
#import <appkit/appkit.h>
#import <sys/time.h>
#import "BibTeXObject.h"

@interface BibliographicFile:Object
{
	char		*theBuffer;	//buffer of the stream
	int			fLength;	//length of file
	int			length, maxLength;	// size of the buffer
	char		*myName;
	char		*changeFileName;
	FILE		*changeFilePointer;
	NXStream	*memStream;
	id			theText;
	List		*listOfObjects;
	List		*sortedListOfObjects;
	List		*listOfTypedObjects;
	int			entryCountList[100];
	int			lastSearchPos;
	int			report;
	int			uTime;
	int			sTime;
	time_t		lastModified;
	int			headerLength;
	BOOL		isDirty;
	BOOL		isNewFile;

}

+ (BOOL) canLoadFromFile:(const char *)fName;
+ (char **) fileTypes;
- (BOOL)fileStatus;
- (int)uTime;
- (int)sTime;
- (int)insertBibObject:(BibTeXObject*)theObject;
- parsingReport:(int)msg;
- (int)countForType:(int)theType;
- (List *)listOfBibObjects;
- (List *)listOfSortedBibObjects;
- (List *)listForType:(int)theType sorted:(BOOL)sort;
- initNewFile:(const char *)fName;
- initFromFile:(const char *)fName;
- changeFilenameTo:(const char *)newName;
- (char *)fullPath;
- (char *)fileName;
- (int) fileSize;
- (int) entries;
- objectAt:(unsigned int)index;
- (NXStream	*)stream;
- (int)lastModified;
- objectAtCharpos:(int)pos andSelectInMatrix:matrix;
- showFile;
- findKey:(const char *)theKey;
- free;
- (int) save;
- setDirty;
- (BOOL)isDirty;
- (BOOL)isNewFile;
- (void) addBibObject:(BibTeXObject*)obj;
- (void) deleteBibObject:(BibTeXObject*)obj;
- (void) changeKeyOfBibObject:(BibTeXObject*)obj;
- (void) changeTypeOfBibObject:(BibTeXObject*)obj from:(int)old to:(int)new;
- addObjects:(List *)objList;
- appendNewText:(int)length :(char *)buffer;
- replaceTextOf:(BibTeXObject*)obj with:(char *)buffer length:(int)len;

@end



/***************		category for the List class	***********/

@interface List(exch)

- exchange:(int)i :(int)j;

@end

