
#import <appkit/appkit.h>

@class	BrowserController;
@class	TeXClass;
@class	Preferences;
@class	BibTexObject;
@class	BibTexView;
@class	DragView;
@class	BibliographicFile;
@class	Shelf;


#define BIBTEST		NO

/********	class hierarchy of this Application:

					Object
					  |
			-------------------------
			|						|
	BibliographicObject		BiblioGraphicFile
			|
		BibTexParser
			|
		BibTeXObject

*************/

#define	X	origin.x
#define	Y	origin.y
#define	W	size.width
#define	H	size.height


/********		tags of menu cells		***********/

//		Document
#define	DOCUMENT	2
#define	OPEN		21
#define	NEW			22
#define	SAVE		23
#define	SAVEAS		24
#define	SAVETO		25
#define	SAVEALL		26
#define	REVERT		27
#define	CLOSE		28

//		File
#define	EDIT		3
#define	CUT			31
#define	COPY		32
#define	COPYCITE	33
#define	PASTE		34
#define	SELECTALL	35
#define	FIND		36

#define	FINDPANEL		361
#define	FINDNEXT		362
#define	FINDPREVIOUS	363
#define	ENTERSELECTION	364
#define	JUMPTOSELECTION	364

//		LaTeX
#define	PREVIEW		6
#define	PRVWINDOW	61
#define	RUNLATEX	62
#define	RUNRTF		63
#define	RUNHTML		64
#define	PRINT		65


@interface Controller:Object
{
	id	infoPanel;
	id	hostNameText;
	id	procTypeText;
	id	screenTypeText;
	id	screenSizeText;
	id	versionText;

	id	browserController;
	Shelf	*shelfController;
	id	bibWindow;
	OpenPanel	*openPanel;
	List *listOfFiles;
	NXBrowser	*litBrowser;
	id	entryDragBox;
	id	entryDragButton;
	id	newEntryButton;
	id	fileDragBox;
	id	findButton;
	id	findObject;
	id	preViewButton;
	id	preViewPushDown;
	BibTexView	*inspector;
	id	betweenButton;
	id	saveAccessoryView;

	TeXClass	*texObject;
	id	deleteButton;
	id	bufferedButton;

	BibTexObject		*lastMainObject;
	BibliographicFile	*lastMainFile;

	id	iconScrollView;

	Preferences	*preferences;
	id	fileNameText;
	id	fileOnShelfText;
	id	fileSizeText;
	id	fileTimeText;
	id	numberOfEntriesText;
	
	NXAtom	MyListPboardType;
	BOOL	filenameChanged;
}

- (void) prRect:(const char *)txt :(NXRect)r;

- info:sender;
- suggestion: sender;
- newFile:sender;
- open:sender;
- revertToSaved:sender;
- (void) shelfText:(const char *)txt;
- save:sender;
- saveAs:sender;
- close:sender;
- preferences:sender;
- update:obj for:aFile isNew:(BOOL)q shiftLit:(BOOL)sl;
- objectForFileNamed:(const char *)fName;
- listOfFiles;
- selectedFile;
- (void)colZeroIsFilled;
- (BOOL) openFile:(const char *)fullName;
- LaTeXFromList:(List *)aList tag:(int)tag;
- LaTeX:sender;
- HTML:sender;
- printDvi:sender;
- showPanel:sender;
- (void)P:sender;
- (void)V:sender;
- browserDidChange:sender;
- (int)semaphore:sender;
- deleteEntry:sender;
- newEntry:sender;
- copyCitation:sender;
- (int) entryDragMethod;
- enterSelectionFor:responder;
- setBacking:sender;
- theShelf;
- (void) getFrameOfFileIcon:(NXRect *)frame;
- (BrowserController *)browserController;
- (DragView *)fileDragView;
- (TeXClass *)texObject;
- macro:sender;

- showReadme:sender;
- showUsage:sender;

- window2eps:sender;

@end


/***************		category for the Text class		***********/

@interface Text(printf)

- (void) addText:(char *)theText;
- (void) clearText;
- (void) clearAndWriteText:(char *)theText;
- (void) printf:(const char *)format, ...;

@end




/***************		category for the PopUpList class	***********/

@interface PopUpList(sizeTheButton)

- sizeButton:button;

@end



