/* One big struct that contains variables local to a specific document
 * Currently switching contexts involves copying this infomation into
 * the global variables with the corresponding name
 */

typedef struct dvicontext {
TeXfontdesctype *TeXfonts[256] ;     /* font pointers */
TeXfontdesctype *TeXfontlist ;
fontdesctype *fontlist ;      /* list of resident fonts */
int curid ;
Boolean landscape ;              /* are we in landscape? */
FILE *dvifile  ;             /* files for input and output */
char Tbasename[2000], oldbasename[2000] ;
char LastFormat[2000], CustomFormat[2000] ;
integer curpos ;                     /* dvi file position */
integer thispage ;                   /* where this page is */
integer rthispage ;
integer prevpage ;                   /* previous page */
integer pagenum, seq ;               /* page number */
real conv, pxlconv ;                 /* to pixel conversion factors */
integer iconv ;                      /* integer to pixel conversion factor */
real vconv ;                         /* these are for the half mode */
integer viconv ;
real alpha ;                  /* conversion ratio, DVI unit per TFM unit */
integer mag ;                 /* the magnification of this document */
real screendpi ;             /* current screen resolution */
shalfword hh, vv ;                   /* current pixel position */
shalfword fnt ;                      /* current font (0-255) */
fontdesctype *curfnt ;               /* current font (pointer) */
frametype frames[MAXFRAME] ;         /* stack for virtual fonts */
quarterword *virpos ;         /* current position in virtual character packet */
quarterword *virlim ;         /* final byte in virtual character packet */
fontmaptype *ffont ;          /* first font in current frame */
shalfword hhoffset, vvoffset ;       /* the horizontal and vertical off */
shalfword hhmin, hhmax, vvmin, vvmax ; /* the borders of the screen */
real hsize , vsize, hmarg, vmarg ;
                                     /* the page and margin size */
shalfword hhsize, vvsize, hhmarg, vvmarg ;
shalfword rhhsize, rvvsize, rhhmarg, rvvmarg ;
shalfword hbody, vbody, hpos, vpos ;
integer hpot, vpot ;
shalfword vscreen  ;            /* screen size vertical */
shalfword vwindow, vwindowheight, hwindow, hwindowwidth ;
integer dvimag, num, den ;           /* sizes from dvi file */
integer memalloc ;
integer numalloc ;
Boolean pageinterrupted ;
integer messagebit ;                 /* the bit to wait for on IDCMP */
Boolean borderson ;
Boolean dualpage ;
Boolean orientationset ;
Boolean reopenscreen ;
shalfword vscreenheight ;
Boolean interlaceon  ;
int first ;
int x, y ;
int tracking ;
Boolean zoomed ;
Boolean mocked ;
char realname[400] ;
char safebuf[400], filenamebuf[400] ;
int redrawbars ;
int turnitoff ;
int nloc ;
integer spage, sno ;
Boolean redrawpage ;
int rowsize, colsize ;
Boolean autofront, autoactivate ;
int actualdpi  ;
struct pagetype *pages ;
struct pagetype *last ;
struct pagetype *currentpage ;
int ht_highlight ;
int ht_last_page ;
int last_pagenum ;
int lasthh ;
int lastvv ;
int last_thing ;
char *last_string ;

} DviContext ;