#   include	<stdio.h>
#   include	<stdlib.h>
#   include	<stddef.h>
#   include	<string.h>

#   include	<ind.h>

#   include	"spelling.h"

/************************************************************************/
/*  Lees de woordenlijst en schrijf een file met alle mogelijke		*/
/*  nederlandse vormen.							*/
/*  Per vorm is de woordsoort en de manier waarop de vorm is afgeleid	*/
/*  aangegeven.								*/
/************************************************************************/

#   define	REGLEN	250

static int	nlWoordenboek( char * naam, void * ind, void * indvreemd )
    {
    FILE *	woordenboek;
    char	regel[REGLEN+1];
    Lemma	hetLemma;
    int		nummer= 0;

    woordenboek= fopen( naam, "r" );
    if  ( ! woordenboek )
	{
	fprintf( stderr, "Kan woordenboek %s niet openen\n", naam );
	return -1;
	}

    while( fgets( regel, REGLEN, woordenboek ) == regel )
	{
	nlSplitLemma( regel, &hetLemma );

	if  ( nlMaak( ind, &hetLemma, 0, indvreemd ) )
	    {
	    fprintf( stderr, "Woordenboek %s, Lemma %d: '%s' fout\n",
			naam, nummer, hetLemma.lm_vorm1 );
	    fclose( woordenboek );
	    return -1;
	    }
	nummer++;
	}

    fclose( woordenboek );
    return 0;
    }

int main( argc, argv )
int	argc;
char **	argv;
    {
    void *	ind= indMake();
    void *	indmini;

    if  ( nlTelGener( ind, (void *)0 ) )
	{ fprintf( stderr, "Telwoorden\n" ); return 1;	}

    if  ( nlWoordenboek( "groen", ind, (void *)0 ) )
	{ return 1;	}

    if  ( nlWoordenboek( "groen.meer", ind, (void *)0 ) )
	{ return 1;	}

    indmini= indMini( ind );
    if  ( ! indmini )
	{ fprintf( stderr, "Kan index niet comprimeren\n" ); return 1;	}

    indFree( ind );
    ind= (void *)0;

    if  ( indmini )
	{
	ind= indRenumber( indmini );

	if  ( ! ind )
	    { fprintf( stderr, "Kan index niet hernummeren\n" ); return 1; }
	indFree( indmini );
	}

    if  ( ind )
	{
	if  ( indWrite( ind, "Dutch.ind" ) )
	    { fprintf( stderr, "Kan index niet schrijven\n" ); return 1; }
	indFree( ind );
	}

    return 0;
    }
