#   include	<stdio.h>
#   include	<stdlib.h>
#   include	<stddef.h>
#   include	<string.h>
#   include	<ctype.h>
#   include	<charnames.h>

#   include	"spelling.h"

/************************************************************************/
/*  Bijvoegelijke naamwoorden.						*/
/*  nlAdjBuig:	verbogen vorm.						*/
/************************************************************************/
int	nlAdjBuig( Lemma * plemma, unsigned char * buf )
    {
    /****************************/
    /*  gegeven?		*/
    /****************************/
    if  ( plemma->lm_vorm2 )
	{
	if  ( ! strcmp( plemma->lm_vorm2, "-" ) )
	    { return 1;	}
	nlSpelCpy( buf, plemma->lm_vorm2 ); return 0;
	}

    if  ( plemma->lm_hoeveelheids )
	{ return 1;	}

    if  ( nlUitgang( plemma->lm_vorm1, strlen( plemma->lm_vorm1 ),
							    "en", 2, 0 ) )
	{ return 1;	}

    return nlAdjBuigVorm( plemma->lm_vorm1, buf );
    }

int	nlAdjBuigVorm( vorm1, buf )
const unsigned char *	vorm1;
unsigned char *		buf;
    {
    int		vorml= strlen( vorm1 );
    int		bufl;

    if  ( nlUitgang( vorm1, strlen( vorm1 ), "en", 2, 0 ) )
	{ return 1;	}

    /********************************************/
    /*  onveranderd: ANS 6.4.1.1.1 p 322	*/
    /********************************************/
    if  ( nlUitgang( vorm1, vorml, "a",   1,  0	)	||
	  nlUitgang( vorm1, vorml, "o",   1,  0	)	||
	  nlUitgang( vorm1, vorml, "e",   1, -1	)	||
	  nlUitgang( vorm1, vorml, "i",   1,  0	)	||
	  nlUitgang( vorm1, vorml, "y",   1,  0	)	||
	  nlUitgang( vorm1, vorml, "de",  2, -1	)	||
	  nlUitgang( vorm1, vorml, "ste", 3, -1	)	)
	{ nlSpelCpy( buf, vorm1 ); return 0;	}

    nlSpelCpy( buf, vorm1 );
    bufl= strlen( buf );

    /********************************************/
    /*  ANS 6.4.1.1.ii.B p 324			*/
    /********************************************/
    if  ( buf[bufl-1] == 's' && bufl >= 3 )
	{
	if  ( ! strncmp( vorm1+ vorml- 3, "ee", 2 )	)
	    { buf[bufl-2]= 's'; buf[bufl-1]= 'e'; return 0; }
	if  ( ! strncmp( vorm1+ vorml- 3, "aa", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "oo", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "uu", 2 )	)
	    { buf[bufl-2]= 'z'; buf[bufl-1]= 'e'; return 0; }
	if  ( ! strncmp( vorm1+ vorml- 3, "oe", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "eu", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "ie", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "ij", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "ei", 2 )	)
	    { buf[bufl-1]= 'z'; buf[bufl]= 'e'; buf[bufl+1]= '\0'; return 0; }
	}
    if  ( buf[bufl-1] == 'f' && bufl >= 3 )
	{
	if  ( ! strncmp( vorm1+ vorml- 3, "aa", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "ee", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "oo", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "uu", 2 )	)
	    { buf[bufl-2]= 'v'; buf[bufl-1]= 'e'; return 0; }
	if  ( ! strncmp( vorm1+ vorml- 3, "oe", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "ie", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "ij", 2 )	||
	      ! strncmp( vorm1+ vorml- 3, "ei", 2 )	)
	    { buf[bufl-1]= 'v'; buf[bufl]= 'e'; buf[bufl+1]= '\0'; return 0; }
	}

    if  ( ! strncmp( vorm1+ vorml- 3, "ee", 2 )	)
	{
	/* controversiele */
	if  ( bufl > 3 && buf[bufl-4] == 'i' )
	    { buf[bufl-3]= ISO_edieresis;	}
	buf[bufl-2]= buf[bufl-1]; buf[bufl-1]= 'e'; return 0;
	}

    if  ( ! strncmp( vorm1+ vorml- 3, "aa", 2 )	||
	  ! strncmp( vorm1+ vorml- 3, "oo", 2 )	||
	  ! strncmp( vorm1+ vorml- 3, "uu", 2 )	)
	{ buf[bufl-2]= buf[bufl-1]; buf[bufl-1]= 'e'; return 0; }

    if  ( bufl >= 3						&&
	  ! nlKlinker( buf[bufl-1] )				&&
	    nlKlinker( buf[bufl-2] ) && buf[bufl-2] != 'y'	&&
	  ! nlKlinker( buf[bufl-3] )				&&
	  ! nlUitgang( vorm1, vorml, "uw",   2,  -1	)	&&
	  ! nlUitgang( vorm1, vorml, "ig",   2,  -1	)	&&
	  ! nlUitgang( vorm1, vorml, "el",   2,  -1	)	&&
	  ! nlUitgang( vorm1, vorml, "er",   2,  -1	)	&&
	  ! nlUitgang( vorm1, vorml, "ij",   2,   0	)	&&
	  ! nlUitgang( vorm1, vorml, "em",   2,  -1	)	&&
	  ! nlUitgang( vorm1, vorml, "en",   2,  -1	)	)
	{
	buf[bufl]= buf[bufl-1];
	buf[bufl+1]= 'e'; buf[bufl+2]= '\0';
	return 0;
	}

    if  ( bufl == 2			&&
	  ! nlKlinker( buf[bufl-1] )	&&
	    nlKlinker( buf[bufl-2] )	)
	{
	buf[bufl-1]= buf[bufl-1];
	buf[bufl+1]= 'e'; buf[bufl+2]= '\0';
	return 0;
	}

    buf[bufl]= 'e'; buf[bufl+1]= '\0';

    return 0;
    }

int	nlAdjBuigPlur( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlAdjBuig( plemma, buf ) )
	{
	int	l= strlen( buf );

	if  ( l >= 6 && ! strcmp( buf+ l- 5, "aanse" ) )
	    { strcpy( buf+ l, "n" ); return 0;	}

	if  ( l >= 3 && ! strcmp( buf+ l- 2, "se" ) )
	    {
	    /*
	    printf( "%s(%d): '%s'\n", __FILE__, __LINE__, buf );
	    strcpy( buf+ l- 2, "zen" );
	    return 0;
	    */
	    }

	strcpy( buf+ l, "n" ); return 0;
	}

    return 1;
    }

/************************************************************************/
/*  Bijvoegelijke naamwoorden.						*/
/*  nlAdjComp, nlAdjCompE:	vergelijkende trap en de verbogen vorm.	*/
/************************************************************************/
int	nlAdjComp( Lemma * plemma, unsigned char * buf )
    {
    int	l;

    /****************************/
    /*  gegeven?		*/
    /****************************/
    if  ( plemma->lm_vorm3 )
	{
	if  ( ! strcmp( plemma->lm_vorm3, "-" ) )
	    { return 1;	}
	nlSpelCpy( buf, plemma->lm_vorm3 ); return 0;
	}

    if  ( plemma->lm_hoeveelheids )
	{ return 1;	}

    l= strlen( plemma->lm_vorm1 );

    if  ( nlUitgang( plemma->lm_vorm1, l, "en", 2, 0 ) )
	{ return 1;	}

    if  ( nlUitgang( plemma->lm_vorm1, l, "er",   2,  -1	)	||
	  nlUitgang( plemma->lm_vorm1, l, "baar", 4,  -1	)	)
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	strcat( buf, "der" );
	return 0;
	}

    if  ( ! nlAdjBuig( plemma, buf ) )
	{ strcat( buf, "r" ); return 0;	}

    return 1;
    }

int	nlAdjCompE( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlAdjComp( plemma, buf ) )
	{ strcat( buf, "e" ); return 0;	}

    return 1;
    }

int	nlAdjCompEN( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlAdjCompE( plemma, buf ) )
	{ strcat( buf, "n" ); return 0;	}

    return 1;
    }

/************************************************************************/
/*  Bijvoegelijke naamwoorden.						*/
/*  nlAdjSuper, nlAdjSuperE:	overtreffende trap en de verbogen vorm.	*/
/************************************************************************/
int	nlAdjSuper( Lemma * plemma, unsigned char * buf )
    {
    int	l;

    /****************************/
    /*  gegeven?		*/
    /****************************/
    if  ( plemma->lm_vorm4 )
	{
	if  ( ! strcmp( plemma->lm_vorm4, "-" ) )
	    { return 1;	}
	nlSpelCpy( buf, plemma->lm_vorm4 ); return 0;
	}

    if  ( plemma->lm_hoeveelheids )
	{ return 1;	}

    if  ( nlUitgang( plemma->lm_vorm1, strlen( plemma->lm_vorm1 ),
							    "en", 2, 0 ) )
	{ return 1;	}

    nlSpelCpy( buf, plemma->lm_vorm1 );
    l= strlen( buf );
    if  ( buf[l-1] == 's' )
	{ strcpy( buf+ l, "t" );	}
    else{ strcpy( buf+ l, "st" );	}

    return 0;
    }

int	nlAdjSuperE( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlAdjSuper( plemma, buf ) )
	{ strcat( buf, "e" ); return 0;	}

    return 1;
    }

int nlAdjAllerSuper( Lemma * plemma, unsigned char * buf )
    {
    int	rval;

    if  ( plemma->lm_hoeveelheids )
	{ return 1;	}

    strcpy( buf, "aller" );
    rval= nlAdjSuper( plemma, buf+ 5 );
    if  ( rval )
	{ return rval;	}

    if  ( ISO_isupper( buf[5] ) )
	{ buf[5]= ISO_tolower( buf[5] );	}

    return 0;
    }

int nlAdjAllerSuperE( Lemma * plemma, unsigned char * buf )
    {
    int	rval;

    if  ( plemma->lm_hoeveelheids )
	{ return 1;	}

    strcpy( buf, "aller" );
    rval= nlAdjSuperE( plemma, buf+ 5 );
    if  ( rval )
	{ return rval;	}

    if  ( ISO_isupper( buf[5] ) )
	{ buf[5]= ISO_tolower( buf[5] );	}

    return 0;
    }

int nlAdjAllerSuperEN( Lemma * plemma, unsigned char * buf )
    {
    int	rval;

    if  ( plemma->lm_hoeveelheids )
	{ return 1;	}

    strcpy( buf, "aller" );
    rval= nlAdjSuperEN( plemma, buf+ 5 );
    if  ( rval )
	{ return rval;	}

    if  ( ISO_isupper( buf[5] ) )
	{ buf[5]= ISO_tolower( buf[5] );	}

    return 0;
    }

int	nlAdjSuperEN( Lemma * plemma, unsigned char * buf )
    {
    if  ( plemma->lm_hoeveelheids )
	{ return 1;	}

    if  ( ! nlAdjSuper( plemma, buf ) )
	{ strcat( buf, "en" ); return 0;	}

    return 1;
    }

/************************************************************************/
/*  Bijvoegelijke naamwoorden.						*/
/*  'rood' -> 'iets roods'.						*/
/*  ANS 6.4.2.1 p 331.							*/
/************************************************************************/
int	nlAdjSubst( Lemma * plemma, unsigned char * buf )
    {
    int	l;

    if  ( plemma->lm_hoeveelheids )
	{ return 1;	}

    if  ( nlUitgang( plemma->lm_vorm1, strlen( plemma->lm_vorm1 ),
								"en", 2, 0 ) )
	{ return 1;	}

    nlSpelCpy( buf, plemma->lm_vorm1 );

    l= strlen( buf );
    if  ( buf[l-1] == 's' )
	{ return 0;	}
    if  ( buf[l-1] == 'x' )
	{ return 0;	}
    if  ( l > 4 && ! strcmp( buf+ ( l- 4 ), "isch" ) )
	{ return 0;	}

    strcat( buf, "s" );

    return 0;
    }

int	nlAdjCompSubst( Lemma * plemma, unsigned char * buf )

    {
    if  ( ! nlAdjComp( plemma, buf ) )
	{ strcat( buf, "s" ); return 0;	}

    return 1;
    }

