#   include	<stdio.h>
#   include	<stdlib.h>
#   include	<stddef.h>
#   include	<string.h>

#   include	<morpho.h>
#   include	"spelling.h"

static char * nlPersoon( persoon )
int	persoon;
    {
    static char nix[10];

    switch( persoon )
	{
	case	SING_1:		return "1e persoon enkelvoud";
	case	SING_2:		return "2e persoon enkelvoud";
	case	SING_3:		return "3e persoon enkelvoud";
	case	PLUR_1:		return "1e persoon meervoud";
	case	PLUR_2:		return "2e persoon meervoud";
	case	PLUR_3:		return "3e persoon meervoud";
	}

    sprintf( nix, "%d", persoon );
    return nix;
    }

static char * nlWijs( wijs )
int	wijs;
    {
    static char nix[10];

    switch( wijs )
	{
	case	INF:		return "Infinitief";
	case	IND:		return "Indicatief";
	case	CONJUNCTIEF:	return "Aanvoegende wijs";
	case	IMPERATIEF:	return "Gebiedende wijs";
	case	TEGDEEL:	return "Tegenwoordig Deelwoord";
	case	VERLDEEL:	return "Verleden Deelwoord";
	}

    sprintf( nix, "%d", wijs );
    return nix;
    }

static char * nlTijd( tijd )
int	tijd;
    {
    static char nix[10];

    switch( tijd )
	{
	case	PRES:		return "Tegenwoordige tijd";
	case	IMPER:		return "Verleden tijd";
	}

    sprintf( nix, "TIJD %d", tijd );
    return nix;
    }

static char * nlVerbogen( verbogen )
int	verbogen;
    {
    static char nix[10];

    switch( verbogen )
	{
	case	1:		return "Wel";
	case	0:		return "Niet";
	}

    sprintf( nix, "%d", verbogen );
    return nix;
    }

static char * nlTrap( trap )
int	trap;
    {
    static char nix[10];

    switch( trap )
	{
	case	POS:	return  "Stellende";
	case	COMP:	return  "Vergelijkende";
	case	SUPER:	return  "Overtreffende";
	}

    sprintf( nix, "%d", trap );
    return nix;
    }

static char * nlSex( sex )
int	sex;
    {
    static char nix[10];

    switch( sex )
	{
	case	SEX_MV:		return "mv.";
	case	SEX_M:		return "m.";
	case	SEX_V:		return "v.";
	case	SEX_O:		return "o.";
	case	SEX_VM:		return "v. (m.)";
	case	SEX_M_V:	return "m. -v.";
	case	SEX_MeO:	return "m. en o.";
	case	SEX_MeV:	return "m. en v.";
	case	SEX_VeM:	return "v. en m.";
	case	SEX_OeV:	return "o. en v.";
	case	SEX_VeO:	return "v. en o.";
	case	SEX_OeM:	return "o. en m.";
	case	SEX_MoO:	return "m. of o.";
	case	SEX_MoV:	return "m. of v.";
	case	SEX_VoO:	return "v. of o.";
	}

    sprintf( nix, "%d", sex );
    return nix;
    }

static char * nlSamen( samen )
int	samen;
    {
    static char nix[10];

    switch( samen )
	{
	case	0:	return "";
	case	1:	return "Onscheidbaar samengesteld";
	case	2:	return "Scheidbaar samengesteld";
	}

    sprintf( nix, "%d", samen );
    return nix;
    }

static char *	nlSoort( soort )
int	soort;
    {
    static char nix[10];

    switch( soort )
	{
	case	TEL:	return "Telwoord";
	case	ADJ:	return "Bijvoegelijk naamwoord";
	case	ADV_C:	return "Verbuigbaar bijwoord";
	case	ADV:	return "Onverbuigbaar bijwoord";
	case	VGW:	return "Voegwoord";
	case	VRZ:	return "Voorzetsel";
	case	LDW:	return "Lidwoord";
	case	INT:	return "Tussenwerpsel";
	case	PRO:	return "Voornaamwoord";
	case	SUB:	return "Zelfstandig naamwoord";
	case	SUB_D:	return "Zelfstandig verkleinwoord";
	case	SUB_P:	return "Plurale Tantum";
	case	VER:	return "Werkwoord";

	case	NAAM:	return "Persoonsnaam";
	case	TOPO:	return "Topografische naam";

	case	VORM:	return "Niet geclassificeerd";
	}

    sprintf( nix, "%d", soort );
    return nix;
    }

void nlLemmaHead( plemma )
Lemma *	plemma;
    {
    char buf[100];
    nlSpelCpy( buf, plemma->lm_vorm1 );
    printf( "######  %s\n", buf );
    }

void nlDrukLemma( plemma )
Lemma *	plemma;
    {
    nlLemmaHead( plemma );

    printf(	"\t%s (%s,%s,%s)\n",
		plemma->lm_vorm1,
		plemma->lm_vorm2?plemma->lm_vorm2:(unsigned char *)"",
		plemma->lm_vorm3?plemma->lm_vorm3:(unsigned char *)"",
		plemma->lm_vorm4?plemma->lm_vorm4:(unsigned char *)""	);

    printf( "\t%s", nlSoort( plemma->lm_soort ) );

    switch( plemma->lm_soort )
	{
	case	ADJ:
	    if  ( plemma->lm_hoeveelheids )
		{ printf( ", hoeveelheidwoord");	}
	    break;
	case	ADV_C:
	case	ADV:
	case	TEL:
	case	VGW:
	case	VRZ:
	case	LDW:
	case	INT:
	case	PRO:
	default:
	    break;
	case	SUB:
	    printf( ": %s",
			    nlSex( plemma->lm_geslacht ) );
	    if  ( plemma->lm_hoeveelheids )
		{ printf( ", hoeveelheidwoord");	}
	    break;
	case	SUB_D:
	case	SUB_P:
	    printf( ": %s", nlSex( plemma->lm_geslacht ) );
	    break;
	case	VER:
	    if  ( plemma->lm_wederkerend )
		{ printf( " wederkerend ");	}
	    else{ printf( " niet wederkerend ");	}
	    printf( " %s", nlSamen( plemma->lm_samen ) );
	    break;
	}

    if  ( plemma->lm_intervoc_d )
	{ printf( " Heeft intervocalische D\n" );	}
    else{ printf( "\n" );				}
    }

void nlDrukDeriv( vorm, plemma, deriv )
unsigned char *	vorm;
Lemma *		plemma;
Deriv *		deriv;
    {
    if  ( vorm )
	{ printf( "%s%s%s\n",	vorm,
				deriv?":\t":"",
				deriv?morstr( deriv->dv_dertype ):"" );	}

    if  ( ! plemma )
	{ printf( "\t GEEN LEMMA\n" ); return; }
    }
