#   include	<stdio.h>
#   include	<stdlib.h>
#   include	<stddef.h>
#   include	<string.h>
#   include	<ctype.h>

#   include	<ind.h>
#   include	<morpho.h>

#   include	"spelling.h"

/************************************************************************/
/*  Onveranderd.							*/
/************************************************************************/
static int	MaakOnveranderd( Lemma * plemma, unsigned char * buf )
    {
    nlSpelCpy( buf, plemma->lm_vorm1 );
    return 0;
    }

/************************************************************************/
/*  Alle mogelijke constructors.					*/
/************************************************************************/
static Derivator	NLafleiders[]=
    {
	    /************************************************************/
	    /*  Telwoord						*/
	    /*	soort	pers	klein	wijs,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	TEL,	-1,	-1,	-1,	-1,	-1, DmoNUMER },
	    MaakOnveranderd
	},
	{
	    {	TEL,	-1,	-1,	-1,	-1,	-1, DmoNUMER_DER_S },
	    nlTelBuigS
	},
	{
	    {	TEL,	-1,	-1,	-1,	-1,	-1, DmoNUMER_DER_P },
	    nlTelBuigP
	},
	    /************************************************************/
	    /*  Bijwoord						*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	ADV_C,	-1,	-1,	POS,	-1,	0, DmoADVER	},
	    MaakOnveranderd
	},
	{
	    {	ADV,	-1,	-1,	-1,	-1,	-1, DmoADVER	},
	    MaakOnveranderd
	},
	{
	    {	ADV_C,	-1,	-1,	COMP,	-1,	0, DmoADVER_COMP },
	    nlAdvComp
	},
	{
	    {	ADV_C,	-1,	-1,	SUPER,	-1,	0, DmoADVER_SUPER },
	    nlAdvSuper
	},
	    /************************************************************/
	    /*  Voegwoord						*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	VGW, -1,	-1,	-1,	-1,	-1, DmoCONJUN	},
	    MaakOnveranderd
	},
	    /************************************************************/
	    /*  Voorzetsel						*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	VRZ,	-1,	-1,	-1,	-1,	-1, DmoPREPOS	},
	    MaakOnveranderd
	},
	    /************************************************************/
	    /*  Lidwoord						*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	LDW,	-1,	-1,	-1,	-1,	-1, DmoARTICLE	},
	    MaakOnveranderd
	},
	    /************************************************************/
	    /*  Tussenwerpsel						*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	INT,	-1,	-1,	-1,	-1,	-1, DmoINTERJ	},
	    MaakOnveranderd
	},
	    /************************************************************/
	    /*  Voornaamwoord						*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	PRO,	-1,	-1,	-1,	-1,	0, DmoPRONOMEN	},
	    MaakOnveranderd
	},
	{
	    {	PRO,	-1,	-1,	-1,	-1,	1, DmoPRONOMENe	},
	    nlProBuig1
	},
	{
	    {	PRO,	-1,	-1,	-1,	-1,	1, DmoPRONOMENPOSe },
	    nlProBuig2
	},
	    /************************************************************/
	    /*  Zelfstandig Naamwoord.					*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	SUB,	SING_3,	0,	-1,	-1,	-1, DmoSUBST	},
	    MaakOnveranderd
	},
	{
	    {	SUB_D,	SING_3,	0,	-1,	-1,	-1, DmoSUBST	},
	    MaakOnveranderd
	},
	{
	    {	SUB_P,	SING_3,	0,	-1,	-1,	-1, DmoSUBST	},
	    MaakOnveranderd
	},
	{
	    {	SUB_C, SING_3, 0,	-1,	-1,	-1, DmoCOLLECT	},
	    MaakOnveranderd
	},
	{
	    {	SUB,	PLUR_3,	0,	-1,	-1,	-1, DmoSUBPLUR },
	    nlSubPlur
	},
	{
	    {	SUB_D,	PLUR_3,	0,	-1,	-1,	-1, DmoSUBPLUR	},
	    nlSubPlur
	},
	{
	    {	SUB,	SING_3,	1,	-1,	-1,	-1, DmoDIMSING	},
	    nlSubDimSing1
	},
	{
	    {	SUB,	SING_3,	1,	-1,	-1,	-1, DmoDIMSING	},
	    nlSubDimSing2
	},
	{
	    {	SUB,	PLUR_3,	1,	-1,	-1,	-1, DmoDIMPLUR	},
	    nlSubDimPlur1
	},
	{
	    {	SUB,	PLUR_3,	1,	-1,	-1,	-1, DmoDIMPLUR	},
	    nlSubDimPlur2
	},
	    /************************************************************/
	    /*  Bijvoegelijk Naamwoord.					*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	ADJ,	-1,	-1,	POS,	-1,	0, DmoADJ	},
	    MaakOnveranderd
	},
	{
	    {	ADJ,	-1,	-1,	POS,	-1,	1, DmoADJe	},
	    nlAdjBuig
	},
	{
	    {	ADJ,	-1,	-1,	COMP,	-1,	0, DmoCOMP	},
	    nlAdjComp
	},
	{
	    {	ADJ,	-1,	-1,	SUPER,	-1,	0, DmoSUPER	},
	    nlAdjSuper
	},
	{
	    {	ADJ,	-1,	-1,	COMP,	-1,	1, DmoCOMPe	},
	    nlAdjCompE
	},
	{
	    {	ADJ,	-1,	-1,	COMP,	-1,	1, DmoCOMPen	},
	    nlAdjCompEN
	},
	{
	    {	ADJ,	-1,	-1,	SUPER,	-1,	1, DmoSUPERe	},
	    nlAdjSuperE
	},
	{
	    {	ADJ,	-1,	-1,	SUPER,	-1,	1, DmoSUPERen	},
	    nlAdjSuperEN
	},
	{
	    {	ADJ,	-1,	-1,	SUPER,	-1,	1, DmoALLER_SUPER },
	    nlAdjAllerSuper
	},
	{
	    {	ADJ,	-1,	-1,	SUPER,	-1,	1, DmoALLER_SUPERe },
	    nlAdjAllerSuperE
	},
	{
	    {	ADJ,	-1,	-1,	-1,	-1,	1, DmoADJSUBST	},
	    nlAdjSubst
	},
	{
	    {	ADJ,	-1,	-1,	-1,	-1,	1, DmoCOMPSUBST	},
	    nlAdjCompSubst
	},
	{
	    {	ADJ,	-1,	-1,	-1,	-1,	1, DmoADJeSUBST	},
	    nlAdjBuig
	},
	{
	    {	ADJ,	-1,	-1,	-1,	-1,	1, DmoADJeSUBSTPLUR },
	    nlAdjBuigPlur
	},
	    /************************************************************/
	    /*  Werkwoord						*/
	    /*	soort	pers	klein	wijs,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	VER,	-1,	-1,	INF,	-1,	-1, DmoINFINIT	},
	    MaakOnveranderd
	},
	/*  presens */
	{
	    {	VER,	SING_1,	-1,	IND,	PRES,	-1, DmoINDPRESSING1 },
	    nlVerPresS1
	},
	{
	    {	VER,	SING_2,	-1,	IND,	PRES,	-1, DmoINDPRESSING2 },
	    nlVerPresS2
	},
	{
	    {	VER,	SING_2,	-1,	IND,	PRES,	-1, DmoINDPRESSING2nl },
	    nlVerPresS2nl
	},
	{
	    {	VER,	SING_3,	-1,	IND,	PRES,	-1, DmoINDPRESSING3 },
	    nlVerPresS3
	},
	{
	    {	VER,	PLUR_1,	-1,	IND,	PRES,	-1, DmoINDPRESPLUR1 },
	    nlVerPresP123
	},
	{
	    {	VER,	PLUR_2,	-1,	IND,	PRES,	-1, DmoINDPRESPLUR2 },
	    nlVerPresP123
	},
	{
	    {	VER,	PLUR_3,	-1,	IND,	PRES,	-1, DmoINDPRESPLUR3 },
	    nlVerPresP123
	},
	/*  presens, gescheiden vorm  */
	{
	    {	VER,	SING_1,	-1,	IND,	PRES,	-1, DmoINDPRESSING1s },
	    nlVerPresS1s
	},
	{
	    {	VER,	SING_2,	-1,	IND,	PRES,	-1, DmoINDPRESSING2s },
	    nlVerPresS2s
	},
	{
	    {	VER,	SING_2,	-1,	IND,	PRES, -1, DmoINDPRESSING2nls },
	    nlVerPresS1s
	},
	{
	    {	VER,	SING_3,	-1,	IND,	PRES,	-1, DmoINDPRESSING3s },
	    nlVerPresS3s
	},
	{
	    {	VER,	PLUR_1,	-1,	IND,	PRES,	-1, DmoINDPRESPLUR1s },
	    nlVerPresP123s
	},
	{
	    {	VER,	PLUR_2,	-1,	IND,	PRES,	-1, DmoINDPRESPLUR2s },
	    nlVerPresP123s
	},
	{
	    {	VER,	PLUR_3,	-1,	IND,	PRES,	-1, DmoINDPRESPLUR3s },
	    nlVerPresP123s
	},
	/*  imperfect */
	{
	    {	VER,	SING_1,	-1,	IND,	IMPER,	-1, DmoINDIMPERSING1 },
	    nlVerImperS123
	},
	{
	    {	VER,	SING_2,	-1,	IND,	IMPER,	-1, DmoINDIMPERSING2 },
	    nlVerImperS123
	},
	{
	    {	VER,	SING_3,	-1,	IND,	IMPER,	-1, DmoINDIMPERSING3 },
	    nlVerImperS123
	},
	{
	    {	VER,	PLUR_1,	-1,	IND,	IMPER,	-1, DmoINDIMPERPLUR1 },
	    nlVerImperP123
	},
	{
	    {	VER,	PLUR_2,	-1,	IND,	IMPER,	-1, DmoINDIMPERPLUR2 },
	    nlVerImperP123
	},
	{
	    {	VER,	PLUR_3,	-1,	IND,	IMPER,	-1, DmoINDIMPERPLUR3 },
	    nlVerImperP123
	},
	/*  imperfect, gescheiden vorm */
	{
	    {	VER,	SING_1,	-1,	IND,	IMPER,	-1, DmoINDIMPERSING1s },
	    nlVerImperS123s
	},
	{
	    {	VER,	SING_2,	-1,	IND,	IMPER,	-1, DmoINDIMPERSING2s },
	    nlVerImperS123s
	},
	{
	    {	VER,	SING_3,	-1,	IND,	IMPER,	-1, DmoINDIMPERSING3s },
	    nlVerImperS123s
	},
	{
	    {	VER,	PLUR_1,	-1,	IND,	IMPER,	-1, DmoINDIMPERPLUR1s },
	    nlVerImperP123s
	},
	{
	    {	VER,	PLUR_2,	-1,	IND,	IMPER,	-1, DmoINDIMPERPLUR2s },
	    nlVerImperP123s
	},
	{
	    {	VER,	PLUR_3,	-1,	IND,	IMPER,	-1, DmoINDIMPERPLUR3s },
	    nlVerImperP123s
	},
	/*  verleden deelw */
	{
	    {	VER,	-1,	-1,	VERLDEEL, -1,	0, DmoPARTPAS	},
	    nlVerPartPas
	},
	{
	    {	VER,	-1,	-1,	VERLDEEL, -1,	1, DmoPARTPASe	},
	    nlVerPartPasE
	},
	{
	    {	VER,	-1,	-1,	VERLDEEL, -1,	1, DmoPARTPASen	},
	    nlVerPartPasEN
	},
	/*  tegenwoordig deelw */
	{
	    {	VER,	-1,	-1,	TEGDEEL, -1,	0, DmoPARTPRES	},
	    nlVerPartPres
	},
	{
	    {	VER,	-1,	-1,	TEGDEEL, -1,	1, DmoPARTPRESe	},
	    nlVerPartPresE
	},
	{
	    {	VER,	-1,	-1,	TEGDEEL, -1,	1, DmoPARTPRESen },
	    nlVerPartPresEN
	},
	{
	    {	VER,	-1,	-1,	-1,	 -1,	1, DmoCOMPPREF	},
	    nlVerCompPref
	},
	{
	    {	VER,	-1,	-1,	-1,	 -1,	1, DmoGEINF	},
	    nlVerGeStam
	},
	    /************************************************************/
	    /*  Persoonsnaam.						*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	NAAM,	SING_3,	0,	-1,	-1,	-1, DmoPERSON	},
	    MaakOnveranderd
	},
	    /************************************************************/
	    /*  Geografische naam.					*/
	    /*	soort	pers	klein	trap,	tijd	verb deriv	*/
	    /************************************************************/
	{
	    {	TOPO,	SING_3,	0,	-1,	-1,	-1, DmoTOPO	},
	    MaakOnveranderd
	},
	    /************************************************************/
	    /*  Moeilijk te classificeren vorm.				*/
	    /************************************************************/
	{
	    {	VORM,	SING_3,	0,	-1,	-1,	-1, DmoWORD	},
	    MaakOnveranderd
	},
    };

int	nlMaak( ind, plemma, toon, indvreemd )
void *	ind;
Lemma *	plemma;
int	toon;
void *	indvreemd;
    {
    int			soort;
    unsigned char	vorm[200];

    for ( soort= 0; soort < sizeof(NLafleiders)/sizeof(Derivator); soort++ )
	{
	if  (    NLafleiders[soort].der_deriv.dv_soort == plemma->lm_soort &&
	      ! (*NLafleiders[soort].der_MaakErEen)( plemma, vorm )	   )
	    {
	    if  ( toon > 1 )
		{ nlDrukDeriv( vorm, plemma, &NLafleiders[soort].der_deriv ); }
	    if  ( toon == 1 )
		{ printf( "%s\n", vorm );	}
	    if  ( ind )
		{
		if  ( nlPut( ind, vorm, 
				    NLafleiders[soort].der_deriv.dv_dertype ) )
		    { printf("put\n"); return -1;	}
		}
	    if  ( indvreemd )
		{
		int accepted;
		if  ( indGet( &accepted, indvreemd, vorm ) >= 0 && accepted )
		    {
		    printf( "############################## %s\n", vorm );
		    nlDrukLemma( plemma );
		    printf( "\n" );
		    }
		}
	    }
	}

    return 0;
    }

int	nlPut( ind, vorm, type )
void *			ind;
const unsigned char *	vorm;
int			type;
    {
    int		tn;

    if  ( ( tn= indPut( ind, vorm ) ) < 0 )
	{ printf("put\n"); return -1;	}
    /*  FUTURE ......
    if  ( indSetItem(   ind, tn, type ) )
	{ printf("item\n"); return -1;	}
    */

    return 0;
    }
