#   include	<stdio.h>
#   include	<stdlib.h>
#   include	<stddef.h>
#   include	<string.h>
#   include	<ctype.h>
#   include	<charnames.h>

#   include	"spelling.h"

/*
printf("%s(%d):%s\n",__FILE__,__LINE__,plemma->lm_vorm1);
*/

/************************************************************************/
/*  Zelfstandige naamwoorden.						*/
/*  nlSubPlur:	Meervoud.						*/
/*  nlSubDimSing[12]:	Verkleinwoord enkelvoud.			*/
/************************************************************************/
int	nlSubPlur( Lemma * plemma, unsigned char * buf )
    {
    int		l= strlen( plemma->lm_vorm1 );

    /****************************/
    /*  gegeven?		*/
    /****************************/
    if  ( plemma->lm_vorm3 )
	{
	nlSpelCpy( buf, plemma->lm_vorm3 );
	return 0;
	}

    /****************************************************/
    /*  Fout in woordenboek. Geldt daar als regelmatig.	*/
    /****************************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "gevoel",  6, 0 ) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	strcpy( buf+ l, "ens" );
	return 0;
	}

    if  ( nlUitgang( plemma->lm_vorm1, l, "s*ie",  4, 0 ) ||
	  nlUitgang( plemma->lm_vorm1, l, "t*ie",  4, 0 ) ||
	  nlUitgang( plemma->lm_vorm1, l, "r*ie",  4, 0 ) ||
	  nlUitgang( plemma->lm_vorm1, l, "m*ie",  4, 0 ) ||
	  nlUitgang( plemma->lm_vorm1, l, "p*ie",  4, 0 ) ||
	  nlUitgang( plemma->lm_vorm1, l, "f*ie",  4, 0 ) ||
	  nlUitgang( plemma->lm_vorm1, l, "g*ie",  4, 0 ) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	buf[l++]= ISO_edieresis; buf[l++]= 'n'; buf[l  ]= '\0';
	return 0;
	}

    /****************************************************/
    /*  pragmaticus .. pragmatici			*/
    /*  narcoticum .. narcotica				*/
    /*  medium .. media					*/
    /****************************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "icus",  4, 0	) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	strcpy( buf+ strlen( buf )- 4, "ici" );
	return 0;
	}
    if  ( nlUitgang( plemma->lm_vorm1, l, "icum",  4, 0	) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	strcpy( buf+ strlen( buf )- 4, "ica" );
	return 0;
	}
    if  ( nlUitgang( plemma->lm_vorm1, l, "ium",  3, 0	) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	strcpy( buf+ strlen( buf )- 3, "ia" );
	return 0;
	}

    /****************************************************/
    /*  op klinker? ANS 2.5.3.2 p 60			*/
    /*  Maar geen tweeklank of 'ee' ANS 2.5.4 p62- 63	*/
    /****************************************************/
    if  ( ! strcmp( plemma->lm_vorm1+ l- 2, "e7" ) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	buf[l++]= 's'; buf[l]= '\0';
	return 0;
	}
    if  ( nlKlinker( plemma->lm_vorm1[l-1] )				&&
          ! nlUitgang( plemma->lm_vorm1, l, "gie",  3, -1	)	&&
          ! nlUitgang( plemma->lm_vorm1, l, "ee",   2, -1	)	&&
          ! nlUitgang( plemma->lm_vorm1, l, "ei",   2, -1	)	&&
          ! nlUitgang( plemma->lm_vorm1, l, "ij",   2, -1	)	&&
          ! nlUitgang( plemma->lm_vorm1, l, "ou",   2, -1	)	&&
          ! nlUitgang( plemma->lm_vorm1, l, "au",   2, -1	)	&&
          ! nlUitgang( plemma->lm_vorm1, l, "eu",   2, -1	)	&&
          ! nlUitgang( plemma->lm_vorm1, l, "ui",   2, -1	)	&&
          ! nlUitgang( plemma->lm_vorm1, l, "ooi",   3, -1	)	)
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	if  ( l > 1				&&
	      ! nlKlinker( buf[l-2] )		&&
	      ( buf[l-1] == 'a'	||
		buf[l-1] == 'o' ||
		buf[l-1] == 'u' )		)
	    { buf[l++]= '\''; buf[l++]= 's'; buf[l]= '\0';	}
	else{ buf[l++]= 's'; buf[l]= '\0';			}
	return 0;
	}

    /************************************/
    /*  uitgangen: ANS 2.5.3.5 p 61	*/
    /************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "el",   2, -1	) ||
          nlUitgang( plemma->lm_vorm1, l, "em",   2, -1	) ||
          nlUitgang( plemma->lm_vorm1, l, "en",   2, -1	) ||
          nlUitgang( plemma->lm_vorm1, l, "er",   2, -1	) ||
          nlUitgang( plemma->lm_vorm1, l, "eyer", 4, -1	) ||
/*        nlUitgang( plemma->lm_vorm1, l, "aar",  3, -1	) ||	*/
          nlUitgang( plemma->lm_vorm1, l, "raar", 4, -1	) ||
          nlUitgang( plemma->lm_vorm1, l, "erd",  3, -1	) ||
          nlUitgang( plemma->lm_vorm1, l, "teur", 4, -1	) ||
					    /*  ^ behalve steur */
          nlUitgang( plemma->lm_vorm1, l, "aard", 4, -1	) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	buf[l++]= 's'; buf[l]= '\0';
	return 0;
	}

    /****************************************************/
    /*  "heid" ANS 2.5.4.B p 65				*/
    /****************************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "heid",   4, 0 ) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	strcpy( buf+ l- 4, "heden" );
	return 0;
	}

    /****************************************************/
    /*  Medeklinker verdubbeling: ANS 2.5.4 p 62	*/
    /****************************************************/
    if  ( l > 1							&&
	  ! nlKlinker( plemma->lm_vorm1[l-1] )			&&
	  plemma->lm_vorm1[l-1] != 'x'				&&
	  plemma->lm_vorm1[l-1] != 'X'				&&
	  nlKlinker( plemma->lm_vorm1[l-2] )			&&
	  ! nlUitgang( plemma->lm_vorm1, l, "uw", 2, 0 )	&&
	  ( l == 2 || ! nlKlinker( plemma->lm_vorm1[l-3] ) )	)
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	if  ( buf[l-1] != 'j' || buf[l-2] != 'i' )
	    { buf[l]= buf[l-1]; l++; }
	buf[l++]= 'e'; buf[l++]= 'n'; buf[l]= '\0';
	return 0;
	}

    /********************************************/
    /*  Openen lettergreep: ANS 2.5.4 p 62	*/
    /********************************************/
    if  ( l >= 3						&&
	  ! nlKlinker( plemma->lm_vorm1[l-1] )			&&
	  nlKlinker( plemma->lm_vorm1[l-2] )			&&
	  plemma->lm_vorm1[l-3] == plemma->lm_vorm1[l-2]	)
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	buf[l-2]= buf[l-1]; l--;
	if  ( buf[l-3] == 'i' && buf[l-2] == 'e' )
	    { buf[l-2]= ISO_edieresis;	}
	if  ( buf[l-1] == 'f' )	{ buf[l-1]= 'v';	}
	if  ( buf[l-1] == 's' )	{ buf[l-1]= 'z';	}
	buf[l++]= 'e'; buf[l++]= 'n'; buf[l]= '\0';
	return 0;
	}

    if  ( nlUitgang( plemma->lm_vorm1, l, "ee",   2, 0	) ||
	  nlUitgang( plemma->lm_vorm1, l, "gie",  3, 0	) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	nlSpelCpy( buf+l, "4en" );
	return 0;
	}

    nlSpelCpy( buf, plemma->lm_vorm1 );
    l= strlen(buf);
    if  ( l < 3					||
	  ( strncmp( buf+ l- 3, "au", 2 )	&&
	    strncmp( buf+ l- 3, "ou", 2 )	)	)
	{
	if  ( buf[l-1] == 'f' )	{ buf[l-1]= 'v';	}

	if  ( buf[l-1] == 's'				&&
	      ( l < 2				||
		    (
		    buf[l-2] != 't'	&&
		    buf[l-2] != 'd'	&&
		    buf[l-2] != 'p'	)	)	)
	    { buf[l-1]= 'z';	}
	}
    buf[l++]= 'e'; buf[l++]= 'n'; buf[l]= '\0';
    return 0;
    }

int	nlSubDimSing1( Lemma * plemma, unsigned char * buf )
    {
    int		l= strlen( plemma->lm_vorm1 );

    /********************/
    /*  gegeven		*/
    /********************/
    if  ( plemma->lm_vorm4 )
	{
	if  ( ! strcmp( plemma->lm_vorm4, "-" ) )
	    { return 1;	}
	nlSpelCpy( buf, plemma->lm_vorm4 );

	/************************/
	/*  fout in lijst	*/
	/************************/
	if  ( ! nlSpelCmp( plemma->lm_vorm1, "blad" ) )
	    {
	    l= strlen( buf );
	    if  ( buf[l-1] == 's' )
		{ buf[l-1]= '\0';	}
	    }
	return 0;
	}

    /****************************************************/
    /*  Fout in woordenboek. Geldt daar als regelmatig.	*/
    /****************************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "gevoel",  6, 0 ) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	strcpy( buf+ l, "entje" );
	return 0;
	}

    /****************************************************/
    /*  Fout in woordenboek. Geldt daar als regelmatig.	*/
    /****************************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "glas",  4, 0 ) ||
	  nlUitgang( plemma->lm_vorm1, l, "gl*as", 5, 0 ) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	strcpy( buf+ l- 2, "aasje" );
	return 0;
	}

    /********************************************/
    /*  Uitgang "ing": ANS 2.6.1.3.2.a p 79.	*/
    /********************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "ing",   3, 0	) )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	strcpy( buf+ l- 3, "inkje" );
	return 0;
	}

    /********************************************/
    /*  Centrum etc hebben geen meervoud hoor.	*/
    /********************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "entrum", 6, 1 ) )
	{ return 1; }

    /********************************************/
    /*  "pje": ANS 2.6.1.3.2.b p 79.		*/
    /********************************************/
    if  ( plemma->lm_vorm1[l-1] == 'm' )
	{
	if  ( nlUitgang( plemma->lm_vorm1, l, "aam",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "eem",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "iem",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "oom",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "uum",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "eim",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "oem",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "uim",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "ium",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "icum",  4, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "aum",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "oum",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "ijm",   3, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "rm",    2, 0	)	||
	      nlUitgang( plemma->lm_vorm1, l, "lm",    2, 0	)	)
	    {
	    nlSpelCpy( buf, plemma->lm_vorm1 );
	    l= strlen(buf);
	    strcpy( buf+ l, "pje" );
	    return 0;
	    }
	}

    /********************************************/
    /*  "tje": ANS 2.6.1.3.2.c p 80. (stomme e)	*/
    /********************************************/
    if  ( nlUitgang( plemma->lm_vorm1, l, "en",   2, -1	)	||
	  nlUitgang( plemma->lm_vorm1, l, "el",   2, -1	)	||
	  nlUitgang( plemma->lm_vorm1, l, "er",   2, -1	)	||
          nlUitgang( plemma->lm_vorm1, l, "eyer", 4, -1	) 	||
	  nlUitgang( plemma->lm_vorm1, l, "ij",   2, -1	)	||
	  nlUitgang( plemma->lm_vorm1, l, "er*ij", 5, -1 )	||
	  nlUitgang( plemma->lm_vorm1, l, "uw",   2, 0	)	||
	  nlUitgang( plemma->lm_vorm1, l, "ew",   2, -1	)	)
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	/********************************/
	/*  Tja, het Nederlands...	*/
	/********************************/
	if  ( ! strcmp( buf+ l- 6, "jongen" ) )
	    { strcpy( buf+ l- 1, "tje" ); }
	else{ strcpy( buf+ l,	 "tje" ); }
	return 0;
	}

    /********************************************/
    /*  "tje": ANS 2.6.1.3.2.c p 80. (andere)	*/
    /********************************************/
    if  ( plemma->lm_vorm1[l-1] == 'n' ||
	  plemma->lm_vorm1[l-1] == 'l' ||
	  plemma->lm_vorm1[l-1] == 'r' ||
	  plemma->lm_vorm1[l-1] == 'w' )
	{
	if  ( ! strncmp( plemma->lm_vorm1+ l- 3, "aa", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "ee", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "ie", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "oo", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "uu", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "ei", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "ui", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "au", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "ou", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "eu", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "oe", 2 )	||
	      ! strncmp( plemma->lm_vorm1+ l- 3, "ij", 2 )	)
	    {
	    nlSpelCpy( buf, plemma->lm_vorm1 );
	    l= strlen(buf);
	    strcpy( buf+ l, "tje" );
	    return 0;
	    }
	}

    if  ( plemma->lm_vorm1[l-1] == 'y' )
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	strcpy( buf+ l, "tje" );
	return 0;
	}

    if  ( nlKlinker( plemma->lm_vorm1[l-1] ) )
	{
	if  ( nlKlinker( plemma->lm_vorm1[l-2] )	||
	      plemma->lm_vorm1[l-1] == 'e'		)
	    {
	    nlSpelCpy( buf, plemma->lm_vorm1 );
	    l= strlen(buf);
	    strcpy( buf+ l, "tje" );
	    return 0;
	    }
	else{
	    nlSpelCpy( buf, plemma->lm_vorm1 );
	    l= strlen(buf);
	    buf[l]= buf[l-1]; l++;
	    strcpy( buf+ l, "tje" );
	    return 0;
	    }
	}

    /****************************************************/
    /*  'etje' ANS 2.6.1.3.ii.1.d (sic) p 80.		*/
    /****************************************************/
    if  ( plemma->lm_vorm1[l-1] == 'm'		||
	  plemma->lm_vorm1[l-1] == 'n'		||
	  plemma->lm_vorm1[l-1] == 'r'		||
	  plemma->lm_vorm1[l-1] == 'l'		)
	{
	/************************************************/
	/*  Uitzonderingen zoals rector			*/
	/************************************************/
	if  ( plemma->lm_vorm3						&&
	      ! strncmp( plemma->lm_vorm1, plemma->lm_vorm3, l )	&&
	      ( ! strcmp( plemma->lm_vorm3+ l, "en" )		||
	        ! strcmp( plemma->lm_vorm3+ l, "s" )		)	)
	    {
	    nlSpelCpy( buf, plemma->lm_vorm1 );
	    l= strlen(buf);
	    strcpy( buf+ l, "tje" );
	    return 0;
	    }

	if  ( l > 1					&&
	      nlKlinker( plemma->lm_vorm1[l-2] )	&&
	      ( l == 2 ||
	        ! nlKlinker( plemma->lm_vorm1[l-3] ) )	)
	    {
	    nlSpelCpy( buf, plemma->lm_vorm1 );
	    l= strlen(buf);
	    buf[l]= buf[l-1];
	    strcpy( buf+ l+ 1, "etje" );
	    return 0;
	    }
	}
    if  ( nlUitgang( plemma->lm_vorm1, l, "ng",   2, -1	)	&&
	  l > 2							&&
	  nlKlinker( plemma->lm_vorm1[l-3] )	&&
	  ( l == 3 ||
	    ! nlKlinker( plemma->lm_vorm1[l-4] ) )	)
	{
	nlSpelCpy( buf, plemma->lm_vorm1 );
	l= strlen(buf);
	strcpy( buf+ l, "etje" );
	return 0;
	}

    /********************************************/
    /*  "je": ANS 2.6.1.3.2.e p 80.		*/
    /********************************************/
    nlSpelCpy( buf, plemma->lm_vorm1 );
    l= strlen(buf);
    strcpy( buf+ l, "je" );
    return 0;
    }

int	nlSubDimSing2( Lemma * plemma, unsigned char * buf )
    {
    /********************/
    /*  gegeven		*/
    /********************/
    if  ( plemma->lm_vorm2 )
	{
	if  ( ! strcmp( plemma->lm_vorm2, "-" ) )
	    { return 1;	}

	nlSpelCpy( buf, plemma->lm_vorm2 );

	return 0;
	}

    return 1;
    }

int	nlSubDimPlur1( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlSubDimSing1( plemma, buf ) )
	{ strcat( buf, "s" ); return 0;	}
    return 1;
    }

int	nlSubDimPlur2( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlSubDimSing2( plemma, buf ) )
	{ strcat( buf, "s" ); return 0;	}
    return 1;
    }
