#   include	<stdio.h>
#   include	<stdlib.h>
#   include	<stddef.h>
#   include	<string.h>
#   include	<ctype.h>

#   include	"spelling.h"
#   include	<charnames.h>
#   include	<morpho.h>
#   include	<ind.h>

/************************************************************************/
/*  Telwoorden.								*/
/************************************************************************/

int	nlTelBuigS( Lemma * plemma, unsigned char * buf )
    {
    nlSpelCpy( buf, plemma->lm_vorm1 );

    if  ( ! strcmp( buf, "ander" )	||
	  ! strcmp( buf, "menig" )	||
	  ! strcmp( buf, "ettelijk" )	)
	{ strcat( buf, "e" ); return 0;	}

    if  ( ! strcmp( buf, "beide" )	)
	{ return 0;	}

    return 1;
    }

int	nlTelBuigP( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlTelBuigS( plemma, buf ) )
	{ strcat( buf, "n" ); return 0;	}

    return 1;
    }

/************************************************************************/
/*  Telwoorden.								*/
/************************************************************************/
#   ifdef __STDC__						/*  {{	*/
    static unsigned char *	nlTelPrint( unsigned char *, int, int, int );
    static int			nlTelPut( void * ind, int number,
					    int jaartal, int type,
					    void * indvreemd );
#   else							/*  }{	*/
    static unsigned char *	nlTelPrint()
    static int			nlTelPut();
#   endif							/*  }}	*/

static unsigned char *	HoofdEenheden[]=
    {
    "nul",
    "een",
    "twee",
    "drie",
    "vier",
    "vijf",
    "zes",
    "zeven",
    "acht",
    "negen",
    "tien",
    "elf",
    "twaalf",
    "dertien",
    "veertien",
    "vijftien",
    "zestien",
    "zeventien",
    "achttien",
    "negentien"
    };


static unsigned char *	HoofdTientallen[]=
    {
	"nul",
	"tien",
	"twintig",
	"dertig",
	"veertig",
	"vijftig",
	"zestig",
	"zeventig",
	"tachtig",
	"negentig",
    };

static unsigned char nlTelEen[]=
	{ ISO_eacute, ISO_eacute, ISO_n, '\0'	};

static unsigned char * nlTelPrint( buf, eenheid, tiental, honderd )
unsigned char *	buf;
int		eenheid;
int		tiental;
int		honderd;
    {
    int		enManier= 0;

    if  ( honderd > 1 )
	{ strcpy( buf, HoofdEenheden[honderd] ); buf += strlen( buf ); }
    if  ( honderd > 0 )
	{ strcpy( buf, "honderd" ); buf += strlen( buf ); }

    if  ( tiental == 0 )
	{
	if  ( eenheid > 0 )
	    {
	    if  ( enManier && eenheid > 0 )
		{ strcpy( buf, "en" ); buf += strlen( buf ); }
	    strcpy( buf, HoofdEenheden[eenheid] ); buf += strlen( buf );
	    }
	}
    if  ( tiental == 1 )
	{
	if  ( enManier && 10* tiental+ eenheid > 0 )
	    { strcpy( buf, "en" ); buf += strlen( buf ); }
	strcpy( buf, HoofdEenheden[10*tiental+eenheid] ); buf += strlen( buf );
	}
    if  ( tiental >  1 )
	{
	if  ( enManier )
	    { strcpy( buf, "en" ); buf += strlen( buf ); }
	if  ( eenheid > 0 )
	    {
	    int		dieresis= ( eenheid == 2 || eenheid == 3 );

	    strcpy( buf, HoofdEenheden[eenheid] ); buf += strlen( buf );
	    if  ( dieresis )
		{ *(buf++)= ISO_edieresis;	}
	    else{ *(buf++)= ISO_e;		}
	    *(buf++)= ISO_n;
	    }
	strcpy( buf, HoofdTientallen[tiental] ); buf += strlen( buf );
	}

    return buf;
    }

static int nlTelPut( ind, number, jaartal, type, indvreemd )
void *	ind;
int	number;
int	jaartal;
int	type;
void *	indvreemd;
    {
    int			eenheid, tiental, honderd, duizend, miljoen, miljard;
    int			xtiental, xhonderd;
    unsigned char	buf[200];
    unsigned char *	bend= buf;

    if  ( number == 0 )
	{
	if  ( type == DmoNUMBER	)
	    {
	    if  ( nlPut( ind, "nul", DmoNUMBER ) )
		{ return -1;	}
	    return 0;
	    }
	if  ( type == DmoCOUNT	)
	    {
	    if  ( nlPut( ind, "nulmaal", DmoCOUNT ) )
		{ return -1;	}
	    return 0;
	    }
	if  ( type == DmoRANK	)
	    {
	    if  ( nlPut( ind, "nulde", DmoRANK ) )
		{ return -1;	}
	    return 0;
	    }
	return -1;
	}

    miljard= ( number / 1000000000 ); number -= 1000000000 * miljard;
    miljoen= ( number / 1000000    ); number -= 1000000    * miljoen;
    duizend= ( number / 1000       ); number -= 1000       * duizend;
    honderd= ( number / 100        ); number -= 100        * honderd;
    tiental= ( number / 10         ); number -= 10         * tiental;
    eenheid=   number;

    if  ( miljard > 0 )
	{
	bend= nlTelPrint( bend, miljard, 0, 0 );
	strcpy( bend, "miljard" ); bend += strlen ( bend );
	}
    if  ( miljoen > 0 )
	{
	xhonderd= ( miljoen / 100        ); miljoen -= 100        * xhonderd;
	xtiental= ( miljoen / 10         ); miljoen -= 10         * xtiental;
	if  ( miljoen > 1 || xtiental >0 || xhonderd > 0 )
	    { bend= nlTelPrint( bend, miljoen, xtiental, xhonderd );	}
	strcpy( bend, "miljoen" ); bend += strlen ( bend );
	}
    if  ( duizend > 0 )
	{
	if  ( honderd == 0 || duizend > 9 )
	    {
	    xhonderd= ( duizend / 100    ); duizend -= 100    * xhonderd;
	    xtiental= ( duizend / 10     ); duizend -= 10     * xtiental;
	    if  ( duizend > 1 || xtiental >0 || xhonderd > 0 )
		{ bend= nlTelPrint( bend, duizend, xtiental, xhonderd ); }
	    strcpy( bend, "duizend" ); bend += strlen ( bend );
	    }
	else{
	    bend= nlTelPrint( bend, honderd, duizend, 0 );
	    if  ( ! jaartal || ( tiental == 0 && eenheid == 0 ) )
		{ strcpy( bend, "honderd" ); bend += strlen ( bend ); }
	    honderd= 0;
	    }
	}

    bend= nlTelPrint( bend, eenheid, tiental, honderd );

    if  ( type == DmoCOUNT )
	{ strcpy( bend, "maal" ); bend += strlen ( bend ); }

    if  ( type == DmoSIZE )
	{
	if  ( ! strcmp( bend- 3, "zes" ) )
	    { strcpy( bend, "sen" ); }
	else{
	    if  ( bend[-1] == 'e' )
		{ bend[0]= ISO_edieresis; bend[1]= 'n'; bend[2]= '\0';	}
	    else{ bend[0]= 'e'; bend[1]= 'n'; bend[2]= '\0';		}
	    }
	}

    if  ( type == DmoRANK )
	{
	switch( tiental )
	    {
	    case 0:
		switch( eenheid )
		    {
		    case 0:
			strcpy( bend, "ste" );
			break;
		    case 1:
			strcpy( bend- 1, "rste" );
			break;
		    case 3:
			strcpy( bend- 3, "erde" );
			break;
		    case 8:
			strcpy( bend, "ste" );
			break;
		    default:
			strcpy( bend, "de" );
			break;
		    }
		break;
	    case 1:
		strcpy( bend, "de" );
		break;
	    default:
		strcpy( bend, "ste" );
		break;
	    }
	}

    /*printf("BUF: '%s'\n", buf );*/
    if  ( nlPut( ind, buf, type ) )
	{ return -1;	}

    if  ( indvreemd )
	{
	int accepted;
	if  ( indGet( &accepted, indvreemd, buf ) >= 0 && accepted )
	    {
	    printf( "############################## %s\n", buf );
	    printf( "    Van Getal\n\n" );
	    }
	}

    return 0;
    }

int nlTelGener( ind, indvreemd )
void *	ind;
void *	indvreemd;
    {
    int	i;

    if  ( nlPut( ind, nlTelEen, DmoNUMBER ) )
	{ return -1;	}

    /********************/
    /*  Jaartallen.	*/
    /********************/
    for ( i= 1301; i <= 1999; i++ )
	{
	if  ( nlTelPut( ind, i, 1, DmoNUMBER, indvreemd ) )
	    { return -1;	}
	}

    for ( i= 0; i <= 20000; i++ )
	{
	if  ( nlTelPut( ind, i, 0, DmoNUMBER, indvreemd ) )
	    { return -1;	}
	if  ( nlTelPut( ind, i, 0, DmoCOUNT, indvreemd ) )
	    { return -1;	}
	if  ( nlTelPut( ind, i, 0, DmoRANK, indvreemd ) )
	    { return -1;	}
	}
    for ( i= 21000; i <= 1000000; i+= 1000 )
	{
	if  ( nlTelPut( ind, i, 0, DmoNUMBER, indvreemd ) )
	    { return -1;	}
	if  ( nlTelPut( ind, i, 0, DmoCOUNT, indvreemd ) )
	    { return -1;	}
	if  ( nlTelPut( ind, i, 0, DmoRANK, indvreemd ) )
	    { return -1;	}
	}

    for ( i= 2; i < 100; i++ )
	{
	if  ( nlTelPut( ind, i, 0, DmoSIZE, indvreemd ) )
	    { return -1;	}
	}
    for ( i= 200; i < 1000; i += 100 )
	{
	if  ( nlTelPut( ind, i, 0, DmoSIZE, indvreemd ) )
	    { return -1;	}
	}
    for ( i= 1000; i <= 10000; i += 1000 )
	{
	if  ( nlTelPut( ind, i, 0, DmoSIZE, indvreemd ) )
	    { return -1;	}
	if  ( nlTelPut( ind, 10* i, 0, DmoSIZE, indvreemd ) )
	    { return -1;	}
	}

    return 0;
    }
