#   include	<stdio.h>
#   include	<stdlib.h>
#   include	<stddef.h>
#   include	<string.h>
#   include	<ctype.h>
#   include	<charnames.h>

#   include	<debugon.h>

#   include	"spelling.h"

/************************************************************************/
/*  Werkwoorden.							*/
/*  Zie de alphabetische lijst op p610 in de ANS.			*/
/************************************************************************/

/************************************************************************/
/*  Potentiele voorvoegsels van samengestelde werkwoorden.		*/
/*  Zie ANS 8.5.2 pp490..512.						*/
/*  Geen voorvoegsel is een prefix van een latere!			*/
/************************************************************************/
typedef struct vo_s
    {
    unsigned char *	vo_string;
    int			vo_len;
    } VOORVOEGSEL;

static VOORVOEGSEL	NLvv[]=
    {
	{ "z*org",		5	},
	{ "z*oek",		5	},
	{ "z*acht",		6	},
	{ "weer*om",		7	},
	{ "w*ijs",		5	},
	{ "w*el",		4	},
	{ "w*eg",		4	},
	{ "w*eer",		5	},
	{ "w*eder",		6	},
	{ "w*aar",		5	},
	{ "w*arm",		5	},
	{ "w*acht",		6	},
	{ "vr*ij",		5	},
	{ "voorb*ij",		8	},
	{ "voor*uit",		8	},
	{ "voor*over",		9	},
	{ "voor*op",		7	},
	{ "voor*af",		7	},
	{ "verder",		6	},
	{ "van*een",		7	},
	{ "v*uil",		5	},
	{ "v*oort",		6	},
	{ "v*oor",		5	},
	{ "v*ol",		4	},
	{ "v*et",		4	},
	{ "v*ast",		5	},
	{ "uit*een",		7	},
	{ "th*uis",		6	},
	{ "ton*eel",		7	},
	{ "tew*eeg",		7	},
	{ "ter*ug",		6	},
	{ "t*ussen",		7	},
	{ "tevr*eden",		9	},
	{ "tew*erk",		7	},
	{ "tegem*oet",		9	},
	{ "ter*echt",		8	},
	{ "tent*oon",		8	},
	{ "tel*oor",		7	},
	{ "tel*eur",		7	},
	{ "tek*eer",		7	},
	{ "t*oe",		4	},
	{ "t*egen",		6	},
	{ "ten*iet",		7	},
	{ "tegen*over",		10	},
	{ "tek*ort",		7	},
	{ "st*uk",		5	},
	{ "st*orm",		6	},
	{ "st*op",		5	},
	{ "st*il",		5	},
	{ "st*and",		6	},
	{ "sch*uil",		7	},
	{ "sch*oot",		7	},
	{ "sch*oon",		7	},
	{ "sch*ool",		7	},
	{ "sch*aatsen",		10	},
	{ "sch*adeloos",	11	},
	{ "sch*eel",		7	},
	{ "sch*eef",		7	},
	{ "s*amen",		6	},
	{ "r*ond",		5	},
	{ "r*amen",		6	},
	{ "r*echt",		6	},
	{ "pr*ijs",		6	},
	{ "pl*aats",		7	},
	{ "pl*at",		5	},
	{ "p*ost",		5	},
	{ "pr*oef",		6	},
	{ "pi*ano",		6	},
	{ "p*aard",		6	},
	{ "overh*oop",		9	},
	{ "over*een",		8	},
	{ "op*een",		6	},
	{ "onder*uit",		9	},
	{ "omv*er",		6	},
	{ "oml*aag",		7	},
	{ "omhoog",		6	},
	{ "overh*een",		9	},
	{ "nab*ij",		6	},
	{ "n*eer",		5	},
	{ "n*a",		3	},
	{ "m*ooi",		5	},
	{ "m*is",		4	},
	{ "m*ee",		4	},
	{ "m*ede",		5	},
	{ "m*aat",		5	},
	{ "langs",		5	},
	{ "l*angs",		6	},
	{ "l*os",		4	},
	{ "l*ief",		5	},
	{ "l*eeg",		5	},
	{ "l*am",		4	},
	{ "l*astig",		7	},
	{ "k*ou",		4	},
	{ "kw*ijt",		6	},
	{ "kw*aad",		6	},
	{ "kr*om",		5	},
	{ "kl*aar",		6	},
	{ "kl*ein",		6	},
	{ "kap*ot",		6	},
	{ "k*offie",		7	},
	{ "k*ort",		5	},
	{ "k*aal",		5	},
	{ "k*aart",		6	},
	{ "kr*enten",		8	},
	{ "k*ennis",		7	},
	{ "in*een",		6	},
	{ "h*uis",		5	},
	{ "h*oog",		5	},
	{ "h*eet",		5	},
	{ "h*een",		5	},
	{ "h*ard",		5	},
	{ "gr*oot",		6	},
	{ "gr*oen",		6	},
	{ "gl*ad",		5	},
	{ "gew*aar",		7	},
	{ "ger*ust",		7	},
	{ "ger*ing",		7	},
	{ "ger*eed",		7	},
	{ "gel*uk",		6	},
	{ "gel*ijk",		7	},
	{ "g*oed",		5	},
	{ "g*ade",		5	},
	{ "g*a",		3	},
	{ "fl*auw",		6	},
	{ "f*out",		5	},
	{ "f*ijn",		5	},
	{ "f*eest",		6	},
	{ "*eruit",		6	},
	{ "dr*oog",		6	},
	{ "door*een",		8	},
	{ "dw*ars",		6	},
	{ "d*ubbel",		7	},
	{ "d*oor",		5	},
	{ "d*ood",		5	},
	{ "d*ol",		4	},
	{ "d*icht",		6	},
	{ "d*iep",		5	},
	{ "d*eel",		5	},
	{ "d*ank",		5	},
	{ "d*aar",		5	},
	{ "bl*oot",		6	},
	{ "bl*ind",		6	},
	{ "bij*een",		7	},
	{ "bek*end",		7	},
	{ "b*uiten",		7	},
	{ "b*uit",		5	},
	{ "b*oven",		6	},
	{ "b*ot",		4	},
	{ "b*oek",		5	},
	{ "b*innen",		7	},
	{ "b*ij",		4	},
	{ "b*ezig",		6	},
	{ "bel*ang",		7	},
	{ "b*eet",		5	},
	{ "b*akzeil",		8	},
	{ "achter*op",		9	},
	{ "achter*om",		9	},
	{ "achter*over",	11	},
	{ "achtern*a",		9	},
	{ "achter*aan",		10	},
	{ "achter*uit",		10	},
	{ "achterop",		8	},
	{ "achterom",		8	},
	{ "achterna",		8	},
	{ "b*oog",		5	},
	{ "br*aak",		6	},
	{ "aan*een",		7	},
	{ "aan",		3	},
	{ "*uit",		4	},
	{ "*over",		5	},
	{ "*open",		5	},
	{ "*op",		3	},
	{ "*onder",		6	},
	{ "omh*oog",		7	},
	{ "*om",		3	},
	{ "*in",		3	},
	{ "bij",		3	},
	{ "*auto",		5	},
	{ "*af",		3	},
	{ "*adem",		5	},
	{ "*achter",		7	},
	{ "*aan",		4	},
    };

#   ifdef	__STDC__					/*  {{	*/
    static int	nlVerStam(	const unsigned char * vorm1,
					const unsigned char * vorm2,
					unsigned char * buf );
    static int	nlVerStamT(	const unsigned char * vorm1,
					const unsigned char * vorm2,
					unsigned char * buf );
    typedef int			(*STAMFUN)( const unsigned char * vorm1,
					const unsigned char * vorm2,
					unsigned char * buf );
    static int nlVerCompStam(	const unsigned char * vorm1,
					const unsigned char * vorm2,
					unsigned char * buf, STAMFUN  );
#   else							/*  }{	*/
    static int	nlVerStam();
    static int	nlVerStamT();
    typedef int			(*STAMFUN)();
    static int nlVerCompStam();
#   endif							/*  }}	*/

/************************************************************************/
/*  De Stam.								*/
/*  Zie ANS 8.3.2.3, p 424.						*/
/************************************************************************/
static int	nlVerStam( vorm1, vorm2, buf )
const unsigned char *	vorm1;
const unsigned char *	vorm2;
unsigned char *		buf;
    {
    int		l= strlen( vorm1 );

    /*  be*amen etc .... */
    if  ( vorm1[0] == 'b' && vorm1[1] == 'e' && vorm1[2] == '*' )
	{
	buf[0]= 'b'; buf[1]= 'e';
	return nlVerStam( vorm1+2, vorm2+2, buf+ 2 );
	}

    /*  ontk*omen etc .... */
    if  ( vorm1[0] == 'o' && vorm1[1] == 'n' && vorm1[2] == 't' )
	{
	buf[0]= 'o'; buf[1]= 'n'; buf[2]= 't';
	return nlVerStam( vorm1+3, vorm2+3, buf+ 3 );
	}

    if  ( ! nlSpelCmp( vorm1, "komen" ) )
	{ strcpy( buf, "kom" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "voorkomen" ) )
	{ strcpy( buf, "voorkom" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "bekomen" ) )
	{ strcpy( buf, "bekom" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "miskomen" ) )
	{ strcpy( buf, "miskom" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "overkomen" ) )
	{ strcpy( buf, "overkom" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "nemen" ) )
	{ strcpy( buf, "neem" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "racen" ) )
	{ strcpy( buf, "race" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "timen" ) )
	{ strcpy( buf, "time" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "kunnen" ) )
	{ strcpy( buf, "kan" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "ganneven" ) )
	{ strcpy( buf, "gannef" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "glarieogen" ) )
	{ strcpy( buf, "glarieoog" ); return 0;	}

    /*printf("%s(%d) :%s\n",__FILE__,__LINE__,vorm1);*/
    if  ( nlUitgang( vorm1, l, "ien",   3, 0	)	||
	  nlUitgang( vorm1, l, "oen",   3, 0	)	)
	{
	int	ll;
	nlSpelCpy( buf, vorm1 );
	ll= strlen( buf );
	buf[ll-1]= '\0';
	return 0;
	}

    /************************************************************/
    /*  Fout in woordenboek: benadelen heeft geen klemtoon op	*/
    /*  de e van delen.						*/
    /*  idem voor *aanbenen.					*/
    /************************************************************/
    if  ( vorm2							&&
	  ( nlUitgang( vorm1, l, "eren",   4, -1 )	||
	    nlUitgang( vorm1, l, "elen",   4, -1 )	||
	    nlUitgang( vorm1, l, "enen",   4, -1 )	||
	    nlUitgang( vorm1, l, "emen",   4, -1 )	)	)
	{
	int		ll;

	ll= strlen( vorm2 );

	if  ( ll >= 5			&&
	      vorm2[ll-5] == 'e'	&&
	      vorm2[ll-4] == 'e'	&&
	      vorm2[ll-3] == vorm1[l-3]	&&
	      vorm2[ll-2] == 'd'	&&
	      vorm2[ll-1] == 'e'	)
	    {
	    nlSpelCpy( buf, vorm2 );
	    ll= strlen( buf );
	    buf[ll-2]= '\0';
	    return 0;
	    }
	}

    /********************************************************************/
    /*  Gemeenschappelijk beginstuk van infinitief en imperfect is	*/
    /*  stam.								*/
    /********************************************************************/
    if  ( vorm1					&&
	  vorm2					&&
	  ! strcmp( vorm2+ l- 2, "de" )		&&
	  ! strcmp( vorm1+ l- 2, "en" )		&&
	  ! strncmp( vorm1, vorm2, l- 2 )	)
	{
	nlSpelCpy( buf, vorm1 );
	l= strlen( buf );
	buf[l-2]= '\0';
	return 0;
	}

    if  ( nlUitgang( vorm1, l, "en",   2, -1	)	||
	  nlUitgang( vorm1, l, "eien", 4,  0	)	||
	  nlUitgang( vorm1, l, "eyen", 4,  0	)	)
	{
	int	ll;
	nlSpelCpy( buf, vorm1 );
	ll= strlen( buf );

	if  ( ll > 3			&&
	      ! nlKlinker( buf[ll-3] )	&&
	      buf[ll-3] == buf[ll-4]	)
	    { buf[ll-3]= '\0'; return 0; }
	else{
	    if  ( ! nlUitgang( vorm1, l, "eren",   4, -1 )		&&
		  ! nlUitgang( vorm1, l, "elen",   4, -1 )		&&
		  ! nlUitgang( vorm1, l, "enen",   4, -1 )		&&
		  ! nlUitgang( vorm1, l, "emen",   4, -1 )		&&
		  ! nlUitgang( vorm1, l, "igen",   4, -1 )		&&
		  ! nlUitgang( vorm1, l, "uwen",   4,  1 )		&&
		  ! nlUitgang( vorm1, l, "uwen",   4, -1 )		&&
				    /* hannesen, luiwammesen :	*/
		  ! nlUitgang( vorm1, l, "esen",   4, -1 )		&&
		  ! nlKlinker( buf[ll-3] )				&&
		  buf[ll-3] != 'x'					&&

		  ( buf[ll-4] == 'a'		||
		    buf[ll-4] == 'e'		||
		    buf[ll-4] == ISO_edieresis	||
		    buf[ll-4] == 'o'		||
		    buf[ll-4] == 'u'		)			&&

		  ( ll == 4					||
		    ! nlKlinker( buf[ll-5] )			||
		    nlUitgang( vorm1, l, "eren", 4, 1 )		)	)
		{
		/*  spelen -> speel */
		int	hc= buf[ll-3];
		if  ( hc == 'v' ) { hc= 'f';	}
		if  ( hc == 'z' ) { hc= 's';	}
		switch( buf[ll-4] )
		    {
		    case ISO_edieresis:
			/*  fout in lijst, affilieerde is ZONDER trema */
			if  ( ll > 4 && buf[ll-5] == 'e' )
			    {
			    /* creeren */
			    buf[ll-3]= 'e';
			    buf[ll-2]= hc; buf[ll-1]= '\0';
			    return 0;
			    }
			buf[ll-4]= 'e'; break;
		    case ISO_adieresis: buf[ll-4]= 'a'; break;
		    case ISO_idieresis: buf[ll-4]= 'i'; break;
		    case ISO_odieresis: buf[ll-4]= 'o'; break;
		    case ISO_udieresis: buf[ll-4]= 'u'; break;
		    default:
			break;
		    }
		buf[ll-3]= buf[ll-4];
		buf[ll-2]= hc; buf[ll-1]= '\0';
		return 0;
		}
	    else{
		buf[ll-2]= '\0';
		if  ( buf[ll-3] == 'v' ) { buf[ll-3]= 'f';	}
		if  ( buf[ll-3] == 'z' ) { buf[ll-3]= 's';	}
		/* ruzien -> ruzie */
		if  ( buf[ll-3] == 'i' && ! nlKlinker( buf[ll-4] ) )
		    { buf[ll-2]= 'e'; buf[ll-1]= '\0'; }
		return 0;
		}
	    }
	}

    if  ( nlUitgang( vorm1, l, "aan",   3, 0	) )
	{
	nlSpelCpy( buf, vorm1 );
	l= strlen( buf );
	buf[l-2]= '\0'; return 0;
	}

    if  ( nlUitgang( vorm1, l, "uen",   3, 0	) ||
	  nlUitgang( vorm1, l, "euen",  4, 0	) ||
	  nlUitgang( vorm1, l, "yen",   3, 0	) )
	{
	nlSpelCpy( buf, vorm1 );
	l= strlen( buf );
	buf[l-2]= '\0'; return 0;
	}

    printf("%s(%d):%s\n",__FILE__,__LINE__,vorm1);
    return 1;
    }

static int	nlVerStamT( vorm1, vorm2, buf )
const unsigned char *	vorm1;
const unsigned char *	vorm2;
unsigned char *		buf;
    {
    if  ( ! nlSpelCmp( vorm1, "kunnen" ) )
	{ strcpy( buf, "kunt" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "racen" ) )
	{ strcpy( buf, "racet" ); return 0;	}

    if  ( ! nlSpelCmp( vorm1, "timen" ) )
	{ strcpy( buf, "timet" ); return 0;	}

    if  ( ! nlVerStam( vorm1, vorm2, buf ) )
	{
	int	l= strlen( buf );

	if  ( nlKlinker( buf[l-1] )	&&
	      buf[l-1] != 'y'		&&
	      ! nlKlinker( buf[l-2] )	)
	    {
	    if  ( buf[l-1] == 'i' )
		{ buf[l]= 'e'; l++;		}
	    else{ buf[l]= buf[l-1]; l++;	}
	    }
	if  ( buf[l-1] != 't' )
	    { buf[l]= 't'; buf[l+1]= '\0';	}

	return 0;
	}

    return 1;
    }

static int nlVerCompStam( vorm1, vorm2, buf, stamfun )
const unsigned char *	vorm1;
const unsigned char *	vorm2;
unsigned char *		buf;
STAMFUN			stamfun;
    {
    int		i;

    for ( i= 0; i < sizeof(NLvv)/sizeof(VOORVOEGSEL); i++ )
	{
	if  ( ! strncmp( vorm1,	NLvv[i].vo_string, NLvv[i].vo_len ) )
	    {
	    unsigned char *	space;
	    int			rval;

	    nlSpelCpy( buf, NLvv[i].vo_string );
	    buf += strlen( buf );
	    space= strchr( vorm2, ' ' );

	    if  ( space && ! strcmp( space+ 1, NLvv[i].vo_string ) )
		{
		* space= '\0';

		if  ( vorm1[NLvv[i].vo_len] == '4' )
		    {
		    /* mee4eten, na4apen, toe4eigenen, uitbalien */
		    if  ( ! strcmp( vorm1, "m*ee4eten" ) )
			{
			rval= (*stamfun)( vorm1+ NLvv[i].vo_len+ 1, vorm2, buf);
			buf[0]= ISO_edieresis;
			goto gedaan;
			}
		    rval= (*stamfun)( vorm1+ NLvv[i].vo_len+ 1, vorm2, buf);
		    }
		else{
		    if  ( ! strcmp( vorm1, "*aanbevelen" ) )
			{
			rval= (*stamfun)( "bev*elen", vorm2, buf);
			goto gedaan;
			}
		    if  ( ! strcmp( vorm1, "*afscheren" )	||
			  ! strcmp( vorm1, "*uitscheren" )	)
			{
			rval= (*stamfun)( "sch*eren", vorm2, buf);
			goto gedaan;
			}
		    if  ( ! strcmp( vorm1, "*afstelen" ) )
			{
			rval= (*stamfun)( "st*elen", vorm2, buf);
			goto gedaan;
			}
		    if  ( ! strcmp( vorm1, "s*amenzweren" )	||
			  ! strcmp( vorm1, "*afzweren" )	)
			{
			rval= (*stamfun)( "zw*eren", vorm2, buf);
			goto gedaan;
			}
		    rval= (*stamfun)( vorm1+ NLvv[i].vo_len, vorm2, buf);
		    }
	    gedaan:
		* space= ' '; return rval;
		}
	    else{
		if  ( vorm1[NLvv[i].vo_len] == '4' )
		    {
		    return (*stamfun)(	vorm1+ NLvv[i].vo_len+ 1,
					    vorm2+ NLvv[i].vo_len+ 1,
					    buf);
		    }
		else{
		    return (*stamfun)(	vorm1+ NLvv[i].vo_len,
					    vorm2+ NLvv[i].vo_len,
					    buf );
		    }
		}

	    return 0;
	    }
	}

    return 1;
    }

/************************************************************************/
/*  De vervoegingen, indicatief tegenwoordige tijd.			*/
/************************************************************************/
int	nlVerPresS1( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "zijn" ) )
	{ strcpy( buf, "ben" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "vermogen" ) )
	{ strcpy( buf, "vermag" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "mogen" ) )
	{ strcpy( buf, "mag" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "zullen" ) )
	{ strcpy( buf, "zal" ); return 0;	}

    if  ( plemma->lm_samen == 2 )
	{
	return nlVerCompStam(	plemma->lm_vorm1, plemma->lm_vorm2,
				buf, nlVerStam );
	}
    else{
	return nlVerStam(	plemma->lm_vorm1, plemma->lm_vorm2, buf );
	}
    }

int	nlVerPresS2( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "zijn" ) )
	{ strcpy( buf, "bent" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "vermogen" ) )
	{ strcpy( buf, "vermag" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "mogen" ) )
	{ strcpy( buf, "mag" ); return 0;	}

    if  ( plemma->lm_samen == 2 )
	{
	return nlVerCompStam(	plemma->lm_vorm1, plemma->lm_vorm2,
				buf, nlVerStamT );
	}
    else{
	return nlVerStamT(	plemma->lm_vorm1, plemma->lm_vorm2, buf );
	}
    }

int	nlVerPresS2nl( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "zijn" ) )
	{ strcpy( buf, "ben" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "vermogen" ) )
	{ strcpy( buf, "vermag" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "mogen" ) )
	{ strcpy( buf, "mag" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "zullen" ) )
	{ strcpy( buf, "zal" ); return 0;	}

    if  ( plemma->lm_samen == 2 )
	{ return 1;	}

    return nlVerStam( plemma->lm_vorm1, plemma->lm_vorm2, buf );
    }

int	nlVerPresS3( Lemma * plemma, unsigned char * buf )
    {
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "zijn" ) )
	{ strcpy( buf, "is" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "vermogen" ) )
	{ strcpy( buf, "vermag" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "mogen" ) )
	{ strcpy( buf, "mag" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "zullen" ) )
	{ strcpy( buf, "zal" ); return 0;	}
    if  ( ! nlSpelCmp( plemma->lm_vorm1, "hebben" ) )
	{ strcpy( buf, "heeft" ); return 0;	}

    if  ( plemma->lm_samen == 2 )
	{
	int	l= strlen( plemma->lm_vorm1 );

	if  ( nlUitgang( plemma->lm_vorm1, l, "hebben",   6, 0 ) )
	    {
	    nlSpelCpy( buf, plemma->lm_vorm1 );
	    l= strlen( buf );
	    strcpy( buf+ l- 6, "heeft" );
	    return 0;
	    }
	else{
	    return nlVerCompStam( plemma->lm_vorm1, plemma->lm_vorm2,
							buf, nlVerStamT );
	    }
	}
    else{
	return nlVerStamT( plemma->lm_vorm1, plemma->lm_vorm2, buf );
	}

    return 1;
    }

int	nlVerPresP123( Lemma * plemma, unsigned char * buf )
    {
    nlSpelCpy( buf, plemma->lm_vorm1 );
    return 0;
    }

int	nlVerPresSs( Lemma * plemma, unsigned char * buf, STAMFUN stamfun )
    {
    int			ret;
    int			i;
    unsigned char	klad[50];

    ret= nlVerCompStam( plemma->lm_vorm1, plemma->lm_vorm2, klad, stamfun );

    if  ( ret )
	{ return ret;	}

    for ( i= 0; i < sizeof(NLvv)/sizeof(VOORVOEGSEL); i++ )
	{
	if  ( ! strncmp( plemma->lm_vorm1, NLvv[i].vo_string,
							NLvv[i].vo_len ) )
	    {
	    unsigned char	voor[12];
	    int			l;

	    nlSpelCpy( voor, NLvv[i].vo_string );
	    l= strlen( voor );

	    if  ( plemma->lm_vorm1[NLvv[i].vo_len] == '4' )
		{ nlSpelCpy( buf, klad+ l+ 1 ); }
	    else{ nlSpelCpy( buf, klad+ l ); }

	    return 0;
	    }
	}

    return 1;
    }

int	nlVerPresS1s( Lemma * plemma, unsigned char * buf )
    {
    if  ( plemma->lm_samen != 2 )
	{ return 1;	}

    return nlVerPresSs( plemma, buf, nlVerStam );
    }

int	nlVerPresS2s( Lemma * plemma, unsigned char * buf )
    {
    if  ( plemma->lm_samen != 2 )
	{ return 1;	}

    return nlVerPresSs( plemma, buf, nlVerStam );
    }

int	nlVerPresS3s( Lemma * plemma, unsigned char * buf )
    {
    if  ( plemma->lm_samen != 2 )
	{ return 1;	}

    return nlVerPresSs( plemma, buf, nlVerStamT );
    }

int	nlVerPresP123s( Lemma * plemma, unsigned char * buf )
    {
    int		i;

    if  ( plemma->lm_samen != 2 )
	{ return 1;	}

    for ( i= 0; i < sizeof(NLvv)/sizeof(VOORVOEGSEL); i++ )
	{
	if  ( ! strncmp( plemma->lm_vorm1,	NLvv[i].vo_string,
						NLvv[i].vo_len ) )
	    {
	    if  ( plemma->lm_vorm1[NLvv[i].vo_len] == '4' )
		{ nlSpelCpy( buf, plemma->lm_vorm1+ NLvv[i].vo_len+ 1 ); }
	    else{ nlSpelCpy( buf, plemma->lm_vorm1+ NLvv[i].vo_len ); }
	    return 0;
	    }
	}

    return 1;
    }

/************************************************************************/
/*  Imperfect.								*/
/************************************************************************/
static unsigned char ieerd  []= { 'i',ISO_edieresis,'e','r','d','\0' };
static unsigned char ieerde []= { 'i',ISO_edieresis,'e','r','d','e','\0' };
static unsigned char ieerden[]= { 'i',ISO_edieresis,'e','r','d','e','n','\0' };

int	nlVerImperS123( Lemma * plemma, unsigned char * buf )
    {
    int	ll;

    if  ( plemma->lm_samen != 2 )
	{
	if  ( plemma->lm_vorm2 )
	    {
	    nlSpelCpy( buf, plemma->lm_vorm2 );
	    /*  fout in lijst */
	    if  ( ( ll= strlen( buf ) ) > 6 && ! strcmp( buf+ll-6, ieerde ) )
		{ buf[ll-5]= 'e';	}
	    return 0;
	    }
	}
    else{
	if  ( plemma->lm_vorm2 )
	    {
	    unsigned char *	spatie= strchr( plemma->lm_vorm2, ' ' );
	    if  ( spatie )
		{
		nlSpelCpy( buf, spatie+ 1 );
		nlSpelCpy( buf+ strlen( buf ), plemma->lm_vorm2 );
		spatie= strchr( buf, ' ' );
		*spatie= '\0';
		/*  fout in lijst */
		if  ( ( ll= strlen(buf) ) > 6 && ! strcmp( buf+ll-6, ieerde ) )
		    { buf[ll-5]= 'e';	}
		return 0;
		}
	    }
	}

    return 1;
    }

int	nlVerImperS123s( Lemma * plemma, unsigned char * buf )
    {
    unsigned char *	spatie;

    if  ( plemma->lm_samen != 2 )
	{ return 1;	}

    if  ( plemma->lm_vorm2 )
	{
	nlSpelCpy( buf, plemma->lm_vorm2 );
	spatie= strchr( buf, ' ' );
	if  ( spatie )
	    { *spatie= '\0'; return 0;	}
	}

    return 1;
    }

int	nlVerImperP123( Lemma * plemma, unsigned char * buf )
    {
    int	ll;

    if  ( plemma->lm_samen != 2 )
	{
	if  ( plemma->lm_vorm3 )
	    {
	    nlSpelCpy( buf, plemma->lm_vorm3 );
	    /*  fout in lijst */
	    if  ( ( ll= strlen( buf ) ) > 7 && ! strcmp( buf+ll-7, ieerden ) )
		{ buf[ll-6]= 'e';	}
	    return 0;
	    }
	}
    else{
	if  ( plemma->lm_vorm3 )
	    {
	    unsigned char *	spatie= strchr( plemma->lm_vorm3, ' ' );
	    if  ( spatie )
		{
		nlSpelCpy( buf, spatie+ 1 );
		nlSpelCpy( buf+ strlen( buf ), plemma->lm_vorm3 );
		spatie= strchr( buf, ' ' );
		*spatie= '\0';
		/*  fout in lijst */
		if  ( ( ll= strlen(buf) ) > 7 && ! strcmp( buf+ll-6, ieerden ) )
		    { buf[ll-5]= '6';	}
		return 0;
		}
	    }
	}

    return 1;
    }

int	nlVerImperP123s( Lemma * plemma, unsigned char * buf )
    {
    unsigned char *	spatie;

    if  ( plemma->lm_samen != 2 )
	{ return 1;	}

    if  ( plemma->lm_vorm3 )
	{
	nlSpelCpy( buf, plemma->lm_vorm3 );
	spatie= strchr( buf, ' ' );
	if  ( spatie )
	    { *spatie= '\0'; return 0;	}
	}

    return 1;
    }

/************************************************************************/
/*  Verleden Deelwoord.							*/
/************************************************************************/
int	nlVerPartPas( Lemma * plemma, unsigned char * buf )
    {
    if  ( plemma->lm_vorm4 )
	{
	int	ll;

	nlSpelCpy( buf, plemma->lm_vorm4 );

	/*  fout in lijst */
	if  ( ( ll= strlen( buf ) ) > 5 && ! strcmp( buf+ll-5, ieerd ) )
	    { buf[ll-4]= 'e';	}

	return 0;
	}

    return 1;
    }

int	nlVerPartPasE( Lemma * plemma, unsigned char * buf )
    {
    unsigned char	klad[200];

    if  ( plemma->lm_vorm4 && ! nlSpelCmp( plemma->lm_vorm4, "geracet" ) )
	{ strcpy( buf, "geracete" ); return 0;	}

    if  ( plemma->lm_vorm4 && ! nlSpelCmp( plemma->lm_vorm4, "getimed" ) )
	{ strcpy( buf, "getimede" ); return 0;	}

    if  ( ! nlVerPartPas( plemma, klad ) )
	{ return nlAdjBuigVorm( klad, buf );	}

    return 1;
    }

int	nlVerPartPasEN( Lemma * plemma, unsigned char * buf )
    {
    unsigned char	klad[200];

    if  ( plemma->lm_vorm4 && ! nlSpelCmp( plemma->lm_vorm4, "geracet" ) )
	{ strcpy( buf, "geraceten" ); return 0;	}

    if  ( plemma->lm_vorm4 && ! nlSpelCmp( plemma->lm_vorm4, "getimed" ) )
	{ strcpy( buf, "getimeden" ); return 0;	}

    if  ( ! nlVerPartPas( plemma, klad )	&&
	  ! nlAdjBuigVorm( klad, buf )		)
	{ strcat( buf, "n" ); return 0;	}

    return 1;
    }

/************************************************************************/
/*  Tegenwoordig Deelwoord.						*/
/************************************************************************/
int	nlVerPartPres( Lemma * plemma, unsigned char * buf )
    {
    nlSpelCpy( buf, plemma->lm_vorm1 );
    strcat( buf, "d" );
    return 0;
    }

int	nlVerPartPresE( Lemma * plemma, unsigned char * buf )
    {
    nlSpelCpy( buf, plemma->lm_vorm1 );
    strcat( buf, "de" );
    return 0;
    }

int	nlVerPartPresEN( Lemma * plemma, unsigned char * buf )
    {
    nlSpelCpy( buf, plemma->lm_vorm1 );
    strcat( buf, "den" );
    return 0;
    }

/************************************************************************/
/*  'gelul' ge+ stam.							*/
/*  Zie ANS 2.6.1.7.a, p 76						*/
/************************************************************************/
int	nlVerGeStam( Lemma * plemma, unsigned char * buf )
    {
    int	i= 0;
    int	rval;

    if  ( plemma->lm_samen )
	{ return 1;	}

    if  ( ! nlSpelCmp( plemma->lm_vorm1, "kunnen" ) )
	{ strcpy( buf, "gekun" ); return 0;	}

    buf[i++]= 'g';
    buf[i++]= 'e';
    rval= nlVerStam( plemma->lm_vorm1, plemma->lm_vorm2, buf+ i );

    if  ( rval )
	{ return rval;	}

    /* if  ( buf[i] == 'a' )	{ buf[i]= ISO_adieresis;	} */
    if  ( buf[i] == 'e' )	{ buf[i]= ISO_edieresis;	}
    if  ( buf[i] == 'i' )	{ buf[i]= ISO_idieresis;	}
    if  ( buf[i] == 'o' )	{ buf[i]= ISO_odieresis;	}
    if  ( buf[i] == 'u' )	{ buf[i]= ISO_udieresis;	}

    return rval;
    }


/************************************************************************/
/*  Voorvoegsel van een scheidbaar samengesteld werkwoord.		*/
/************************************************************************/
int	nlVerCompPref( Lemma * plemma, unsigned char * buf )
    {
    int		i;

    if  ( plemma->lm_samen != 2 )
	{ return 1;	}

    for ( i= 0; i < sizeof(NLvv)/sizeof(VOORVOEGSEL); i++ )
	{
	if  ( ! strncmp( plemma->lm_vorm1,	NLvv[i].vo_string,
						NLvv[i].vo_len ) )
	    {
	    nlSpelCpy( buf, NLvv[i].vo_string );
	    return 0;
	    }
	}

    printf( "ONBEKEND VOORVOEGSEL: '%s'\n", plemma->lm_vorm1 );
    return 1;
    }
