#   include	<stdio.h>
#   include	<stdlib.h>
#   include	<stddef.h>
#   include	<string.h>

#   include	<debugoff.h>

#   include	"spelling.h"

/************************************************************************/
/*  Zoek een woord in een woordenlijst.					*/
/************************************************************************/

#   define	REGLEN	200

static int	nlReadAt( f, buf, plemma, pm )
FILE *	f;
char *	buf;
Lemma *	plemma;
long *	pm;
    {
    int	c;

    if  ( *pm > 0 )
	{
	(*pm)--;
	if  ( fseek( f, *pm, SEEK_SET ) )
	    { fclose( f ); return 1;	}
	while( ( c= getc( f ) ) != EOF && c != '\n' )
	    { (*pm)++;	}
	if  ( c == EOF )
	    { return 1;	}
	}
    else{
	if  ( fseek( f, *pm, SEEK_SET ) )
	    { fclose( f ); return 1;	}
	}
    if  ( fgets( buf, REGLEN, f ) != buf )
	{ return 1;	}
    nlSplitLemma( buf, plemma );

    return 0;
    }

/************************************************************************/
/*  Roep een procedure voor alle lemmas bij een woord.			*/
/************************************************************************/
int nlRoepProc(	FILE *		f,
		long		filesize,
		unsigned char *	woord,
		void *		door,
		int		(*proc)( Lemma *, void * )	)
    {
    long	l, m, r;
    Lemma	hetLemma;
    char	regel[REGLEN+1];
    int		c;

    l= 0; r= filesize; m= ( l+ r )/ 2;

    while( l < m )
	{
	long	mm= m;

	if  ( nlReadAt( f, regel, &hetLemma, &mm ) )
	    { r= m; m= ( l+ r )/ 2; continue;	}
	c= nlSpelCmp( hetLemma.lm_vorm1, woord );
	if  ( c < 0 )
	    { l= m; m= ( l+ r )/ 2; continue;	}
	else{
	    if  ( c == 0 )
		{
		if  ( mm >= r )
		    { m= mm; break;	}
		}
	    r= m; m= ( l+ r )/ 2; continue;
	    }
	}

    if  ( nlReadAt( f, regel, &hetLemma, &m ) )
	{ return 0;	}

    while( nlSpelCmp( hetLemma.lm_vorm1, woord ) <  0 )
	{
	if  ( fgets( regel, REGLEN, f ) != regel )
	    { break;	}
	nlSplitLemma( regel, &hetLemma );
	}

    while( nlSpelCmp( hetLemma.lm_vorm1, woord ) == 0 )
	{
	if  ( (*proc)( &hetLemma, door ) )
	    { LDEB(-1); return -1;	}

	if  ( fgets( regel, REGLEN, f ) != regel )
	    { break;	}

	nlSplitLemma( regel, &hetLemma );
	}

    return 0;
    }
