#   include	<stdio.h>
#   include	<ind.h>
#   include	<charnames.h>
#   include	<debugon.h>

static char buf[100];

static int readWords( filename, ind )
char *	filename;
void * ind;
    {
    int		c, cc;
    int		pos;
    int		skip;
    int		line= 1;

    FILE *	f= fopen( filename, "r" );

    if  ( ! f )
	{ SDEB(filename); return -1; }

    pos= 0; skip= 0;

    while( ( c= getc( f ) ) != EOF )
	{
	switch( c )
	    {
	    case '.':
		buf[pos++]= c; skip= 1;
		continue;
	    case '-':
		buf[pos++]= c;
		continue;
	    case 'a': case 'b': case 'c': case 'd': case 'e':
	    case 'f': case 'g': case 'h': case 'i': case 'j':
	    case 'k': case 'l': case 'm': case 'n': case 'o':
	    case 'p': case 'q': case 'r': case 's': case 't':
	    case 'u': case 'v': case 'w': case 'x': case 'y':
	    case 'z':
		buf[pos++]= c;
		continue;
	    case '\0':
		continue;
	    case '\r':
	    case '\n':
		buf[pos]= '\0';
		if  ( pos > 0 && ! skip )
		    {
		    int		tn;

		    if  ( ( tn= indPut( ind, buf ) ) < 0 )
			{ printf( "%s\n", buf ); fclose( f ); return -1; }
		    }
		pos= 0; skip= 0; line++;
		continue;
	    case '/': case ',':
		if  ( pos == 0 )
		    {
		    fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					filename, line, pos, c );
		    fclose( f ); return -1;
		    }
		switch( buf[pos-1] )
		    {
		    case 'c':
			buf[pos-1]= ISO_ccedilla;
			continue;
		    default:
			fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					filename, line, pos, buf[pos-1], c );
			fclose( f ); return -1;
		    }
		/*NOTREACHED*/
		break;
	    case '"':
		if  ( pos == 0 )
		    {
		    fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					filename, line, pos, c );
		    fclose( f ); return -1;
		    }
		switch( buf[pos-1] )
		    {
		    case 'e':
			buf[pos-1]= ISO_edieresis;
			continue;
		    case 'i':
			buf[pos-1]= ISO_idieresis;
			continue;
		    case 'u':
			buf[pos-1]= ISO_udieresis;
			continue;
		    case 'o':
			buf[pos-1]= ISO_odieresis;
			continue;
		    case 'a':
			buf[pos-1]= ISO_adieresis;
			continue;
		    default:
			fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					filename, line, pos, buf[pos-1], c );
			fclose( f ); return -1;
		    }
		/*NOTREACHED*/
		break;
	    case '\'':
		if  ( pos == 0 )
		    {
		    fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					filename, line, pos, c );
		    fclose( f ); return -1;
		    }
		switch( buf[pos-1] )
		    {
		    case 'a':
			buf[pos-1]= ISO_aacute;
			continue;
		    case 'e':
			buf[pos-1]= ISO_eacute;
			continue;
		    case 'l':
		    case 'd':
		    case 'c':
		    case 'r':
		    case 'j':
		    case 'u':
		    case 'm':
		    case 'n':
		    case 's':
		    case 't':
			buf[pos++]= c;
			continue;
		    default:
			fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					filename, line, pos, buf[pos-1], c );
			fclose( f ); return -1;
		    }
		/*NOTREACHED*/
		break;
	    case '`':
		if  ( pos == 0 )
		    {
		    fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					filename, line, pos, c );
		    fclose( f ); return -1;
		    }
		switch( buf[pos-1] )
		    {
		    case 'a':
			buf[pos-1]= ISO_agrave;
			continue;
		    case 'e':
			buf[pos-1]= ISO_egrave;
			continue;
		    case 'u':
			buf[pos-1]= ISO_ugrave;
			continue;
		    default:
			fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					filename, line, pos, buf[pos-1], c );
			fclose( f ); return -1;
		    }
		/*NOTREACHED*/
		break;
	    case '^':
		if  ( pos == 0 )
		    {
		    fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					filename, line, pos, c );
		    fclose( f ); return -1;
		    }
		switch( buf[pos-1] )
		    {
		    case 'a':
			buf[pos-1]= ISO_acircumflex;
			continue;
		    case 'o':
			buf[pos-1]= ISO_ocircumflex;
			continue;
		    case 'e':
			buf[pos-1]= ISO_ecircumflex;
			continue;
		    case 'i':
			buf[pos-1]= ISO_icircumflex;
			continue;
		    case 'u':
			buf[pos-1]= ISO_ucircumflex;
			continue;
		    default:
			fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					filename, line, pos, buf[pos-1], c );
			fclose( f ); return -1;
		    }
		/*NOTREACHED*/
		break;
	    case '{':
		c= getc( f );
		switch( c )
		    {
		    case 'A':
		    case 'O':
			buf[pos++]= c;
			c= getc( f );
			if  ( c != 'E' )
			    {
			    fprintf( stderr, "%s(%d): pos= %d, '{%c%c'\n", /*}*/
					filename, line, pos, buf[pos-1], c );
			    fclose( f ); return -1;
			    }
			break;
		    case 'a':
		    case 'o':
			buf[pos++]= c;
			c= getc( f );
			if  ( c != 'e' )
			    {
			    fprintf( stderr, "%s(%d): pos= %d, '{%c%c'\n", /*}*/
					filename, line, pos, buf[pos-1], c );
			    fclose( f ); return -1;
			    }
			break;
		    default:
			fprintf( stderr, "%s(%d): pos= %d, '{%c'\n", /*}*/
					filename, line, pos, c );
			fclose( f ); return -1;
		    }
		cc= getc( f );
		if  ( cc != '}' )
		    {
		    fprintf( stderr, "%s(%d): pos= %d, '{%c%c%c'\n", /*}*/
				filename, line, pos, buf[pos-1], c, cc );
		    fclose( f ); return -1;
		    }
		switch( buf[pos-1] )
		    {
		    case 'A':
			buf[pos-1]= ISO_AE; continue;
		    case 'O':
			buf[pos++]= c; continue;
		    case 'a':
			buf[pos-1]= ISO_ae; continue;
		    case 'o':
			buf[pos++]= c; continue;
		    default:
			fprintf( stderr, "impossible\n" );
			fclose( f ); return -1;
		    }
		break;
	    default:
		fprintf( stderr, "%s(%d): c= '%c'= 0x%02x\n",
					    filename, line, c, c );
		fclose( f ); return -1;
	    }
	}

    fclose( f );
    return 0;
    }

int main( argc, argv )
int	argc;
char **	argv;
    {
    void *	ind= indMake();
    void *	indmini;
    int		arg;

    if  ( ! ind )
	{ XDEB(ind); return 1;	}

    for ( arg= 1; arg < argc; arg++ )
	{
	if  ( readWords( argv[arg], ind ) )
	    { SDEB(argv[arg]); indFree( ind ); return 1; }
	}

    indmini= indMini( ind );
    if  ( ! indmini )
	{ XDEB(indMini); return 1;	}

    if  ( indmini )
	{
	char *	indexName= "French.ind";

	if  ( indWrite( indmini, indexName ) )
	    { SDEB(indexName); return 1; }
	indFree( indmini );
	}

    indFree( ind );

    return 0;
    }
