#   include	<stdio.h>
#   include	<ind.h>
#   include	<charnames.h>
#   include	<debugon.h>
#   include	"affix.h"

static char buf[300];

int main(	int	argc,
		char **	argv	)
    {
    FILE *	f;
    int		arg;

    int		c;
    int		pos, len;
    int		skip, show;
    int		line= 1;

    void *	ind= indMake();
    void *	indmini;
    int		tn;

    if  ( argc <= 2 )
	{ LLDEB(argc,2); return 1;	}

    if  ( ! ind )
	{ XDEB(ind); return 1;	}

    if  ( affixReadFile( argv[1] ) )
	{ SDEB(argv[1]); return 1; }

    for ( arg= 2; arg < argc; arg++ )
	{
	len= pos= 0; skip= 0; show= 0;

	f= fopen( argv[arg], "r" );
	if  ( ! f )
	    { SXDEB(argv[arg],f); return 1;	}

	while( ( c= getc( f ) ) != EOF )
	    {
	    switch( c )
		{
		case 'A': case 'B': case 'C': case 'D': case 'E':
		case 'F': case 'G': case 'H': case 'I': case 'J':
		case 'K': case 'L': case 'M': case 'N': case 'O':
		case 'P': case 'Q': case 'R':           case 'T':
		case 'U': case 'V': case 'W': case 'X': case 'Y':
		case 'Z':
		case 'a': case 'b': case 'c': case 'd': case 'e':
		case 'f': case 'g': case 'h': case 'i': case 'j':
		case 'k': case 'l': case 'm': case 'n': case 'o':
		case 'p': case 'q': case 'r': case 's': case 't':
		case 'u': case 'v': case 'w': case 'x': case 'y':
		case 'z':
		    buf[pos++]= c;
		    continue;
		case 'S':
		    if  ( pos > 0 && buf[pos-1] == 's' )
			{ buf[pos-1]= ISO_germandbls; }
		    else{ buf[pos++]= c;	}
		    continue;
		case '"':
		    if  ( pos == 0 )
			{
			fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					    argv[arg], line, pos, c );
			fclose( f ); return 1;
			}
		    switch( buf[pos-1] )
			{
			case 'e':
			    buf[pos-1]= ISO_edieresis;
			    continue;
			case 'i':
			    buf[pos-1]= ISO_idieresis;
			    continue;
			case 'u':
			    buf[pos-1]= ISO_udieresis;
			    continue;
			case 'U':
			    buf[pos-1]= ISO_Udieresis;
			    continue;
			case 'o':
			    buf[pos-1]= ISO_odieresis;
			    continue;
			case 'O':
			    buf[pos-1]= ISO_Odieresis;
			    continue;
			case 'a':
			    buf[pos-1]= ISO_adieresis;
			    continue;
			case 'A':
			    buf[pos-1]= ISO_Adieresis;
			    continue;
			default:
			    fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					argv[arg], line, pos, buf[pos-1], c );
			    fclose( f ); return 1;
			}
		    /*NOTREACHED*/
		    break;
		case '\'':
		    if  ( pos == 0 )
			{
			fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					    argv[arg], line, pos, c );
			fclose( f ); return 1;
			}
		    switch( buf[pos-1] )
			{
			case 'a':
			    buf[pos-1]= ISO_aacute;
			    continue;
			case 'e':
			    buf[pos-1]= ISO_eacute;
			    continue;
			case 'l':
			case 'd':
			case 'c':
			case 'r':
			case 'j':
			case 'u':
			case 'm':
			case 'n':
			case 's':
			case 't':
			    buf[pos++]= c;
			    continue;
			default:
			    fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					argv[arg], line, pos, buf[pos-1], c );
			    fclose( f ); return 1;
			}
		    /*NOTREACHED*/
		    break;
		case '`':
		    if  ( pos == 0 )
			{
			fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					    argv[arg], line, pos, c );
			fclose( f ); return 1;
			}
		    switch( buf[pos-1] )
			{
			case 'a':
			    buf[pos-1]= ISO_agrave;
			    continue;
			case 'e':
			    buf[pos-1]= ISO_egrave;
			    continue;
			case 'u':
			    buf[pos-1]= ISO_ugrave;
			    continue;
			default:
			    fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					argv[arg], line, pos, buf[pos-1], c );
			    fclose( f ); return 1;
			}
		    /*NOTREACHED*/
		    break;
		case '^':
		    if  ( pos == 0 )
			{
			fprintf( stderr, "%s(%d): pos= %d, c= '%c'\n",
					    argv[arg], line, pos, c );
			fclose( f ); return 1;
			}
		    switch( buf[pos-1] )
			{
			case 'a':
			    buf[pos-1]= ISO_acircumflex;
			    continue;
			case 'o':
			    buf[pos-1]= ISO_ocircumflex;
			    continue;
			case 'e':
			    buf[pos-1]= ISO_ecircumflex;
			    continue;
			case 'i':
			    buf[pos-1]= ISO_icircumflex;
			    continue;
			case 'u':
			    buf[pos-1]= ISO_ucircumflex;
			    continue;
			default:
			    fprintf( stderr, "%s(%d): pos= %d, '%c%c'\n",
					argv[arg], line, pos, buf[pos-1], c );
			    fclose( f ); return 1;
			}
		    /*NOTREACHED*/
		    break;
		case '/':
		    len= pos;
		    buf[pos++]= '\0';
		    break;
		case '\n':
		    buf[pos]= '\0';

		    if  ( pos != 0 )
			{
			if  ( len != 0 )
			    {
			    /* printf( "%s/%s\n", buf, buf+ len+ 1 ); */

			    if  ( affixApplyRules( buf, len, buf+ len+ 1,
								ind, indPut ) )
				{
				fprintf( stderr, "%d: '%s'\n", __LINE__, buf );
				fclose( f ); return 1;
				}
			    }

			if  ( ( tn= indPut( ind, buf ) ) < 0 )
			    {
			    fprintf( stderr, "%d: '%s'\n", __LINE__, buf );
			    fclose( f ); return 1;
			    }
			}
		    len= pos= 0; line++;
		    break;
#		if 0
		case '0':
		    if  ( len > 0 )
			{ break;	}
		    /*FALLTHROUGH*/
#		endif
		default:
		    fprintf( stderr, "%s(%d): pos= %d, '%c'\n",
				    argv[arg], line, pos, c );
		    fclose( f ); return 1;
		}
	    }

	fclose( f );
	}

    indmini= indMini( ind );

    indFree( ind );
    ind= (void *)0;

    if  ( ! indmini )
	{ XDEB(indmini);; return 1;	}

    if  ( indmini )
	{
	ind= indRenumber( indmini );

	if  ( ! ind )
	    { XDEB(ind);; return 1; }
	indFree( indmini );
	}

    if  ( ind )
	{
	char *	indexName= "German.ind";

	if  ( indWrite( ind, indexName ) )
	    { SDEB(indexName); return 1; }

	indFree( ind );
	}

    return 0;
    }
