/************************************************************************/
/*									*/
/*  ASCII, Names are the Postscript Glyph names, For the Control	*/
/*	characters, the names in /usr/pub/ascii are used.		*/
/*									*/
/*  ECMA 94 Latin 1 character Set Chart (= ISO 8859-1).			*/
/*  ASCII+ ISOLatin1Encoding.						*/
/*  Spelling follows the Postscipt Glyph Name, (prefixed with 'ISO_'.)	*/
/*  Glyph names are from appendix E.5 (p. 495) of:			*/
/*  Adobe Systems: Postscript Language Reference Manual, Addison &	*/
/*	Wesley, Reading MA., 1990, ISBN 0-201-18127-4			*/
/*									*/
/*  Idem for Standard Encoding of Postscript.				*/
/*									*/
/*  Idem for NeXT Encoding of Postscript.				*/
/*									*/
/*  Idem for Apple Macintosh ROM character set.				*/
/*									*/
/*  Idem for EBCDIC for ibm 3270.					*/
/*	This is more or less guessed. Consulted are:			*/
/*	1)  Character map in x3270 source.				*/
/*	2)  Unicode Standard, Appendix 6.2, PC EBCDIC Code Page (p. 605)*/
/*	    Unicode Consortium: Unicode Standard, Version 1.0, Volume 1,*/
/*		Addidon & Wesley, Reading MA., 1991, ISBN 0-201-56788-1	*/
/*									*/
/************************************************************************/

/************************************************************************/
/*  ASCII								*/
/************************************************************************/
#   define	ASCII_nul		0x00
#   define	ASCII_soh		0x01
#   define	ASCII_stx		0x02
#   define	ASCII_etx		0x03
#   define	ASCII_eot		0x04
#   define	ASCII_enq		0x05
#   define	ASCII_ack		0x06
#   define	ASCII_bel		0x07
#   define	ASCII_bs		0x08
#   define	ASCII_ht		0x09
#   define	ASCII_nl		0x0a
#   define	ASCII_vt		0x0b
#   define	ASCII_np		0x0c
#   define	ASCII_cr		0x0d
#   define	ASCII_so		0x0e
#   define	ASCII_si		0x0f
#   define	ASCII_dle		0x10
#   define	ASCII_dc1		0x11
#   define	ASCII_dc2		0x12
#   define	ASCII_dc3		0x13
#   define	ASCII_dc4		0x14
#   define	ASCII_nak		0x15
#   define	ASCII_syn		0x16
#   define	ASCII_etb		0x17
#   define	ASCII_can		0x18
#   define	ASCII_em		0x19
#   define	ASCII_sub		0x1a
#   define	ASCII_esc		0x1b
#   define	ASCII_fs		0x1c
#   define	ASCII_gs		0x1d
#   define	ASCII_rs		0x1e
#   define	ASCII_us		0x1f
#   define	ASCII_space		0x20
#   define	ASCII_exclam		0x21
#   define	ASCII_quotedbl		0x22
#   define	ASCII_numbersign	0x23
#   define	ASCII_dollar		0x24
#   define	ASCII_percent		0x25
#   define	ASCII_ampersand		0x26
#   define	ASCII_quoteright	0x27
#   define	ASCII_parenleft		0x28
#   define	ASCII_parenright	0x29
#   define	ASCII_asterisk		0x2a
#   define	ASCII_plus		0x2b
#   define	ASCII_comma		0x2c
#   define	ASCII_minus		0x2d
#   define	ASCII_period		0x2e
#   define	ASCII_slash		0x2f
#   define	ASCII_zero		0x30
#   define	ASCII_one		0x31
#   define	ASCII_two		0x32
#   define	ASCII_three		0x33
#   define	ASCII_four		0x34
#   define	ASCII_five		0x35
#   define	ASCII_six		0x36
#   define	ASCII_seven		0x37
#   define	ASCII_eight		0x38
#   define	ASCII_nine		0x39
#   define	ASCII_colon		0x3a
#   define	ASCII_semicolon		0x3b
#   define	ASCII_less		0x3c
#   define	ASCII_equal		0x3d
#   define	ASCII_greater		0x3e
#   define	ASCII_question		0x3f
#   define	ASCII_at		0x40
#   define	ASCII_A			0x41
#   define	ASCII_B			0x42
#   define	ASCII_C			0x43
#   define	ASCII_D			0x44
#   define	ASCII_E			0x45
#   define	ASCII_F			0x46
#   define	ASCII_G			0x47
#   define	ASCII_H			0x48
#   define	ASCII_I			0x49
#   define	ASCII_J			0x4a
#   define	ASCII_K			0x4b
#   define	ASCII_L			0x4c
#   define	ASCII_M			0x4d
#   define	ASCII_N			0x4e
#   define	ASCII_O			0x4f
#   define	ASCII_P			0x50
#   define	ASCII_Q			0x51
#   define	ASCII_R			0x52
#   define	ASCII_S			0x53
#   define	ASCII_T			0x54
#   define	ASCII_U			0x55
#   define	ASCII_V			0x56
#   define	ASCII_W			0x57
#   define	ASCII_X			0x58
#   define	ASCII_Y			0x59
#   define	ASCII_Z			0x5a
#   define	ASCII_bracketleft	0x5b
#   define	ASCII_backslash		0x5c
#   define	ASCII_bracketright	0x5d
#   define	ASCII_circumflex	0x5e
#   define	ASCII_underscore	0x5f
#   define	ASCII_quoteleft		0x60
#   define	ASCII_a			0x61
#   define	ASCII_b			0x62
#   define	ASCII_c			0x63
#   define	ASCII_d			0x64
#   define	ASCII_e			0x65
#   define	ASCII_f			0x66
#   define	ASCII_g			0x67
#   define	ASCII_h			0x68
#   define	ASCII_i			0x69
#   define	ASCII_j			0x6a
#   define	ASCII_k			0x6b
#   define	ASCII_l			0x6c
#   define	ASCII_m			0x6d
#   define	ASCII_n			0x6e
#   define	ASCII_o			0x6f
#   define	ASCII_p			0x70
#   define	ASCII_q			0x71
#   define	ASCII_r			0x72
#   define	ASCII_s			0x73
#   define	ASCII_t			0x74
#   define	ASCII_u			0x75
#   define	ASCII_v			0x76
#   define	ASCII_w			0x77
#   define	ASCII_x			0x78
#   define	ASCII_y			0x79
#   define	ASCII_z			0x7a
#   define	ASCII_braceleft		0x7b
#   define	ASCII_bar		0x7c
#   define	ASCII_braceright	0x7d
#   define	ASCII_tilde		0x7e
#   define	ASCII_del		0x7f

#   define	ASCII_isupper( c )	((c)>=ASCII_A&&(c)<=ASCII_Z)
#   define	ASCII_islower( c )	((c)>=ASCII_a&&(c)<=ASCII_z)
#   define	ASCII_isalpha( c )	(ASCII_isupper((c))||ASCII_islower((c)))
#   define	ASCII_tolower( c )	(ASCII_isupper((c))?(c)+0x10:(c))
#   define	ASCII_toupper( c )	(ASCII_islower((c))?(c)-0x10:(c))

/************************************************************************/
/*  ISO Latin1 (ISO 8859)						*/
/************************************************************************/
#   define	ISO_nul			ASCII_nul
#   define	ISO_soh			ASCII_soh
#   define	ISO_stx			ASCII_stx
#   define	ISO_etx			ASCII_etx
#   define	ISO_eot			ASCII_eot
#   define	ISO_enq			ASCII_enq
#   define	ISO_ack			ASCII_ack
#   define	ISO_bel			ASCII_bel

#   define	ISO_bs			ASCII_bs
#   define	ISO_ht			ASCII_ht
#   define	ISO_nl			ASCII_nl
#   define	ISO_vt			ASCII_vt
#   define	ISO_np			ASCII_np
#   define	ISO_cr			ASCII_cr
#   define	ISO_so			ASCII_so
#   define	ISO_si			ASCII_si

#   define	ISO_dle			ASCII_dle
#   define	ISO_dc1			ASCII_dc1
#   define	ISO_dc2			ASCII_dc2
#   define	ISO_dc3			ASCII_dc3
#   define	ISO_dc4			ASCII_dc4
#   define	ISO_nak			ASCII_nak
#   define	ISO_syn			ASCII_syn
#   define	ISO_etb			ASCII_etb

#   define	ISO_can			ASCII_can
#   define	ISO_em			ASCII_em
#   define	ISO_sub			ASCII_sub
#   define	ISO_esc			ASCII_esc
#   define	ISO_fs			ASCII_fs
#   define	ISO_gs			ASCII_gs
#   define	ISO_rs			ASCII_rs
#   define	ISO_us			ASCII_us

#   define	ISO_space		ASCII_space
#   define	ISO_exclam		ASCII_exclam
#   define	ISO_quotedbl		ASCII_quotedbl
#   define	ISO_numbersign		ASCII_numbersign
#   define	ISO_dollar		ASCII_dollar
#   define	ISO_percent		ASCII_percent
#   define	ISO_ampersand		ASCII_ampersand
#   define	ISO_quoteright		ASCII_quoteright

#   define	ISO_parenleft		ASCII_parenleft
#   define	ISO_parenright		ASCII_parenright
#   define	ISO_asterisk		ASCII_asterisk
#   define	ISO_plus		ASCII_plus
#   define	ISO_comma		ASCII_comma
#   define	ISO_minus		ASCII_minus
#   define	ISO_period		ASCII_period
#   define	ISO_slash		ASCII_slash

#   define	ISO_zero		ASCII_zero
#   define	ISO_one			ASCII_one
#   define	ISO_two			ASCII_two
#   define	ISO_three		ASCII_three
#   define	ISO_four		ASCII_four
#   define	ISO_five		ASCII_five
#   define	ISO_six			ASCII_six
#   define	ISO_seven		ASCII_seven

#   define	ISO_eight		ASCII_eight
#   define	ISO_nine		ASCII_nine
#   define	ISO_colon		ASCII_colon
#   define	ISO_semicolon		ASCII_semicolon
#   define	ISO_less		ASCII_less
#   define	ISO_equal		ASCII_equal
#   define	ISO_greater		ASCII_greater
#   define	ISO_question		ASCII_question

#   define	ISO_at			ASCII_at
#   define	ISO_A			ASCII_A
#   define	ISO_B			ASCII_B
#   define	ISO_C			ASCII_C
#   define	ISO_D			ASCII_D
#   define	ISO_E			ASCII_E
#   define	ISO_F			ASCII_F
#   define	ISO_G			ASCII_G

#   define	ISO_H			ASCII_H
#   define	ISO_I			ASCII_I
#   define	ISO_J			ASCII_J
#   define	ISO_K			ASCII_K
#   define	ISO_L			ASCII_L
#   define	ISO_M			ASCII_M
#   define	ISO_N			ASCII_N
#   define	ISO_O			ASCII_O

#   define	ISO_P			ASCII_P
#   define	ISO_Q			ASCII_Q
#   define	ISO_R			ASCII_R
#   define	ISO_S			ASCII_S
#   define	ISO_T			ASCII_T
#   define	ISO_U			ASCII_U
#   define	ISO_V			ASCII_V
#   define	ISO_W			ASCII_W

#   define	ISO_X			ASCII_X
#   define	ISO_Y			ASCII_Y
#   define	ISO_Z			ASCII_Z
#   define	ISO_bracketleft		ASCII_bracketleft
#   define	ISO_backslash		ASCII_backslash
#   define	ISO_bracketright	ASCII_bracketright
#   define	ISO_asciicircum		ASCII_circumflex
#   define	ISO_underscore		ASCII_underscore

#   define	ISO_quoteleft		ASCII_quoteleft
#   define	ISO_a			ASCII_a
#   define	ISO_b			ASCII_b
#   define	ISO_c			ASCII_c
#   define	ISO_d			ASCII_d
#   define	ISO_e			ASCII_e
#   define	ISO_f			ASCII_f
#   define	ISO_g			ASCII_g

#   define	ISO_h			ASCII_h
#   define	ISO_i			ASCII_i
#   define	ISO_j			ASCII_j
#   define	ISO_k			ASCII_k
#   define	ISO_l			ASCII_l
#   define	ISO_m			ASCII_m
#   define	ISO_n			ASCII_n
#   define	ISO_o			ASCII_o

#   define	ISO_p			ASCII_p
#   define	ISO_q			ASCII_q
#   define	ISO_r			ASCII_r
#   define	ISO_s			ASCII_s
#   define	ISO_t			ASCII_t
#   define	ISO_u			ASCII_u
#   define	ISO_v			ASCII_v
#   define	ISO_w			ASCII_w

#   define	ISO_x			ASCII_x
#   define	ISO_y			ASCII_y
#   define	ISO_z			ASCII_z
#   define	ISO_braceleft		ASCII_braceleft
#   define	ISO_bar			ASCII_bar
#   define	ISO_braceright		ASCII_braceright
#   define	ISO_asciitilde		ASCII_tilde
#   define	ISO_del			ASCII_del

#   define	ISO_dotlessi		0x90	/*  0220	*/
#   define	ISO_grave		0x91
#   define	ISO_acute		0x92
#   define	ISO_circumflex		0x93
#   define	ISO_tilde		0x94
/*#   define	ISO_dieresis		0x95*/
#   define	ISO_breve		0x96
#   define	ISO_dotaccent		0x97

#   define	ISO_dieresis		0x98	/*  0230	*/
/*0231=0x99*/
#   define	ISO_ring		0x9a
/*#   define	ISO_cedilla		0x9b*/
/*0234=0x9c*/
#   define	ISO_hungarumlaut	0x9d
#   define	ISO_ogonek		0x9e
#   define	ISO_caron		0x9f

/*0240*/
#   define	ISO_exclamdown		0xa1
#   define	ISO_cent		0xa2
#   define	ISO_sterling		0xa3
#   define	ISO_currency		0xa4
#   define	ISO_yen			0xa5
#   define	ISO_brokenbar		0xa6
#   define	ISO_section		0xa7

/*#   define	ISO_dieresis		0xa8	/ *  0250	*/
#   define	ISO_copyright		0xa9
#   define	ISO_ordfeminine		0xaa
#   define	ISO_guillemotleft	0xab
#   define	ISO_logicalnot		0xac
#   define	ISO_hyphen		0xad
#   define	ISO_registered		0xae
#   define	ISO_macron		0xaf

#   define	ISO_degree		0xb0	/* 0260		*/
#   define	ISO_plusminus		0xb1
#   define	ISO_twosuperior		0xb2
#   define	ISO_threesuperior	0xb3
#   define	ISO_acute_ALSO		0xb4
#   define	ISO_mu			0xb5
#   define	ISO_paragraph		0xb6
#   define	ISO_periodcentered	0xb7

#   define	ISO_cedilla		0xb8
#   define	ISO_onesuperior		0xb9
#   define	ISO_ordmasculine	0xba
#   define	ISO_guillemotright	0xbb
#   define	ISO_onequarter		0xbc
#   define	ISO_onehalf		0xbd
#   define	ISO_threequarters	0xbe
#   define	ISO_questiondown	0xbf

#   define	ISO_Agrave		0xc0
#   define	ISO_Aacute		0xc1
#   define	ISO_Acircumflex		0xc2
#   define	ISO_Atilde		0xc3
#   define	ISO_Adieresis		0xc4
#   define	ISO_Aring		0xc5
#   define	ISO_AE			0xc6
#   define	ISO_Ccedilla		0xc7

#   define	ISO_agrave		( ISO_Agrave+		0x20 )
#   define	ISO_aacute		( ISO_Aacute+		0x20 )
#   define	ISO_acircumflex		( ISO_Acircumflex+	0x20 )
#   define	ISO_atilde		( ISO_Atilde+		0x20 )
#   define	ISO_adieresis		( ISO_Adieresis+	0x20 )
#   define	ISO_aring		( ISO_Aring+		0x20 )
#   define	ISO_ae			( ISO_AE+		0x20 )
#   define	ISO_ccedilla		( ISO_Ccedilla+		0x20 )

#   define	ISO_Egrave		0xc8
#   define	ISO_Eacute		0xc9
#   define	ISO_Ecircumflex		0xca
#   define	ISO_Edieresis		0xcb
#   define	ISO_Igrave		0xcc
#   define	ISO_Iacute		0xcd
#   define	ISO_Icircumflex		0xce
#   define	ISO_Idieresis		0xcf

#   define	ISO_egrave		( ISO_Egrave+		0x20 )
#   define	ISO_eacute		( ISO_Eacute+		0x20 )
#   define	ISO_ecircumflex		( ISO_Ecircumflex+	0x20 )
#   define	ISO_edieresis		( ISO_Edieresis+	0x20 )
#   define	ISO_igrave		( ISO_Igrave+		0x20 )
#   define	ISO_iacute		( ISO_Iacute+		0x20 )
#   define	ISO_icircumflex		( ISO_Icircumflex+	0x20 )
#   define	ISO_idieresis		( ISO_Idieresis+	0x20 )

#   define	ISO_Eth			0xd0
#   define	ISO_Ntilde		0xd1
#   define	ISO_Ograve		0xd2
#   define	ISO_Oacute		0xd3
#   define	ISO_Ocircumflex		0xd4
#   define	ISO_Otilde		0xd5
#   define	ISO_Odieresis		0xd6
#   define	ISO_multiply		0xd7

#   define	ISO_eth			( ISO_Eth+		0x20 )
#   define	ISO_ntilde		( ISO_Ntilde+		0x20 )
#   define	ISO_ograve		( ISO_Ograve+		0x20 )
#   define	ISO_oacute		( ISO_Oacute+		0x20 )
#   define	ISO_ocircumflex		( ISO_Ocircumflex+	0x20 )
#   define	ISO_otilde		( ISO_Otilde+		0x20 )
#   define	ISO_odieresis		( ISO_Odieresis+	0x20 )
#   define	ISO_divide		( ISO_multiply+		0x20 )

#   define	ISO_Oslash		0xd8
#   define	ISO_Ugrave		0xd9
#   define	ISO_Uacute		0xda
#   define	ISO_Ucircumflex		0xdb
#   define	ISO_Udieresis		0xdc
#   define	ISO_Yacute		0xdd
#   define	ISO_Thorn		0xde
#   define	ISO_germandbls		0xdf

#   define	ISO_oslash		( ISO_Oslash+		0x20 )
#   define	ISO_ugrave		( ISO_Ugrave+		0x20 )
#   define	ISO_uacute		( ISO_Uacute+		0x20 )
#   define	ISO_ucircumflex		( ISO_Ucircumflex+	0x20 )
#   define	ISO_udieresis		( ISO_Udieresis+	0x20 )
#   define	ISO_yacute		( ISO_Yacute+		0x20 )
#   define	ISO_thorn		( ISO_Thorn+		0x20 )
#   define	ISO_ydieresis		( ISO_germandbls+	0x20 )

#   define	ISO_isupper(c)	((ASCII_isupper((c)))||\
				  ((c)>=ISO_Agrave&&(c)<=ISO_Odieresis)||\
				  ((c)>=ISO_Oslash&&(c)<=ISO_germandbls))
#   define	ISO_islower(c)	((ASCII_islower((c)))||\
				  ((c)>=ISO_germandbls&&(c)<=ISO_odieresis)||\
				  ((c)>=ISO_oslash&&(c)<=ISO_ydieresis))
#   define	ISO_isalpha(c)	(ISO_isupper((c))||ISO_islower((c)))
#   define	ISO_tolower(c)	(((ISO_isupper(c)&&(c)!=ISO_germandbls))?\
				    ((c)+0x20):(c))
#   define	ISO_toupper(c)	(((ISO_islower(c)&&(c)!=ISO_germandbls))?\
				    ((c)-0x20):(c))

/************************************************************************/
/*  Adobe Postscript Standard encoding.					*/
/************************************************************************/
#   define	PS_space		ASCII_space
#   define	PS_exclam		ASCII_exclam
#   define	PS_quotedbl		ASCII_quotedbl
#   define	PS_numbersign		ASCII_numbersign
#   define	PS_dollar		ASCII_dollar
#   define	PS_percent		ASCII_percent
#   define	PS_ampersand		ASCII_ampersand
#   define	PS_quoteright		ASCII_quoteright

#   define	PS_parenleft		ASCII_parenleft
#   define	PS_parenright		ASCII_parenright
#   define	PS_asterisk		ASCII_asterisk
#   define	PS_plus			ASCII_plus
#   define	PS_comma		ASCII_comma
#   define	PS_minus		ASCII_minus
#   define	PS_period		ASCII_period
#   define	PS_slash		ASCII_slash

#   define	PS_zero			ASCII_zero
#   define	PS_one			ASCII_one
#   define	PS_two			ASCII_two
#   define	PS_three		ASCII_three
#   define	PS_four			ASCII_four
#   define	PS_five			ASCII_five
#   define	PS_six			ASCII_six
#   define	PS_seven		ASCII_seven

#   define	PS_eight		ASCII_eight
#   define	PS_nine			ASCII_nine
#   define	PS_colon		ASCII_colon
#   define	PS_semicolon		ASCII_semicolon
#   define	PS_less			ASCII_less
#   define	PS_equal		ASCII_equal
#   define	PS_greater		ASCII_greater
#   define	PS_question		ASCII_question

#   define	PS_at			ASCII_at
#   define	PS_A			ASCII_A
#   define	PS_B			ASCII_B
#   define	PS_C			ASCII_C
#   define	PS_D			ASCII_D
#   define	PS_E			ASCII_E
#   define	PS_F			ASCII_F
#   define	PS_G			ASCII_G

#   define	PS_H			ASCII_H
#   define	PS_I			ASCII_I
#   define	PS_J			ASCII_J
#   define	PS_K			ASCII_K
#   define	PS_L			ASCII_L
#   define	PS_M			ASCII_M
#   define	PS_N			ASCII_N
#   define	PS_O			ASCII_O

#   define	PS_P			ASCII_P
#   define	PS_Q			ASCII_Q
#   define	PS_R			ASCII_R
#   define	PS_S			ASCII_S
#   define	PS_T			ASCII_T
#   define	PS_U			ASCII_U
#   define	PS_V			ASCII_V
#   define	PS_W			ASCII_W

#   define	PS_X			ASCII_X
#   define	PS_Y			ASCII_Y
#   define	PS_Z			ASCII_Z
#   define	PS_bracketleft		ASCII_bracketleft
#   define	PS_backslash		ASCII_backslash
#   define	PS_bracketright		ASCII_bracketright
#   define	PS_asciicircum		ASCII_circumflex
#   define	PS_underscore		ASCII_underscore

#   define	PS_quoteleft		ASCII_quoteleft
#   define	PS_a			ASCII_a
#   define	PS_b			ASCII_b
#   define	PS_c			ASCII_c
#   define	PS_d			ASCII_d
#   define	PS_e			ASCII_e
#   define	PS_f			ASCII_f
#   define	PS_g			ASCII_g

#   define	PS_h			ASCII_h
#   define	PS_i			ASCII_i
#   define	PS_j			ASCII_j
#   define	PS_k			ASCII_k
#   define	PS_l			ASCII_l
#   define	PS_m			ASCII_m
#   define	PS_n			ASCII_n
#   define	PS_o			ASCII_o

#   define	PS_p			ASCII_p
#   define	PS_q			ASCII_q
#   define	PS_r			ASCII_r
#   define	PS_s			ASCII_s
#   define	PS_t			ASCII_t
#   define	PS_u			ASCII_u
#   define	PS_v			ASCII_v
#   define	PS_w			ASCII_w

#   define	PS_x			ASCII_x
#   define	PS_y			ASCII_y
#   define	PS_z			ASCII_z
#   define	PS_braceleft		ASCII_braceleft
#   define	PS_bar			ASCII_bar
#   define	PS_braceright		ASCII_braceright
#   define	PS_asciitilde		ASCII_tilde
/*0x7f*/

/*0200*/
/*0201*/
/*0202*/
/*0203*/
/*0204*/
/*0205*/
/*0206*/
/*0207*/

/*0210*/
/*0211*/
/*0212*/
/*0213*/
/*0214*/
/*0215*/
/*0216*/
/*0217*/

/*0220*/
/*0221*/
/*0222*/
/*0223*/
/*0224*/
/*0225*/
/*0226*/
/*0227*/

/*0230*/
/*0231*/
/*0232*/
/*0233*/
/*0234*/
/*0235*/
/*0236*/
/*0237*/

/*0240*/
#   define	PS_exclamdown		0xa1
#   define	PS_cent			0xa2
#   define	PS_sterling		0xa3
#   define	PS_fraction		0xa4
#   define	PS_yen			0xa5
#   define	PS_florin		0xa6
#   define	PS_section		0xa7

#   define	PS_currency		0xa8
#   define	PS_quotesingle		0xa9
#   define	PS_quotedblleft		0xaa
#   define	PS_guillemotleft	0xab
#   define	PS_guillsinglleft	0xac
#   define	PS_guillsinglright	0xad
#   define	PS_fi			0xae
#   define	PS_fl			0xaf

/*0260*/
#   define	PS_endash		0xb1
#   define	PS_dagger		0xb2
#   define	PS_daggerdbl		0xb3
#   define	PS_periodcentered	0xb4
/*0265*/
#   define	PS_paragraph		0xb6
#   define	PS_bullet		0xb7

#   define	PS_quotesinglbase	0xb8
#   define	PS_quotedblbase		0xb9
#   define	PS_quotedblright	0xba
#   define	PS_guillemotright	0xbb
#   define	PS_ellipsis		0xbc
#   define	PS_perthousand		0xbd
/*0276*/
#   define	PS_questiondown		0xbf

/*0300*/
#   define	PS_grave		0xc1
#   define	PS_acute		0xc2
#   define	PS_circumflex		0xc3
#   define	PS_tilde		0xc4
#   define	PS_macron		0xc5
#   define	PS_breve		0xc6
#   define	PS_dotaccent		0xc7

#   define	PS_dieresis		0xc8
/*0311*/
#   define	PS_ring			0xca
#   define	PS_cedilla		0xcb
/*0314*/
#   define	PS_hungarumlaut		0xcd
#   define	PS_ogonek		0xce
#   define	PS_caron		0xcf

#   define	PS_emdash		0xd0
/*0xd1*/
/*0xd2*/
/*0xd3*/
/*0xd4*/
/*0xd5*/
/*0xd6*/
/*0xd7*/

/*0330*/
/*0331*/
/*0332*/
/*0333*/
/*0334*/
/*0335*/
/*0336*/
/*0337*/

/*0xe0=0340*/
#   define	PS_AE			0xe1
/*0xe2*/
#   define	PS_ordfeminine		0xe3
/*0xe*/
/*0xe5*/
/*0xe6*/
/*0xe7*/

#   define	PS_Lslash		0xc8
#   define	PS_Oslash		0xe9
#   define	PS_OE			0xea
#   define	PS_ordmasculine		0xeb
/*0354*/
/*0355*/
/*0356*/
/*0357*/

/*0360*/
#   define	PS_ae			0xf1
/*0362*/
/*0363*/
/*0364*/
#   define	PS_dotlessi		0xf5
/*0366*/
/*0367*/

#   define	PS_lslash		0xf8
#   define	PS_oslash		0xf9
#   define	PS_oe			0xfa
#   define	PS_germandbls		0xfb
/*0374*/
/*0375*/
/*0376*/
/*0377*/

/************************************************************************/
/*  NeXT Postscript encoding.						*/
/************************************************************************/
#   define	NX_nul		ASCII_nul
#   define	NX_soh		ASCII_soh
#   define	NX_stx		ASCII_stx
#   define	NX_etx		ASCII_etx
#   define	NX_eot		ASCII_eot
#   define	NX_enq		ASCII_enq
#   define	NX_ack		ASCII_ack
#   define	NX_bel		ASCII_bel
#   define	NX_bs		ASCII_bs
#   define	NX_ht		ASCII_ht
#   define	NX_nl		ASCII_nl
#   define	NX_vt		ASCII_vt
#   define	NX_np		ASCII_np
#   define	NX_cr		ASCII_cr
#   define	NX_so		ASCII_so
#   define	NX_si		ASCII_si
#   define	NX_dle		ASCII_dle
#   define	NX_dc1		ASCII_dc1
#   define	NX_dc2		ASCII_dc2
#   define	NX_dc3		ASCII_dc3
#   define	NX_dc4		ASCII_dc4
#   define	NX_nak		ASCII_nak
#   define	NX_syn		ASCII_syn
#   define	NX_etb		ASCII_etb
#   define	NX_can		ASCII_can
#   define	NX_em		ASCII_em
#   define	NX_sub		ASCII_sub
#   define	NX_esc		ASCII_esc
#   define	NX_fs		ASCII_fs
#   define	NX_gs		ASCII_gs
#   define	NX_rs		ASCII_rs
#   define	NX_us		ASCII_us

#   define	NX_space	PS_space
#   define	NX_exclam	PS_exclam
#   define	NX_quotedbl	PS_quotedbl
#   define	NX_numbersign	PS_numbersign
#   define	NX_dollar	PS_dollar
#   define	NX_percent	PS_percent
#   define	NX_ampersand	PS_ampersand
#   define	NX_quoteright	PS_quoteright

#   define	NX_parenleft	PS_parenleft
#   define	NX_parenright	PS_parenright
#   define	NX_asterisk	PS_asterisk
#   define	NX_plus		PS_plus
#   define	NX_comma	PS_comma
#   define	NX_minus	PS_minus
#   define	NX_period	PS_period
#   define	NX_slash	PS_slash

#   define	NX_zero		PS_zero
#   define	NX_one		PS_one
#   define	NX_two		PS_two
#   define	NX_three	PS_three
#   define	NX_four		PS_four
#   define	NX_five		PS_five
#   define	NX_six		PS_six
#   define	NX_seven	PS_seven

#   define	NX_eight	PS_eight
#   define	NX_nine		PS_nine
#   define	NX_colon	PS_colon
#   define	NX_semicolon	PS_semicolon
#   define	NX_less		PS_less
#   define	NX_equal	PS_equal
#   define	NX_greater	PS_greater
#   define	NX_question	PS_question

#   define	NX_at		PS_at
#   define	NX_A		PS_A
#   define	NX_B		PS_B
#   define	NX_C		PS_C
#   define	NX_D		PS_D
#   define	NX_E		PS_E
#   define	NX_F		PS_F
#   define	NX_G		PS_G

#   define	NX_H		PS_H
#   define	NX_I		PS_I
#   define	NX_J		PS_J
#   define	NX_K		PS_K
#   define	NX_L		PS_L
#   define	NX_M		PS_M
#   define	NX_N		PS_N
#   define	NX_O		PS_O

#   define	NX_P		PS_P
#   define	NX_Q		PS_Q
#   define	NX_R		PS_R
#   define	NX_S		PS_S
#   define	NX_T		PS_T
#   define	NX_U		PS_U
#   define	NX_V		PS_V
#   define	NX_W		PS_W

#   define	NX_X		PS_X
#   define	NX_Y		PS_Y
#   define	NX_Z		PS_Z
#   define	NX_bracketleft	PS_bracketleft
#   define	NX_backslash	PS_backslash
#   define	NX_bracketright	PS_bracketright
#   define	NX_asciicircum	PS_asciicircum
#   define	NX_underscore	PS_underscore

#   define	NX_quoteleft	PS_quoteleft
#   define	NX_a		PS_a
#   define	NX_b		PS_b
#   define	NX_c		PS_c
#   define	NX_d		PS_d
#   define	NX_e		PS_e
#   define	NX_f		PS_f
#   define	NX_g		PS_g

#   define	NX_h		PS_h
#   define	NX_i		PS_i
#   define	NX_j		PS_j
#   define	NX_k		PS_k
#   define	NX_l		PS_l
#   define	NX_m		PS_m
#   define	NX_n		PS_n
#   define	NX_o		PS_o

#   define	NX_p		PS_p
#   define	NX_q		PS_q
#   define	NX_r		PS_r
#   define	NX_s		PS_s
#   define	NX_t		PS_t
#   define	NX_u		PS_u
#   define	NX_v		PS_v
#   define	NX_w		PS_w

#   define	NX_x		PS_x
#   define	NX_y		PS_y
#   define	NX_z		PS_z
#   define	NX_braceleft	PS_braceleft
#   define	NX_bar		PS_bar
#   define	NX_braceright	PS_braceright
#   define	NX_asciitilde	PS_asciitilde
#   define	NX_del		ASCII_del

/*0200*/
#   define	NX_Agrave		0x81
#   define	NX_Aacute		0x82
#   define	NX_Acircumflex		0x83
#   define	NX_Atilde		0x84
#   define	NX_Adieresis		0x85
#   define	NX_Aring		0x86
#   define	NX_Ccedilla		0x87

#   define	NX_Egrave		0x88
#   define	NX_Eacute		0x89
#   define	NX_Ecircumflex		0x8a
#   define	NX_Edieresis		0x8b
#   define	NX_Igrave		0x8c
#   define	NX_Iacute		0x8d
#   define	NX_Icircumflex		0x8e
#   define	NX_Idieresis		0x8f

#   define	NX_Eth			0x90
#   define	NX_Ntilde		0x91
#   define	NX_Ograve		0x92
#   define	NX_Oacute		0x93
#   define	NX_Ocircumflex		0x94
#   define	NX_Otilde		0x95
#   define	NX_Odieresis		0x96
#   define	NX_Ugrave		0x97

#   define	NX_Uacute		0x98
#   define	NX_Ucircumflex		0x99
#   define	NX_Udieresis		0x9a
#   define	NX_Yacute		0x9b
#   define	NX_Thorn		0x9c
#   define	NX_mu			0x9d
#   define	NX_multiply		0x9e
#   define	NX_divide		0x9f

#   define	NX_copyright		0xa0
#   define	NX_exclamdown		PS_exclamdown
#   define	NX_cent			PS_cent
#   define	NX_sterling		PS_sterling
#   define	NX_fraction		PS_fraction
#   define	NX_yen			PS_yen
#   define	NX_florin		PS_florin
#   define	NX_section		PS_section

#   define	NX_currency		PS_currency
#   define	NX_quotesingle		PS_quotesingle
#   define	NX_quotedblleft		PS_quotednlleft
#   define	NX_guillemotleft	PS_guillemotleft
#   define	NX_guillsinglleft	PS_guillsinglleft
#   define	NX_guillsinglright	PS_guillsinglright
#   define	NX_fi			PS_fi
#   define	NX_fl			PS_fl

#   define	NX_registered		0xb0
#   define	NX_endash		PS_endash
#   define	NX_dagger		PS_dagger
#   define	NX_daggerdbl		PS_daggerdbl
#   define	NX_periodcentered	PS_periodcentered
#   define	NX_brokenbar		0xb5
#   define	NX_paragraph		PS_paragraph
#   define	NX_bullet		PS_bullet

#   define	NX_quotesinglbase	PS_quotesinglbase
#   define	NX_quotedblbase		PS_quotedblbase
#   define	NX_quotedblright	PS_quotedblright
#   define	NX_guillemotright	PS_guillemotright
#   define	NX_ellipsis		PS_ellipsis
#   define	NX_perthousand		PS_perthousand
#   define	NX_logicalnot		0xbe
#   define	NX_questiondown		PS_questiondown

#   define	NX_onesuperior		0xc0
#   define	NX_grave		PS_grave
#   define	NX_acute		PS_acute
#   define	NX_circumflex		PS_circumflex
#   define	NX_tilde		PS_tilde
#   define	NX_macron		PS_macron
#   define	NX_breve		PS_breve
#   define	NX_dotaccent		PS_dotaccent

#   define	NX_dieresis		PS_dieresis
#   define	NX_twosuperior		0311
#   define	NX_ring			PS_ring
#   define	NX_cedilla		PS_cedilla
#   define	NX_threesuperior	0314
#   define	NX_hungarumlaut		PS_hungarumlaut
#   define	NX_ogonek		PS_ogonek
#   define	NX_caron		PS_caron

#   define	NX_emdash		PS_emdash
#   define	NX_plusminus		0xd1
#   define	NX_onequarter		0xd2
#   define	NX_onehalf		0xd3
#   define	NX_threequarters	0xd4
#   define	NX_agrave		0xd5
#   define	NX_aacute		0xd6
#   define	NX_acircumflex		0xd7

#   define	NX_atilde		0xd8
#   define	NX_adieresis		0xd9
#   define	NX_aring		0xda
#   define	NX_ccedilla		0xdb
#   define	NX_egrave		0xdc
#   define	NX_eacute		0xdd
#   define	NX_ecircumflex		0xde
#   define	NX_edieresis		0xdf

#   define	NX_igrave		0xe0
#   define	NX_AE			PS_AE
#   define	NX_iacute		0xe2
#   define	NX_ordfeminine		PS_ordfeminine
#   define	NX_icircumflex		0xe4
#   define	NX_idieresis		0xe5
#   define	NX_eth			0xe6
#   define	NX_ntilde		0xe7

#   define	NX_Lslash		PS_Lslash
#   define	NX_Oslash		PS_Oslash
#   define	NX_OE			PS_OE
#   define	NX_ordmasculine		PS_ordmasculine
#   define	NX_ograve		0xec
#   define	NX_oacute		0xed
#   define	NX_ocircumflex		0xee
#   define	NX_otilde		0xef

#   define	NX_odieresis		0xf0
#   define	NX_ae			PS_ae
#   define	NX_ugrave		0xf2
#   define	NX_uacute		0xf3
#   define	NX_ucircumflex		0xf4
#   define	NX_dotlessi		PS_dotlessi
#   define	NX_udieresis		0xf6
#   define	NX_yacute		0xf7

#   define	NX_lslash		PS_lslash
#   define	NX_oslash		PS_oslash
#   define	NX_oe			PS_oe
#   define	NX_germandbls		PS_germandbls
#   define	NX_thorn		0xfc
#   define	NX_ydieresis		0xfd
/*0376*/
/*0377*/

/************************************************************************/
/*  EBCDIC as used by the IBM 3270 series terminals.			*/
/************************************************************************/
#   define	EBCDIC_space		0x40
#   define	EBCDIC_0x41		0x41	/*  Non breaking space	*/
#   define	EBCDIC_acircumflex	0x42
#   define	EBCDIC_adieresis	0x43
#   define	EBCDIC_agrave		0x44
#   define	EBCDIC_aacute		0x45
#   define	EBCDIC_atilde		0x46
#   define	EBCDIC_a_XXX		0x47
#   define	EBCDIC_c_XXX		0x48
#   define	EBCDIC_ntilde		0x49
#   define	EBCDIC_cent		0x4a
#   define	EBCDIC_period		0x4b
#   define	EBCDIC_less		0x4c
#   define	EBCDIC_parenleft	0x4d
#   define	EBCDIC_plus		0x4e
#   define	EBCDIC_bar		0x4f
#   define	EBCDIC_ampersand	0x50
#   define	EBCDIC_eacute		0x51
#   define	EBCDIC_ecircumflex	0x52
#   define	EBCDIC_edieresis	0x53
#   define	EBCDIC_egrave		0x54
#   define	EBCDIC_iacute		0x55
#   define	EBCDIC_icircumflex	0x56
#   define	EBCDIC_idieresis	0x57
#   define	EBCDIC_igrave		0x58
#   define	EBCDIC_germandbls	0x59
#   define	EBCDIC_exclam		0x5a
#   define	EBCDIC_dollar		0x5b
#   define	EBCDIC_asterisk		0x5c
#   define	EBCDIC_parenright	0x5d
#   define	EBCDIC_semicolon	0x5e
#   define	EBCDIC_logicalnot	0x5f
#   define	EBCDIC_minus		0x60
#   define	EBCDIC_slash		0x61
#   define	EBCDIC_Acircumflex	0x62
#   define	EBCDIC_Adieresis	0x63
#   define	EBCDIC_Agrave		0x64
#   define	EBCDIC_Aacute		0x65
#   define	EBCDIC_Atilde		0x66
#   define	EBCDIC_Aring		0x67
#   define	EBCDIC_Ccedilla		0x68
#   define	EBCDIC_Ntilde		0x69
#   define	EBCDIC_brokenbar	0x6a
#   define	EBCDIC_comma		0x6b
#   define	EBCDIC_percent		0x6c
#   define	EBCDIC_underscore	0x6d
#   define	EBCDIC_greater		0x6e
#   define	EBCDIC_question		0x6f
#   define	EBCDIC_oslash		0x70
#   define	EBCDIC_Eacute		0x71
#   define	EBCDIC_Ecircumflex	0x72
#   define	EBCDIC_Edieresis	0x73
#   define	EBCDIC_Egrave		0x74
#   define	EBCDIC_Iacute		0x75
#   define	EBCDIC_Icircumflex	0x76
#   define	EBCDIC_Idieresis	0x77
#   define	EBCDIC_Igrave		0x78
#   define	EBCDIC_grave		0x79
#   define	EBCDIC_colon		0x7a
#   define	EBCDIC_numbersign	0x7b
#   define	EBCDIC_at		0x7c
#   define	EBCDIC_quotesingle	0x7d
#   define	EBCDIC_equal		0x7e
#   define	EBCDIC_quoteddbl	0x7f
#   define	EBCDIC_Oslash		0x80
#   define	EBCDIC_a		0x81
#   define	EBCDIC_b		0x82
#   define	EBCDIC_c		0x83
#   define	EBCDIC_d		0x84
#   define	EBCDIC_e		0x85
#   define	EBCDIC_f		0x86
#   define	EBCDIC_g		0x87
#   define	EBCDIC_h		0x88
#   define	EBCDIC_i		0x89
#   define	EBCDIC_guillemotleft	0x8a
#   define	EBCDIC_guillemotright	0x8b
#   define	EBCDIC_eth		0x8c
#   define	EBCDIC_yacute		0x8d
#   define	EBCDIC_thorn		0x8e
#   define	EBCDIC_plusminus	0x8f
#   define	EBCDIC_degree		0x90
#   define	EBCDIC_j		0x91
#   define	EBCDIC_k		0x92
#   define	EBCDIC_l		0x93
#   define	EBCDIC_m		0x94
#   define	EBCDIC_n		0x95
#   define	EBCDIC_o		0x96
#   define	EBCDIC_p		0x97
#   define	EBCDIC_q		0x98
#   define	EBCDIC_r		0x99
#   define	EBCDIC_ordfeminine	0x9a
#   define	EBCDIC_ordmasculine	0x9b
#   define	EBCDIC_ae		0x9c
#   define	EBCDIC_cedilla		0x9d
#   define	EBCDIC_AE		0x9e
#   define	EBCDIC_currency		0x9f
#   define	EBCDIC_mu		0xa0
#   define	EBCDIC_tilde		0xa1
#   define	EBCDIC_s		0xa2
#   define	EBCDIC_t		0xa3
#   define	EBCDIC_u		0xa4
#   define	EBCDIC_v		0xa5
#   define	EBCDIC_w		0xa6
#   define	EBCDIC_x		0xa7
#   define	EBCDIC_y		0xa8
#   define	EBCDIC_z		0xa9
#   define	EBCDIC_exclamdown	0xaa
#   define	EBCDIC_questiondown	0xab
#   define	EBCDIC_Eth		0xac
#   define	EBCDIC_Yacute		0xad
#   define	EBCDIC_Thorn		0xae
#   define	EBCDIC_registered	0xaf
#   define	EBCDIC_circumflex	0xb0
#   define	EBCDIC_sterling		0xb1
#   define	EBCDIC_yen		0xb2
#   define	EBCDIC_dotcentered	0xb3
#   define	EBCDIC_copyright	0xb4
#   define	EBCDIC_section		0xb5
#   define	EBCDIC_paragraph	0xb6
#   define	EBCDIC_onequarter	0xb7
#   define	EBCDIC_onehalf		0xb8
#   define	EBCDIC_threequarters	0xb9
#   define	EBCDIC_bracketleft	0xba
#   define	EBCDIC_bracketright	0xbb
#   define	EBCDIC_overscore	0xbc /**/
#   define	EBCDIC_dieresis		0xbd
#   define	EBCDIC_acute		0xbe
#   define	EBCDIC_multiply		0xbf
#   define	EBCDIC_braceleft	0xc0
#   define	EBCDIC_A		0xc1
#   define	EBCDIC_B		0xc2
#   define	EBCDIC_C		0xc3
#   define	EBCDIC_D		0xc4
#   define	EBCDIC_E		0xc5
#   define	EBCDIC_F		0xc6
#   define	EBCDIC_G		0xc7
#   define	EBCDIC_H		0xc8
#   define	EBCDIC_I		0xc9
#   define	EBCDIC_hyphen		0xca
#   define	EBCDIC_ocircumflex	0xcb
#   define	EBCDIC_odieresis	0xcc
#   define	EBCDIC_ograve		0xcd
#   define	EBCDIC_oacute		0xce
#   define	EBCDIC_otilde		0xcf
#   define	EBCDIC_braceright	0xd0
#   define	EBCDIC_J		0xd1
#   define	EBCDIC_K		0xd2
#   define	EBCDIC_L		0xd3
#   define	EBCDIC_M		0xd4
#   define	EBCDIC_N		0xd5
#   define	EBCDIC_O		0xd6
#   define	EBCDIC_P		0xd7
#   define	EBCDIC_Q		0xd8
#   define	EBCDIC_R		0xd9
#   define	EBCDIC_onesuperior	0xda
#   define	EBCDIC_ucircumflex	0xdb
#   define	EBCDIC_udieresis	0xdc
#   define	EBCDIC_ugrave		0xdd
#   define	EBCDIC_uacute		0xde
#   define	EBCDIC_ydieresis	0xdf
#   define	EBCDIC_backslash	0xe0
#   define	EBCDIC_divide		0xe1
#   define	EBCDIC_S		0xe2
#   define	EBCDIC_T		0xe3
#   define	EBCDIC_U		0xe4
#   define	EBCDIC_V		0xe5
#   define	EBCDIC_W		0xe6
#   define	EBCDIC_X		0xe7
#   define	EBCDIC_Y		0xe8
#   define	EBCDIC_Z		0xe9
#   define	EBCDIC_twosuperior	0xea
#   define	EBCDIC_Ocircumflex	0xeb
#   define	EBCDIC_Odieresis	0xec
#   define	EBCDIC_Ograve		0xed
#   define	EBCDIC_Oacute		0xee
#   define	EBCDIC_Otilde		0xef
#   define	EBCDIC_zero		0xf0
#   define	EBCDIC_one		0xf1
#   define	EBCDIC_two		0xf2
#   define	EBCDIC_three		0xf3
#   define	EBCDIC_four		0xf4
#   define	EBCDIC_five		0xf5
#   define	EBCDIC_six		0xf6
#   define	EBCDIC_seven		0xf7
#   define	EBCDIC_eight		0xf8
#   define	EBCDIC_nine		0xf9
#   define	EBCDIC_threesuperior	0xfa
#   define	EBCDIC_Ucircumflex	0xfb
#   define	EBCDIC_Udieresis	0xfc
#   define	EBCDIC_Ugrave		0xfd
#   define	EBCDIC_Uacute		0xfe
#   define	EBCDIC_OE		0xff

/************************************************************************/
/*  Code page 437 'English' of MS-DOS 5.0.				*/
/************************************************************************/
#   define	DOS437_nul		ASCII_nul
#   define	DOS437_soh		ASCII_soh
#   define	DOS437_stx		ASCII_stx
#   define	DOS437_etx		ASCII_etx
#   define	DOS437_eot		ASCII_eot
#   define	DOS437_enq		ASCII_enq
#   define	DOS437_ack		ASCII_ack
#   define	DOS437_bel		ASCII_bel

#   define	DOS437_bs		ASCII_bs
#   define	DOS437_ht		ASCII_ht
#   define	DOS437_nl		ASCII_nl
#   define	DOS437_vt		ASCII_vt
#   define	DOS437_np		ASCII_np
#   define	DOS437_cr		ASCII_cr
#   define	DOS437_so		ASCII_so
#   define	DOS437_si		ASCII_si

#   define	DOS437_dle		ASCII_dle
#   define	DOS437_dc1		ASCII_dc1
#   define	DOS437_dc2		ASCII_dc2
#   define	DOS437_dc3		ASCII_dc3
#   define	DOS437_dc4		ASCII_dc4
#   define	DOS437_nak		ASCII_nak
#   define	DOS437_syn		ASCII_syn
#   define	DOS437_etb		ASCII_etb

#   define	DOS437_can		ASCII_can
#   define	DOS437_em		ASCII_em
#   define	DOS437_sub		ASCII_sub
#   define	DOS437_esc		ASCII_esc
#   define	DOS437_fs		ASCII_fs
#   define	DOS437_gs		ASCII_gs
#   define	DOS437_rs		ASCII_rs
#   define	DOS437_us		ASCII_us

#   define	DOS437_space		ASCII_space
#   define	DOS437_exclam		ASCII_exclam
#   define	DOS437_quotedbl		ASCII_quotedbl
#   define	DOS437_numbersign	ASCII_numbersign
#   define	DOS437_dollar		ASCII_dollar
#   define	DOS437_percent		ASCII_percent
#   define	DOS437_ampersand	ASCII_ampersand
#   define	DOS437_quoteright	ASCII_quoteright

#   define	DOS437_parenleft	ASCII_parenleft
#   define	DOS437_parenright	ASCII_parenright
#   define	DOS437_asterisk		ASCII_asterisk
#   define	DOS437_plus		ASCII_plus
#   define	DOS437_comma		ASCII_comma
#   define	DOS437_minus		ASCII_minus
#   define	DOS437_period		ASCII_period
#   define	DOS437_slash		ASCII_slash

#   define	DOS437_zero		ASCII_zero
#   define	DOS437_one		ASCII_one
#   define	DOS437_two		ASCII_two
#   define	DOS437_three		ASCII_three
#   define	DOS437_four		ASCII_four
#   define	DOS437_five		ASCII_five
#   define	DOS437_six		ASCII_six
#   define	DOS437_seven		ASCII_seven

#   define	DOS437_eight		ASCII_eight
#   define	DOS437_nine		ASCII_nine
#   define	DOS437_colon		ASCII_colon
#   define	DOS437_semicolon	ASCII_semicolon
#   define	DOS437_less		ASCII_less
#   define	DOS437_equal		ASCII_equal
#   define	DOS437_greater		ASCII_greater
#   define	DOS437_question		ASCII_question

#   define	DOS437_at		ASCII_at
#   define	DOS437_A		ASCII_A
#   define	DOS437_B		ASCII_B
#   define	DOS437_C		ASCII_C
#   define	DOS437_D		ASCII_D
#   define	DOS437_E		ASCII_E
#   define	DOS437_F		ASCII_F
#   define	DOS437_G		ASCII_G

#   define	DOS437_H		ASCII_H
#   define	DOS437_I		ASCII_I
#   define	DOS437_J		ASCII_J
#   define	DOS437_K		ASCII_K
#   define	DOS437_L		ASCII_L
#   define	DOS437_M		ASCII_M
#   define	DOS437_N		ASCII_N
#   define	DOS437_O		ASCII_O

#   define	DOS437_P		ASCII_P
#   define	DOS437_Q		ASCII_Q
#   define	DOS437_R		ASCII_R
#   define	DOS437_S		ASCII_S
#   define	DOS437_T		ASCII_T
#   define	DOS437_U		ASCII_U
#   define	DOS437_V		ASCII_V
#   define	DOS437_W		ASCII_W

#   define	DOS437_X		ASCII_X
#   define	DOS437_Y		ASCII_Y
#   define	DOS437_Z		ASCII_Z
#   define	DOS437_bracketleft	ASCII_bracketleft
#   define	DOS437_backslash	ASCII_backslash
#   define	DOS437_bracketright	ASCII_bracketright
#   define	DOS437_asciicircum	ASCII_circumflex
#   define	DOS437_underscore	ASCII_underscore

#   define	DOS437_quoteleft	ASCII_quoteleft
#   define	DOS437_a		ASCII_a
#   define	DOS437_b		ASCII_b
#   define	DOS437_c		ASCII_c
#   define	DOS437_d		ASCII_d
#   define	DOS437_e		ASCII_e
#   define	DOS437_f		ASCII_f
#   define	DOS437_g		ASCII_g

#   define	DOS437_h		ASCII_h
#   define	DOS437_i		ASCII_i
#   define	DOS437_j		ASCII_j
#   define	DOS437_k		ASCII_k
#   define	DOS437_l		ASCII_l
#   define	DOS437_m		ASCII_m
#   define	DOS437_n		ASCII_n
#   define	DOS437_o		ASCII_o

#   define	DOS437_p		ASCII_p
#   define	DOS437_q		ASCII_q
#   define	DOS437_r		ASCII_r
#   define	DOS437_s		ASCII_s
#   define	DOS437_t		ASCII_t
#   define	DOS437_u		ASCII_u
#   define	DOS437_v		ASCII_v
#   define	DOS437_w		ASCII_w

#   define	DOS437_x		ASCII_x
#   define	DOS437_y		ASCII_y
#   define	DOS437_z		ASCII_z
#   define	DOS437_braceleft	ASCII_braceleft
#   define	DOS437_bar		ASCII_bar
#   define	DOS437_braceright	ASCII_braceright
#   define	DOS437_asciitilde	ASCII_tilde
#   define	DOS437_del		ASCII_del

#   define	DOS437_Ccedilla		128
#   define	DOS437_udieresis	129
#   define	DOS437_eacute		130
#   define	DOS437_acircumflex	131
#   define	DOS437_adieresis	132
#   define	DOS437_agrave		133
#   define	DOS437_aring		134
#   define	DOS437_ccedilla		135

#   define	DOS437_ecircumflex	136
#   define	DOS437_edieresis	137
#   define	DOS437_egrave		138
#   define	DOS437_idieresis	139
#   define	DOS437_icircumflex	140
#   define	DOS437_igrave		141
#   define	DOS437_Adieresis	142
#   define	DOS437_Aring		143

#   define	DOS437_Eacute		144
#   define	DOS437_ae		145
#   define	DOS437_AE		146
#   define	DOS437_ocircumflex	147
#   define	DOS437_odieresis	148
#   define	DOS437_ograve		149
#   define	DOS437_ucircumflex	150
#   define	DOS437_ugrave		151

#   define	DOS437_ydieresis	152
#   define	DOS437_Odieresis	153
#   define	DOS437_Udieresis	154
#   define	DOS437_cent		155
#   define	DOS437_sterling		156
#   define	DOS437_yen		157
#   define	DOS437_0x9e		158	/* peseta sign UNICODE 20a7 */
#   define	DOS437_florin		159

#   define	DOS437_aacute		160
#   define	DOS437_iacute		161
#   define	DOS437_oacute		162
#   define	DOS437_uacute		163
#   define	DOS437_ntilde		164
#   define	DOS437_Ntilde		165
#   define	DOS437_ordfeminine	166
#   define	DOS437_ordmasculine	167

#   define	DOS437_questiondown	168
#   define	DOS437_0xa9		169 	/*  reversed not UNICODE 2310 */
#   define	DOS437_logicalnot	170
#   define	DOS437_onehalf		171
#   define	DOS437_onequarter	172
#   define	DOS437_exclamdown	173
#   define	DOS437_guillemotleft	174
#   define	DOS437_guillemotright	175

#   define	DOS437_0xb0		176	/*  Line drawing	*/
#   define	DOS437_0xb1		177	/*  Line drawing	*/
#   define	DOS437_0xb2		178	/*  Line drawing	*/
#   define	DOS437_0xb3		179	/*  Line drawing	*/
#   define	DOS437_0xb4		180	/*  Line drawing	*/
#   define	DOS437_0xb5		181	/*  Line drawing	*/
#   define	DOS437_0xb6		182	/*  Line drawing	*/
#   define	DOS437_0xb7		183	/*  Line drawing	*/

#   define	DOS437_0xb8		184	/*  Line drawing	*/
#   define	DOS437_0xb9		185	/*  Line drawing	*/
#   define	DOS437_0xba		186	/*  Line drawing	*/
#   define	DOS437_0xbb		187	/*  Line drawing	*/
#   define	DOS437_0xbc		188	/*  Line drawing	*/
#   define	DOS437_0xbd		189	/*  Line drawing	*/
#   define	DOS437_0xbe		190	/*  Line drawing	*/
#   define	DOS437_0xbf		191	/*  Line drawing	*/

#   define	DOS437_0xc0		192	/*  Line drawing	*/
#   define	DOS437_0xc1		193	/*  Line drawing	*/
#   define	DOS437_0xc2		194	/*  Line drawing	*/
#   define	DOS437_0xc3		195	/*  Line drawing	*/
#   define	DOS437_0xc4		196	/*  Line drawing	*/
#   define	DOS437_0xc5		197	/*  Line drawing	*/
#   define	DOS437_0xc6		198	/*  Line drawing	*/
#   define	DOS437_0xc7		199	/*  Line drawing	*/

#   define	DOS437_0xc8		200	/*  Line drawing	*/
#   define	DOS437_0xc9		201	/*  Line drawing	*/
#   define	DOS437_0xca		202	/*  Line drawing	*/
#   define	DOS437_0xcb		203	/*  Line drawing	*/
#   define	DOS437_0xcc		204	/*  Line drawing	*/
#   define	DOS437_0xcd		205	/*  Line drawing	*/
#   define	DOS437_0xce		206	/*  Line drawing	*/
#   define	DOS437_0xcf		207	/*  Line drawing	*/

#   define	DOS437_0xd0		208	/*  Line drawing	*/
#   define	DOS437_0xd1		209	/*  Line drawing	*/
#   define	DOS437_0xd2		210	/*  Line drawing	*/
#   define	DOS437_0xd3		211	/*  Line drawing	*/
#   define	DOS437_0xd4		212	/*  Line drawing	*/
#   define	DOS437_0xd5		213	/*  Line drawing	*/
#   define	DOS437_0xd6		214	/*  Line drawing	*/
#   define	DOS437_0xd7		215	/*  Line drawing	*/

#   define	DOS437_0xd8		216	/*  Line drawing	*/
#   define	DOS437_0xd9		217	/*  Line drawing	*/
#   define	DOS437_0xda		218	/*  Line drawing	*/
#   define	DOS437_0xdb		219	/*  Line drawing	*/
#   define	DOS437_0xdc		220	/*  Line drawing	*/
#   define	DOS437_0xdd		221	/*  Line drawing	*/
#   define	DOS437_0xde		222	/*  Line drawing	*/
#   define	DOS437_0xdf		223	/*  Line drawing	*/

#   define	DOS437_alpha		224
#   define	DOS437_germandbls	225
#   define	DOS437_Gamma		226
#   define	DOS437_Pi		227
#   define	DOS437_Sigma		228
#   define	DOS437_sigma		229
#   define	DOS437_mu		230
#   define	DOS437_tau		231

#   define	DOS437_Phi		232
#   define	DOS437_Theta		233
#   define	DOS437_Omega		234
#   define	DOS437_delta		235
#   define	DOS437_infinity		236
#   define	DOS437_phi		237
#   define	DOS437_epsilon		238
#   define	DOS437_intersection	239

#   define	DOS437_equivalence	240
#   define	DOS437_plusminus	241
#   define	DOS437_greaterequal	242
#   define	DOS437_lessequal	243
#   define	DOS437_integraltp	244
#   define	DOS437_integralbt	245
#   define	DOS437_divide		246
#   define	DOS437_approxequal	247

#   define	DOS437_degree		248
#   define	DOS437_bullet		249
#   define	DOS437_periodcentered	250
#   define	DOS437_radical		251
#   define	DOS437_nsuperior	252
#   define	DOS437_twosuperior	253
#   define	DOS437_0xfe		254	/*  Drawing: black square */
#   define	DOS437_0xff		255

/************************************************************************/
/*  The Apple MACINTOSH character set.					*/
/************************************************************************/

#   define MAC_Adieresis		0x80
#   define MAC_Aring			0x81
#   define MAC_Ccedilla			0x82
#   define MAC_Eacute			0x83
#   define MAC_Ntilde			0x84
#   define MAC_Odieresis		0x85
#   define MAC_Udieresis		0x86
#   define MAC_aacute			0x87

#   define MAC_agrave			0x88
#   define MAC_acircumflex		0x89
#   define MAC_adieresis		0x8a
#   define MAC_atilde			0x8b
#   define MAC_aring			0x8c
#   define MAC_ccedilla			0x8d
#   define MAC_eacute			0x8e
#   define MAC_egrave			0x8f

#   define MAC_ecircumflex		0x90
#   define MAC_edieresis		0x91
#   define MAC_iacute			0x92
#   define MAC_igrave			0x93
#   define MAC_icircumflex		0x94
#   define MAC_idieresis		0x95
#   define MAC_ntilde			0x96
#   define MAC_oacute			0x97

#   define MAC_ograve			0x98
#   define MAC_ocircumflex		0x99
#   define MAC_odieresis		0x9a
#   define MAC_otilde			0x9b
#   define MAC_uacute			0x9c
#   define MAC_ugrave			0x9d
#   define MAC_ucircumflex		0x9e
#   define MAC_udieresis		0x9f

#   define MAC_degree			0xa1
#   define MAC_cent			0xa2
#   define MAC_sterling			0xa3
#   define MAC_section			0xa4
#   define MAC_paragraph		0xa6
#   define MAC_germandbls		0xa7

#   define MAC_registered		0xa8
#   define MAC_copyright		0xa9
#   define MAC_AE			0xae
#   define MAC_Oslash			0xaf

#   define MAC_plusminus		0xb1
#   define MAC_yen			0xb4
#   define MAC_mu			0xb5

#   define MAC_pi			0xb9
#   define MAC_ordfeminine		0xbb
#   define MAC_ordmasculine		0xbc
#   define MAC_ohm			0xbd
#   define MAC_ae			0xbe
#   define MAC_oslash			0xbf

#   define MAC_quesiondown		0xc0
#   define MAC_exclamdown		0xc1
#   define MAC_logicalnot		0xc2
#   define MAC_guillemotleft		0xc7
#   define MAC_guillemotright		0xc8

#   define MAC_Agrave			0xcb
#   define MAC_Atilde			0xcc
#   define MAC_Otilde			0xcd

#   define MAC_divide			0xd6

#   define MAC_ydieresis		0xd8
#   define MAC_Yacute			0xd9
#   define MAC_currency			0xdb

#   define MAC_Acircumflex		0xe5
#   define MAC_Ecircumflex		0xe6
#   define MAC_Aacute			0xe7

#   define MAC_Edieresis		0xe8
#   define MAC_Egrave			0xe9
#   define MAC_Iacute			0xea
#   define MAC_Icircumflex		0xeb
#   define MAC_Idieresis		0xec
#   define MAC_Igrave			0xed
#   define MAC_Oacute			0xee
#   define MAC_Ocircumflex		0xef

#   define MAC_Ograve			0xf1
#   define MAC_Uacute			0xf2
#   define MAC_Ucircumflex		0xf3
#   define MAC_Ugrave			0xf4
