#   ifndef	IND_H						/*  {{	*/
#   define	IND_H

#   define	INDhASIS	1	/*  knudde -> knudde		*/
#   define	INDhFIRSTUP	2	/*  Knudde -> knudde		*/
#   define	INDhIJUP	3	/*  IJsco -> ijsco		*/
#   define	INDhALLUP	4	/*  KNUDDE -> knudde		*/
#   define	INDhTAILUP	5	/*  EDAM -> Edam		*/
#   define	INDhIJTAILUP	6	/*  IJMUIDEN -> IJmuiden	*/

/************************************************************************/
/*  A list of Guesses.							*/
/************************************************************************/
typedef struct IndGuessScore
    {
    unsigned char *	igsWord;
    int			igsScore;
    } IndGuessScore;

typedef struct IndGuessList
    {
    int			iglGuessCount;
    IndGuessScore *	iglGuesses;
    } IndGuessList;

/************************************************************************/
/*  Scores for frequent substitutions: Helps making guesses.		*/
/************************************************************************/
typedef struct GuessSubstitution
    {
    unsigned char *	gsFrom;
    unsigned char *	gsTo;
    int			gsFromLength;
    int			gsToLength;
    int			gsCost;

    } GuessSubstitution;

/************************************************************************/
/*  A possible 'word' that is collected doring the scan of the input.	*/
/************************************************************************/
#   define	FORM_MAX	100

typedef struct PossibleWord
    {
    int				pwStartPosition;
    int				pwInsertionPoint;
    int				pwRejectedAt;
    int				pwAcceptedAt;
    struct PossibleWord *	pwNext;
    unsigned char		pwForm[FORM_MAX+2];
    } PossibleWord;

/************************************************************************/
/*  Routine declarations.						*/
/************************************************************************/
extern void *	indMake( void );
extern void *	indRead( const char * filename, int readonly );
extern int		indPut( void * ind, const unsigned char * key );
extern int		indForget( void * ind, const unsigned char * key );
extern int		indGet( int *, void * ind, const unsigned char * key );
extern void		indFree( void * ind );
extern int		indWrite( void * ind, const char * filename );
extern void *	indMini( void * ind );
extern void *	indRenumber( void * ind );

extern int indGuess(	void *				voidind,
			    const unsigned char *		word,
			    void *				something,
			    int				how,
			    const GuessSubstitution *	typos,
			    int				count,
			    int				(*fun)
			( void *, const unsigned char *, int, int ) );

extern int	indSetItem( void *, int, int );
extern int	indGetItems( void *, int, int *, int ** );

extern int	indGetWord(	int *			pWhatWasShifted,
				void *			voidind,
				const unsigned char *	word,
				int			asPrefix	);

extern int indGuessWord(	void *				voidind,
			    const unsigned char *		word,
			    void *				something,
			    const GuessSubstitution *	typos,
			    int				count,
			    int				(*fun)
			( void *, const unsigned char *, int, int ) );

extern int		indShiftWord( unsigned char * copy,
				  const unsigned char * word, int how );
extern int		indAddGuess(	IndGuessList *		igl,
				    const unsigned char *	word,
				    int			score	);
extern void 	indCleanGuesses( IndGuessList *		igl );
extern void 	indSortGuesses(	IndGuessList *		igl );

extern void	indFreePossibilities(	PossibleWord *	pw	);
extern void	indLogPossibilities(	PossibleWord *	pw	);

extern PossibleWord *	indNewPossibility(	int		start,
						PossibleWord *	next,
						int		first	);

extern void indAddCharacterToPossibilities(	PossibleWord *	pw,
						int		c	);

extern int indCountPossibilities(	PossibleWord *	pw,
					int		position,
				int		(*check)
						 ( const unsigned char *,
						   void *, int ),
				void *		through,
				int		characterThatFollows );

extern PossibleWord * indRejectPossibilities(	PossibleWord *	pw	);
extern PossibleWord * indMaximalPossibility(	PossibleWord *	pw	);

#   endif /*	IND_H						    }}	*/
