/************************************************************************/
/*  Morphological classes.						*/
/************************************************************************/

/************************************************************************/
/*  Classes of words.							*/
/************************************************************************/
#   define	WmoUNSPEC		0
#   define	WmoSUBST		1
#   define	WmoARTICLE		2
#   define	WmoPRONOMEN		3
#   define	WmoNUMER		4
#   define	WmoADJ			5
#   define	WmoADVER		6
#   define	WmoVERBUM		7
#   define	WmoPREPOS		8
#   define	WmoPOSTPOS		9
#   define	WmoCONJUN		10
#   define	WmoINTERJ		11
#   define	WmoPAST			12			/********/

/************************************************************************/
/*  Gender of words.							*/
/************************************************************************/
#   define	GmoUNSPEC		100
#   define	GmoFEMALE		101
#   define	GmoMALE			102
#   define	GmoNEUTRAL		103
#   define	GmoPAST			104			/********/

/************************************************************************/
/*  Special properties.							*/
/************************************************************************/
#   define	PmoUNSPEC		1000
#   define	PmoADVSCALES		1001
#   define	PmoDIMINUTIVE		1002
#   define	PmoPLURTANTUM		1003
#   define	PmoPAST			1004			/********/

/************************************************************************/
/*  Kinds of derivations.						*/
/************************************************************************/
#   define	DmoUNSPEC		10000
#   define	DmoNUMER		10001
#   define	DmoNUMER_DER_S		10002
#   define	DmoNUMER_DER_P		10003
#   define	DmoADVER		10004
#   define	DmoADVER_COMP		10005
#   define	DmoADVER_SUPER		10006
#   define	DmoCONJUN		10007
#   define	DmoPREPOS		10008
#   define	DmoARTICLE		10009
#   define	DmoINTERJ		10010
#   define	DmoPRONOMEN		10011
#   define	DmoPRONOMENe		10012
#   define	DmoPRONOMENPOSe		10013
#   define	DmoSUBST		10014
#   define	DmoSUBPLUR		10015
#   define	DmoDIMSING		10016
#   define	DmoDIMPLUR		10017
#   define	DmoADJ			10018
#   define	DmoADJe			10019
#   define	DmoCOMP			10020
#   define	DmoCOMPe		10021
#   define	DmoSUPER		10022
#   define	DmoSUPERe		10023
#   define	DmoINFINIT		10024

#   define	DmoINDPRESSING1		10025
#   define	DmoINDPRESSING2		10026
#   define	DmoINDPRESSING2nl	10027
#   define	DmoINDPRESSING3		10028
#   define	DmoINDPRESPLUR1		10029
#   define	DmoINDPRESPLUR2		10030
#   define	DmoINDPRESPLUR3		10031
#   define	DmoINDIMPERSING1	10032
#   define	DmoINDIMPERSING2	10033
#   define	DmoINDIMPERSING3	10034
#   define	DmoINDIMPERPLUR1	10035
#   define	DmoINDIMPERPLUR2	10036
#   define	DmoINDIMPERPLUR3	10037

#   define	DmoINDPRESSING1s	10038
#   define	DmoINDPRESSING2s	10039
#   define	DmoINDPRESSING2nls	10040
#   define	DmoINDPRESSING3s	10041
#   define	DmoINDPRESPLUR1s	10042
#   define	DmoINDPRESPLUR2s	10043
#   define	DmoINDPRESPLUR3s	10044
#   define	DmoINDIMPERSING1s	10045
#   define	DmoINDIMPERSING2s	10046
#   define	DmoINDIMPERSING3s	10047
#   define	DmoINDIMPERPLUR1s	10048
#   define	DmoINDIMPERPLUR2s	10049
#   define	DmoINDIMPERPLUR3s	10050

#   define	DmoPARTPAS		10051
#   define	DmoPARTPASe		10052
#   define	DmoPARTPASen		10053
#   define	DmoPARTPRES		10054
#   define	DmoPARTPRESe		10055
#   define	DmoPARTPRESen		10056

#   define	DmoCOMPPREF		10057
#   define	DmoGEINF		10058

#   define	DmoPERSON		10059
#   define	DmoTOPO			10060

#   define	DmoADJSUBST		10061
#   define	DmoCOMPSUBST		10062
#   define	DmoADJeSUBST		10063
#   define	DmoADJeSUBSTPLUR	10064
#   define	DmoCOMPen		10065
#   define	DmoSUPERen		10066
#   define	DmoALLER_SUPER		10067
#   define	DmoALLER_SUPERe		10068
#   define	DmoALLER_SUPERen	10069

#   define	DmoNUMBER		10070
#   define	DmoRANK			10071
#   define	DmoSIZE			10072

#   define	DmoCOLLECT		10073

#   define	DmoWORD			10074

#   define	DmoCOUNT		10075
#   define	DmoPAST			10076			/********/

#   ifdef __STDC__						/*  {{	*/
    extern char *	morstr( int );
#   else							/*  }{	*/
    extern char *	morstr();
#   endif							/*  }}	*/
