/************************************************************************/
/*  Translate NeXT Postscript encoding to ISO Latin 1.			*/
/************************************************************************/
unsigned char NextToIso[256]=
    {
    0000,		/*    0= 0000= 0x00 (nul)	*/
    0001,		/*    1= 0001= 0x01 (soh)	*/
    0002,		/*    2= 0002= 0x02 (stx)	*/
    0003,		/*    3= 0003= 0x03 (etx)	*/
    0004,		/*    4= 0004= 0x04 (eot)	*/
    0005,		/*    5= 0005= 0x05 (enq)	*/
    0006,		/*    6= 0006= 0x06 (ack)	*/
    0007,		/*    7= 0007= 0x07 (bel)	*/
    0010,		/*    8= 0010= 0x08 (bs)	*/
    0011,		/*    9= 0011= 0x09 (ht)	*/
    0012,		/*   10= 0012= 0x0a (nl)	*/
    0013,		/*   11= 0013= 0x0b (vt)	*/
    0014,		/*   12= 0014= 0x0c (np)	*/
    0015,		/*   13= 0015= 0x0d (cr)	*/
    0016,		/*   14= 0016= 0x0e (so)	*/
    0017,		/*   15= 0017= 0x0f (si)	*/
    0020,		/*   16= 0020= 0x10 (dle)	*/
    0021,		/*   17= 0021= 0x11 (dc1)	*/
    0022,		/*   18= 0022= 0x12 (dc2)	*/
    0023,		/*   19= 0023= 0x13 (dc3)	*/
    0024,		/*   20= 0024= 0x14 (dc4)	*/
    0025,		/*   21= 0025= 0x15 (nak)	*/
    0026,		/*   22= 0026= 0x16 (syn)	*/
    0027,		/*   23= 0027= 0x17 (etb)	*/
    0030,		/*   24= 0030= 0x18 (can)	*/
    0031,		/*   25= 0031= 0x19 (em)	*/
    0032,		/*   26= 0032= 0x1a (sub)	*/
    0033,		/*   27= 0033= 0x1b (esc)	*/
    0034,		/*   28= 0034= 0x1c (fs)	*/
    0035,		/*   29= 0035= 0x1d (gs)	*/
    0036,		/*   30= 0036= 0x1e (rs)	*/
    0037,		/*   31= 0037= 0x1f (us)	*/
    ISO_space,
    ISO_exclam,
    ISO_quotedbl,
    ISO_numbersign,
    ISO_dollar,
    ISO_percent,
    ISO_ampersand,
    ISO_quoteright,
    ISO_parenleft,
    ISO_parenright,
    ISO_asterisk,
    ISO_plus,
    ISO_comma,
    ISO_minus,
    ISO_period,
    ISO_slash,
    ISO_zero,
    ISO_one,
    ISO_two,
    ISO_three,
    ISO_four,
    ISO_five,
    ISO_six,
    ISO_seven,
    ISO_eight,
    ISO_nine,
    ISO_colon,
    ISO_semicolon,
    ISO_less,
    ISO_equal,
    ISO_greater,
    ISO_question,
    ISO_at,
    ISO_A,
    ISO_B,
    ISO_C,
    ISO_D,
    ISO_E,
    ISO_F,
    ISO_G,
    ISO_H,
    ISO_I,
    ISO_J,
    ISO_K,
    ISO_L,
    ISO_M,
    ISO_N,
    ISO_O,
    ISO_P,
    ISO_Q,
    ISO_R,
    ISO_S,
    ISO_T,
    ISO_U,
    ISO_V,
    ISO_W,
    ISO_X,
    ISO_Y,
    ISO_Z,
    ISO_bracketleft,
    ISO_backslash,
    ISO_bracketright,
    ISO_asciicircum,
    ISO_underscore,
    ISO_quoteleft,
    ISO_a,
    ISO_b,
    ISO_c,
    ISO_d,
    ISO_e,
    ISO_f,
    ISO_g,
    ISO_h,
    ISO_i,
    ISO_j,
    ISO_k,
    ISO_l,
    ISO_m,
    ISO_n,
    ISO_o,
    ISO_p,
    ISO_q,
    ISO_r,
    ISO_s,
    ISO_t,
    ISO_u,
    ISO_v,
    ISO_w,
    ISO_x,
    ISO_y,
    ISO_z,
    ISO_braceleft,
    ISO_bar,
    ISO_braceright,
    ISO_asciitilde,
/**/0x7f,		/*0x7f=0177*/
/**/0x80,		/*0200=0x80*/
    ISO_Agrave,
    ISO_Aacute,
    ISO_Acircumflex,
    ISO_Atilde,
    ISO_Adieresis,
    ISO_Aring,
    ISO_Ccedilla,
    ISO_Egrave,
    ISO_Eacute,
    ISO_Ecircumflex,
    ISO_Edieresis,
    ISO_Igrave,
    ISO_Iacute,
    ISO_Icircumflex,
    ISO_Idieresis,
    ISO_Eth,
    ISO_Ntilde,
    ISO_Ograve,
    ISO_Oacute,
    ISO_Ocircumflex,
    ISO_Otilde,
    ISO_Odieresis,
    ISO_Ugrave,
    ISO_Uacute,
    ISO_Ucircumflex,
    ISO_Udieresis,
    ISO_Yacute,
    ISO_Thorn,
    ISO_mu,
    ISO_multiply,
    ISO_divide,
    ISO_copyright,
    ISO_exclamdown,
    ISO_cent,
    ISO_sterling,
/**/ISO_slash,		/* fraction,		*/
    ISO_yen,
/**/ISO_f,		/* florin,		*/
    ISO_section,
    ISO_currency,
/**/ISO_quoteright,	/* quotesingle, 	*/
/**/ISO_quotedbl,	/* quotedblleft,	*/
    ISO_guillemotleft,
/**/ISO_guillemotleft,	/* guillsinglleft,	*/
/**/ISO_guillemotright,	/* guillsinglright,	*/
/**/ISO_currency,	/* fi, 			*/
/**/ISO_currency,	/* fl, 			*/
    ISO_registered,
/**/ISO_currency,	/* endash,		*/
/**/ISO_currency,	/* dagger,		*/
/**/ISO_currency,	/* daggerdbl,		*/
    ISO_periodcentered,
    ISO_brokenbar,
    ISO_paragraph,
/**/ISO_currency,	/* bullet,		*/
/**/ISO_quoteright,	/* quotesinglbase,	*/
/**/ISO_quotedbl,	/* quotedblbase,	*/
/**/ISO_quotedbl,	/* quotedblright,	*/
    ISO_guillemotright,
/**/ISO_currency,	/* ellipsis,		*/
/**/ISO_currency,	/* perthousand,		*/
    ISO_logicalnot,
    ISO_questiondown,
    ISO_onesuperior,
    ISO_grave,
    ISO_acute,
    ISO_circumflex,
    ISO_tilde,
    ISO_macron,
    ISO_breve,
    ISO_dotaccent,
    ISO_dieresis,
    ISO_twosuperior,
    ISO_ring,
    ISO_cedilla,
    ISO_threesuperior,
    ISO_hungarumlaut,
    ISO_ogonek,
    ISO_caron,
/**/ISO_currency,	/* emdash, */
    ISO_plusminus,
    ISO_onequarter,
    ISO_onehalf,
    ISO_threequarters,
    ISO_agrave,
    ISO_aacute,
    ISO_acircumflex,
    ISO_atilde,
    ISO_adieresis,
    ISO_aring,
    ISO_ccedilla,
    ISO_egrave,
    ISO_eacute,
    ISO_ecircumflex,
    ISO_edieresis,
    ISO_igrave,
    ISO_AE,
    ISO_iacute,
    ISO_ordfeminine,
    ISO_icircumflex,
    ISO_idieresis,
    ISO_eth,
    ISO_ntilde,
/**/ISO_currency,	/* Lslash, */
    ISO_Oslash,
/**/ISO_currency,	/* OE, */
    ISO_ordmasculine,
    ISO_ograve,
    ISO_oacute,
    ISO_ocircumflex,
    ISO_otilde,
    ISO_odieresis,
    ISO_ae,
    ISO_ugrave,
    ISO_uacute,
    ISO_ucircumflex,
    ISO_dotlessi,
    ISO_udieresis,
    ISO_yacute,
/**/ISO_currency,	/* lslash */
    ISO_oslash,
/**/ISO_currency,	/* oe */
    ISO_germandbls,
    ISO_thorn,
    ISO_ydieresis,
    0376,
    0377,
    };
