#   include	"indlocal.h"
#   include	<debugoff.h>

#   ifdef NeXT
#	include	<libc.h>
#	include	<mach/mach.h>
#   endif

#   include	<unistd.h>
#   include	<fcntl.h>

/************************************************************************/
/*  Swap a buffer							*/
/************************************************************************/
static void	indSwapInt( char * buf )
    {
    register char	c;

    c= buf[0]; buf[0]= buf[3]; buf[3]= c;
    c= buf[1]; buf[1]= buf[2]; buf[2]= c;
    }

static void	indSwapInd( IND * ind )
    {
    indSwapInt( (char *)&(ind->ind_magic) );
    indSwapInt( (char *)&(ind->ind_fd) );
    indSwapInt( (char *)&(ind->ind_start) );
    indSwapInt( (char *)&(ind->ind_readonly) );
    indSwapInt( (char *)&(ind->ind_nnode) );
    indSwapInt( (char *)&(ind->indAllocatedNodes) );
    indSwapInt( (char *)&(ind->indAllocatedLinks) );
    indSwapInt( (char *)&(ind->ind_lfree) );
    indSwapInt( (char *)&(ind->ind_lfull) );
    indSwapInt( (char *)&(ind->ind_ccount) );
    indSwapInt( (char *)&(ind->ind_cfree) );
    indSwapInt( (char *)&(ind->ind_cfull) );

    return;
    }

/************************************************************************/
/*  Make an index.							*/
/************************************************************************/
IND *	indINDmake( readonly )
int	readonly;
    {
    IND *	rval= (IND *)malloc( sizeof( IND ) );

    if  ( rval )
	{
	rval->ind_magic= INDMAGIC;
	rval->ind_fd= -1;

	rval->ind_start= -1;
	rval->ind_readonly= readonly;

	rval->ind_nodes= (TrieNode *)0;
	rval->indNodePages= (TrieNode **)0;
	rval->ind_nnode= 0;
	rval->indAllocatedNodes= 0;

	rval->ind_links= (TrieLink *)0;
	rval->indLinkPages= (TrieLink **)0;
	rval->indAllocatedLinks= 0;
	rval->ind_lfree= 0;
	rval->ind_lfull= 0;

	rval->ind_classes= (int *)0;
	rval->ind_cpages= (int **)0;
	rval->ind_ccount= 0;
	rval->ind_cfree= 0;
	rval->ind_cfull= 0;
	}

    return rval;
    }

void	indINDfree( ind )
IND *	ind;
    {
    int		i;
    int		page;
    char *	p;

#   ifdef NeXT
    if  ( ind->ind_readonly )
	{
	kern_return_t	ret;

	if  ( ind->ind_nodes )
	    {
	    ret= vm_deallocate( task_self(), (vm_address_t)ind->ind_nodes,
				ind->indAllocatedNodes* sizeof(TrieNode) );
	    if  ( ret != KERN_SUCCESS )
		{ ; }
	    }
	if  ( ind->ind_links )
	    {
	    ret= vm_deallocate( task_self(), (vm_address_t)ind->ind_links,
				ind->indAllocatedLinks* sizeof(TrieLink) );
	    if  ( ret != KERN_SUCCESS )
		{ ; }
	    }
	if  ( ind->ind_classes )
	    {
	    ret= vm_deallocate( task_self(), (vm_address_t)ind->ind_classes,
				ind->ind_ccount* sizeof( int ) );
	    if  ( ret != KERN_SUCCESS )
		{ ; }
	    }
	}
#   endif

    if  ( ind->indNodePages )
	{
	page= 0;
#	ifdef NeXT
	if  ( ! ind->ind_readonly )
#	endif
	for ( i= 0; i < ind->indAllocatedNodes; i += TNsBLOCK )
	    {
	    p= (char *)ind->indNodePages[page++];
	    if  ( p )
		{ free( p );	}
	    }
	free( (char *)ind->indNodePages );
	}

    if  ( ind->indLinkPages )
	{
	page= 0;
#	ifdef NeXT
	if  ( ! ind->ind_readonly )
#	endif
	for ( i= 0; i < ind->indAllocatedLinks; i += TLsBLOCK )
	    {
	    p= (char *)ind->indLinkPages[page++];
	    if  ( p )
		{ free( p );	}
	    }
	free( (char *)ind->indLinkPages );
	}

    if  ( ind->ind_cpages )
	{
	page= 0;
#	ifdef NeXT
	if  ( ! ind->ind_readonly )
#	endif
	for ( i= 0; i < ind->ind_ccount; i += ITsBLOCK )
	    {
	    p= (char *)ind->ind_cpages[page++];
	    if  ( p )
		{ free( p );	}
	    }
	free( (char *)ind->ind_cpages );
	}

    free( (char *)ind );
    }

/************************************************************************/
/*  Write an index to file						*/
/************************************************************************/
static int	indWriteData( ind, fd, swap )
IND *		ind;
int		fd;
int		swap;
    {
    int		n;
    int		i;
    unsigned	sz;
    int		page;

    page= 0;
    for ( n= 0; n < ind->indAllocatedNodes; n += TNsBLOCK )
	{
	sz= TNsBLOCK * sizeof( TrieNode );
	if  ( swap )
	    {
	    for ( i= 0; i < TNsBLOCK; i++ )
		{
		indSwapInt( (char *)&ind->indNodePages[page][i].tn_transitions );
		indSwapInt( (char *)&ind->indNodePages[page][i].tn_items );
		}
	    }
	if  ( write( fd, (char *)ind->indNodePages[page], sz ) != sz )
	    { return -1; }

	if  ( swap )
	    {
	    for ( i= 0; i < TNsBLOCK; i++ )
		{
		indSwapInt( (char *)&ind->indNodePages[page][i].tn_transitions );
		indSwapInt( (char *)&ind->indNodePages[page][i].tn_items );
		}
	    }
	page++;
	}

    page= 0;
    for ( n= 0; n < ind->indAllocatedLinks; n += TLsBLOCK )
	{
	sz= TLsBLOCK * sizeof( TrieLink );
	if  ( swap )
	    {
	    for ( i= 0; i < TLsBLOCK; i++ )
		{ indSwapInt( (char *)&ind->indLinkPages[page][i] ); }
	    }
	if  ( write( fd, (char *)ind->indLinkPages[page], sz ) != sz )
	    { LDEB(fd); return -1; }
	if  ( swap )
	    {
	    for ( i= 0; i < TLsBLOCK; i++ )
		{ indSwapInt( (char *)&ind->indLinkPages[page][i] ); }
	    }
	page++;
	}

    page= 0;
    for ( n= 0; n < ind->ind_ccount; n += ITsBLOCK )
	{
	sz= ITsBLOCK * sizeof( int );
	if  ( swap )
	    {
	    for ( i= 0; i < ITsBLOCK; i++ )
		{ indSwapInt( (char *)&ind->ind_cpages[page][i] ); }
	    }
	if  ( write( fd, (char *)ind->ind_cpages[page], sz ) != sz )
	    { LDEB(fd); return -1; }
	if  ( swap )
	    {
	    for ( i= 0; i < ITsBLOCK; i++ )
		{ indSwapInt( (char *)&ind->ind_cpages[page][i] ); }
	    }
	page++;
	}

    return 0;
    }

int	indINDwrite( ind, filename )
IND *		ind;
const char *	filename;
    {
    int		fd= creat( filename, 0666 );
    int		rval= 0;
    IND	swapped;

    if  ( fd < 0 )
	{ return -1; }

#   ifdef DEBUG
    printf( "WRITE: ROOT= %d, nnode= %d, ncount= %d lcount= %d\n",
	ind->ind_start,	ind->ind_nnode, ind->indAllocatedNodes, ind->indAllocatedLinks );
#   endif

    if  ( write( fd, ind, sizeof(IND) ) != sizeof(IND) )
	{ LDEB(fd); rval= -1;	}
    else{
	if  ( indWriteData( ind, fd, 0 ) )
	    { rval= -1;	}
	}

    if  ( ! rval )
	{
	swapped= *ind;
	indSwapInd( &swapped );

	if  ( write( fd, &swapped, sizeof(IND) ) != sizeof(IND) )
	    { rval= -1;	}
	else{
	    if  ( indWriteData( ind, fd, 1 ) )
		{ rval= -1;	}
	    }
	}

    if  ( close( fd ) )
	{ rval= -1;	}

    return rval;
    }

/************************************************************************/
/*  Read an index from file						*/
/************************************************************************/
IND *	indINDread( filename, readonly )
const char *	filename;
int		readonly;
    {
    int		fd= open( filename, 0 );

    IND *	ind;
    TrieNode *	nodes;
    TrieLink *	links;
    int *	items;
    int		n;
    unsigned	sz;
    int		page;
    long	offset= 0;
    int		memory_mapped= 0;
    IND	swapped;
    int		swap;

    if  ( fd < 0 )
	{ return (IND *)0;	}

    ind= indINDmake( readonly );

    if  ( ! ind )
	{ goto failure;	}

    if  ( read( fd, ind, sizeof(IND) ) != sizeof(IND) )
	{ goto failure;	}

    if  ( ind->ind_magic != INDMAGIC )
	{
	if  ( ind->ind_magic == INDMAGIC_R )
	    {
	    swapped= *ind;
	    indSwapInd( &swapped );
	    if  ( swapped.ind_magic != INDMAGIC )
		{ goto failure;	}
	    offset= sizeof( IND );
	    offset += swapped.indAllocatedNodes* sizeof( TrieNode );
	    offset += swapped.indAllocatedLinks* sizeof( TrieLink );
	    offset += swapped.ind_ccount* sizeof( int );
	    if  ( lseek( fd, offset, SEEK_SET ) != offset		||
		  read( fd, ind, sizeof( IND ) ) != sizeof(IND)	)
		{
		offset= sizeof( IND );
		if  ( lseek( fd, offset, SEEK_SET ) != offset )
		    { goto failure;	}
		*ind= swapped;
		swap= 1;
		}
	    else{
		offset += sizeof( IND );
		swap= 0;
		}
	    }
	else{ goto failure;	}
	}
    else{
	offset= sizeof(IND);
	swap= 0;
	}

    ind->ind_readonly= readonly;

#   ifdef DEBUG
    printf( "READ:  ROOT= %d, nnode= %d, ncount= %d lcount= %d\n",
	ind->ind_start,	ind->ind_nnode, ind->indAllocatedNodes, ind->indAllocatedLinks );
#   endif

#   ifdef NeXT
    if  ( readonly && ! swap )
	{
	kern_return_t	ret;

	ret= map_fd( fd, (vm_offset_t)offset,
		    (vm_offset_t *)&ind->ind_nodes, 1,
		    ind->indAllocatedNodes* sizeof(TrieNode) );
	if  ( ret != KERN_SUCCESS )
	    { goto failure;	}

	offset += ind->indAllocatedNodes* sizeof(TrieNode);

	ret= map_fd( fd, (vm_offset_t)offset,
		    (vm_offset_t *)&ind->ind_links, 1,
		    ind->indAllocatedLinks* sizeof(TrieLink) );
	if  ( ret != KERN_SUCCESS )
	    { goto failure;	}

	offset += ind->indAllocatedLinks* sizeof(TrieLink);

	ret= map_fd( fd, (vm_offset_t)offset,
		    (vm_offset_t *)&ind->ind_classes, 1,
		    ind->ind_ccount* sizeof(int) );

	if  ( ret != KERN_SUCCESS )
	    { goto failure;	}

	offset += ind->ind_ccount* sizeof(int);

	memory_mapped= 1;
	}
#   endif

    sz= (ind->indAllocatedNodes/TNsBLOCK)* sizeof( TrieNode * );
    ind->indNodePages= (TrieNode **)malloc( sz );
    if  ( ! ind->indNodePages )
	{ goto failure;	}
    page= 0;
    for ( n= 0; n < ind->indAllocatedNodes; n += TNsBLOCK )
	{ ind->indNodePages[page++]= (TrieNode *)0; }

    sz= (ind->indAllocatedLinks/TLsBLOCK)* sizeof( TrieLink * );
    ind->indLinkPages= (TrieLink **)malloc( sz );
    if  ( ! ind->indLinkPages )
	{ goto failure;	}
    page= 0;
    for ( n= 0; n < ind->indAllocatedLinks; n += TLsBLOCK )
	{ ind->indLinkPages[page++]= (TrieLink *)0; }

    sz= (ind->ind_ccount/ITsBLOCK)* sizeof( int * );
    ind->ind_cpages= (int **)malloc( sz );
    if  ( ! ind->ind_cpages )
	{ goto failure;	}
    page= 0;
    for ( n= 0; n < ind->ind_ccount; n += ITsBLOCK )
	{ ind->ind_cpages[page++]= (int *)0; }

    page= 0;
    for ( n= 0; n < ind->indAllocatedNodes; n += TNsBLOCK )
	{
	if  ( ! memory_mapped )
	    {
	    sz= TNsBLOCK * sizeof( TrieNode );
	    ind->indNodePages[page++]= nodes= (TrieNode *)malloc( sz );
	    if  ( ! nodes )
		{ goto failure;	}

	    if  ( read( fd, (char *)nodes, sz ) != sz )
		{ goto failure;	}
	    }
	else{
	    ind->indNodePages[page++]= ind->ind_nodes+ n;
	    }
	}

    page= 0;
    for ( n= 0; n < ind->indAllocatedLinks; n += TLsBLOCK )
	{
	if  ( ! memory_mapped )
	    {
	    sz= TLsBLOCK * sizeof( TrieLink );
	    ind->indLinkPages[page++]= links= (TrieLink *)malloc( sz );
	    if  ( ! links )
		{ goto failure;	}

	    if  ( read( fd, (char *)links, sz ) != sz )
		{ goto failure;	}
	    }
	else{
	    ind->indLinkPages[page++]= ind->ind_links+ n;
	    }
	}

    page= 0;
    for ( n= 0; n < ind->ind_ccount; n += ITsBLOCK )
	{
	if  ( ! memory_mapped )
	    {
	    sz= ITsBLOCK * sizeof( int );
	    ind->ind_cpages[page++]= items= (int *)malloc( sz );
	    if  ( ! items )
		{ goto failure;	}

	    if  ( read( fd, (char *)items, sz ) != sz )
		{ goto failure;	}
	    }
	else{ ind->ind_cpages[page]= ind->ind_classes+ n; page++; }
	}

    if  ( close( fd ) )
	{ indINDfree( ind ); return (IND *)0; }

    return ind;

failure:
    close( fd );
    if  ( ind )
	{ indINDfree( ind );	}
    return (IND *)0;
    }
