#   include	<stdio.h>
#   include	<ctype.h>
#   include	<ind.h>

#   ifdef	__STDC__
#	include	<stddef.h>
#	include	<stdlib.h>
#	include	<string.h>
#   endif

#   ifdef __BIG_ENDIAN__
#   else
#	ifdef __LITTLE_ENDIAN__
#	else
#	    if defined(mc68000) || defined(mc68k)
#		define	__BIG_ENDIAN__
#	    endif
#	    if defined(sparc)
#		define	__BIG_ENDIAN__
#	    endif
#	    if defined(MIPSEL)
#		define	__LITTLE_ENDIAN__
#	    endif
#	    if defined( __i386 ) || defined( __i486__ )
#		define	__LITTLE_ENDIAN__ 1
#	    endif
#	endif
#   endif

#   ifdef __BIG_ENDIAN__
#   else
#	ifdef __LITTLE_ENDIAN__
#	else
	One of __BIG_ENDIAN__ or __LITTLE_ENDIAN__ must be defined.
#	endif
#   endif

#   define	TNfUSED		1
#   define	TNfACCEPTS	2

#   define	INDMAGIC	0x4d61726b
#   define	INDMAGIC_R	0x6b72614d

#   define	TLsBLOCK	5000
#   define	TNsBLOCK	5000
#   define	ITsBLOCK	5000

#   define	TLgFREE	0xfffffe
#   define	TLgUSED	0xffffff

typedef struct tn_s
    {
    int			tn_transitions;
    int			tn_items;
    unsigned char	tn_ntrans;
    unsigned char	tn_nitem;
    unsigned char	tn_flags;
    unsigned char	tn_unused;
    } TrieNode;

typedef struct tl_s
    {
#   ifdef __BIG_ENDIAN__
    unsigned char		tl_key:8;
    unsigned int		tl_to:24;
#   else
#	ifdef __LITTLE_ENDIAN__
	unsigned int		tl_to:24;
	unsigned char		tl_key:8;
#	else
	One of __BIG_ENDIAN__ or __LITTLE_ENDIAN__ must be defined.
#	endif
#   endif
    } TrieLink;

typedef struct ind_s
    {
    int			ind_magic;	/*  To avoid trouble		*/

    int			ind_fd;		/*  For future use.		*/

    int			ind_start;
    int			ind_readonly;

    TrieNode *		ind_nodes;
    TrieNode **		indNodePages;
    int			ind_nnode;
    int			indAllocatedNodes;

    TrieLink *		ind_links;
    TrieLink **		indLinkPages;
    int			indAllocatedLinks;
    int			ind_lfree;
    int			ind_lfull;

    int *		ind_classes;
    int **		ind_cpages;
    int			ind_ccount;
    int			ind_cfree;
    int			ind_cfull;
    } IND;

#   define	NODE(ind,tn) ((ind)->indNodePages[(tn)/TNsBLOCK]+((tn)%TNsBLOCK))
#   define	LINK(ind,tl) ((ind)->indLinkPages[(tl)/TLsBLOCK]+((tl)%TLsBLOCK))
#   define	ITEMS(ind,cl) ((ind)->ind_cpages[(cl)/ITsBLOCK]+((cl)%ITsBLOCK))

extern IND *	indINDmake( int readonly );
extern IND *	indINDread( const char * filename, int readonly );
extern int		indINDput( IND * ind, const unsigned char * );
extern int		indINDforget( IND * ind, unsigned char * );
extern int		indINDget( int *, IND * ind, int,
				const unsigned char * );
extern void		indINDfree( IND * ind );
extern int		indINDwrite( IND * ind, const char * filename );
extern int		indTNmake( IND * ind );
extern void		indTNfree( IND * ind, int tn );
extern int		indTLalloc( IND * ind, int old, int n );
extern void		indTLfree( IND * ind, int tl );
extern IND *	indINDmini( IND * ind );
extern void		indTLprint( IND *, int );
extern void		indTNprint( IND *, int );
extern void		indINDprint( IND * );
extern void		indDump( IND *, int, int );
extern int		indINDstep( int *, IND * ind, int,
				const unsigned char * );
extern int indINDguess(	IND *				ind,
			    const unsigned char *		word,
			    void *				something,
			    int				how,
			    const GuessSubstitution *	typos,
			    int				count,
			    int				(*fun)
			    ( void *, const unsigned char *, int, int ) );

extern int		indITalloc( IND * ind, int old, int n );
extern void		indITfree( IND * ind, int cl );
extern int		indITset( IND * ind , int tn, int item );
extern int		indITget( IND * ind , int tn, int *, int ** );
extern int		indWRDget( IND * ind, int * pWhatWasShifted,
				const unsigned char * word, int asPrefix );

extern int	indWRDguess(	IND *				ind,
			    const unsigned char *		wrd,
			    void *				something,
			    const GuessSubstitution *	typos,
			    int				count,
			    int				(*fun)
			    ( void *, const unsigned char *, int, int ) );

extern IND *	indINDrenumber( IND * ind );
