/*	Search and Replace

	Date	Rev.	Author			Revision Made
	----	----	----------		------------------------------------
	2/94	0.1		Gary Lynn		Original Program
	2/94	0.2		Gary Lynn		Added option of making backups of modified files
	2/94	0.3		Gary Lynn		Fixed bug with renaming of directories
	2/94	0.4		Gary Lynn		Fixed bug where last file was searched twice
	2/94	0.5		Gary Lynn		Removed restriction of searching on executables
	5/94 0.6		Gary Lynn		Added restriction of searching hidden files
								Fixed bug with deleting last line of file if it contained no CR
	9/94	0.7		Gary Lynn		Fixed bug which caused problems when a ">" or "<" was used
									in the search string (added quotes to the call to "grep")
*/

#import "Globals.h"

@interface SearchAndReplace:Object 
{
	id		searchStringForm;
	id		directoryText;
	id		backupsDirectoryText;
	id		filenameText;
	id		includeExcludeRadio;
	id		extensionForm;
	id		operationSwitch;
	char		fullFilename[256],
			backupsDirectory[256],
			*homeDir;
}

- appDidInit:sender;
- execute:sender;
- (BOOL)renameFile:(char *)aName searchFor:(char *)searchString replaceWith:(char *)replaceString;
- setBackupsDirectory:sender;
- setDirectory:sender;

@end
