.TH "LaCheck" "1" "%%LACHECKDATE%%" "%%LACHECKREV%%"
.SH NAME
lacheck - A consistency checker for LaTeX documents.
.SH SYNOPSIS
.B lacheck 
.I filename
[
.I .tex
]
.SH DESCRIPTION
lacheck is a general purpose consistency checker for LaTeX documents.
It reads a LaTeX document and displays warning messages, if it finds
bad sequences. It should be noted, that the badness is 
.I very
subjective.
.LP
The things checked are:
.LP
Mismatched groups (braces), environments and math mode
delimiters.  When a mismatch is found, line numbers for
.I "both" 
start and end of the mismatch is given. The error messages comes in
pairs, one for the end match and one for the beginning, marked with
\`<-\' and \`->\' respectively.
.LP
Bad spacing. This is: missing a \`\\ \' after an abbreviation, missing
an \`\\@\' before a punctuation mark in a paragraph that is ended by an
capital letter, double spaces like \` \~\', bad usage of ellipsis
(like using ... instead of \\ldots, or using \\ldots where \\cdots
should be used) missing \~ before a \\cite or \\ref command
.LP
Badly placed punctuation marks around end of math mode delimiters. This
is, pucktuators placed right after display math end or punctuators
placed right before text math end.  Also sequences of whitespace
followed by punctuation marks are caught.  
.LP 
Bad use of citation characters, constructs like "\'word" or
"word\`" will be caught.  
.LP
lacheck will read files that are input using \\input or \\include.
Files with suffix \`.sty\' are omitted, as they probably will cause
lacheck to crash.
.LP 
lacheck may be invoked from within Emacs(1) using compile:

To run:  
.B "M-x compile <ret>"
, and then 
.B "C-x `"
to parse the messages

.SH OUTPUT
The output is UNIX-error like, and may be parsed using Emacs(1)
compile mode. Here is a sample:

.PD 0
lacheck compiler
.TP
"/usr/mef/compiler.tex", line 34: missing \`\\\\\\\\ \' after "etc."
.TP
"/usr/mef/compiler.tex", line 179: double space at " ~"
.TP
"/usr/mef/compiler.tex", line 186: <- unmatched "}"
.TP
"/usr/mef/compiler.tex", line 181: -> unmatched "$$"
.PD 1
.LP
A control space \`\\ \' should be inserted at line 34, to prevent an
end-of-sentence space. 
Also, at line 179, the first space of the sequence " ~" should
probably be deleted.
The last two lines is an example, where the user mistyped, and
probably inserted an extra "}" somewhere.

.SH DIAGNOSTICS
Some special cases should be explained. In cases where a sentence ends
with something that lacheck thinks is an abbreviation an missing \`\\
\' error may also occur, if the following sentence begins with a
lowercase letter.
.LP
A mismatch error may cause more to follow, due to the chosen
algorithm. In such cases just correct the
.I "first"
error and run lacheck again
.LP
Braces, environments and math mode must be balanced within a file.
.LP
LaCheck may be confused by unmatched stuff placed inside verbatim-like
environments called something else than exactly \`verbatim\'.
.SH FILES
%%LACHECKPATH%%
.SH SEE ALSO
tex(1), Emacs(1), latex(1)
.SH BUGS
Lots... Ideas for improvements and bug reports are very welcome. 
Such should be
directed to the author.
.SH AUTHOR
Kresten Krab Thorup,  Email <krab@iesd.auc.dk>

