;;; @ min-ind.el - minor mode to auto-indent relatively.
;;;
;;; $Id: min-ind.el,v 5.3 1993/03/18 08:45:46 amanda Exp $

(provide 'min-ind)
(require 'min-map)

;;; @@ Author
;;;
;;; Created by Alan K. Stebbens  7 Aug 87
;;;
;;; Added minor maps and ugly code by,
;;; Per Abrahamsen at University of Aalborg, Denmark 12 sep 87.
;;; Some cleanup 17 Feb 93.
;;;
;;; This file is hopefully to small to be affected by any form of copyright.

;;; @@ The Mode Line

(defvar auto-indent-mode nil
  "True, iff we are in auto indent mode.")

  (make-variable-buffer-local 'auto-indent-mode)

(or (assq 'auto-indent-mode minor-mode-alist)
    (setq minor-mode-alist
	  (cons '(auto-indent-mode " Indent") minor-mode-alist)))

;;; @@ The Mode

(defun auto-indent-mode (arg)
  "Toggle auto indent mode.
With prefix arg, turn auto indent mode on iff arg is positive.

Auto indent mode works by invoking indent-relative for TAB,
and using indent-relative-maybe as the indent-line-function for auto-fill,
and LFD."  
  (interactive "P")
  (if (or (and (null arg) auto-indent-mode)
	  (<= (prefix-numeric-value arg) 0))
      ;; Turn it off
      (if auto-indent-mode
	  (unbind-minor-mode 'auto-indent-mode))
    ;;Turn it on
    (if auto-indent-mode
	()
      (minor-set-key "\t" 'indent-relative 'auto-indent-mode)
      (minor-set-key "\n" 'newline-and-indent 'auto-indent-mode)
      (minor-set-variable 'indent-line-function 'indent-relative-maybe
			  'auto-indent-mode)
      (minor-set-variable 'auto-indent-mode t 'auto-indent-mode)))
  ;; Update mode line
  (set-buffer-modified-p (buffer-modified-p)))

;;; @@ Emacs

(run-hooks 'after-min-ind-hook)

;;; Local Variables:
;;; mode: emacs-lisp
;;; mode: outline-minor
;;; outline-regexp: ";;; @+\\|(......"
;;; End:

