;; bibframe.el
;; Last edited: Sat Oct 26 23:36:01 1991 by tompe@diag7 (Tommy Persson)
;;

;; The following TWO defvar should be changed when installing the system.
;; But the second is probably correct.

(defvar bibframe-bibtex-bin "/home/brutalix/rkllab/tex/bin/"
  "The path to bibtex")

(defvar bibframe-frame-bin (concat (getenv "FMHOME") "/bin/")
  "The path to mmltomif")

(defvar bibframe-reflist nil "List of references and there number")

(defvar bibframe-screflist nil "List of screferences and there number")

(defvar bibframe-shortcite "List of all shortcite-variables")



(defun rep (word repword)
  (setq case-fold-search nil)
  (goto-char (point-min))
  (while (search-forward word nil t) (replace-match repword t t))
  (setq case-fold-search t))

(defun reg-rep (regexp repword)
  (goto-char (point-min))
  (while (re-search-forward regexp (point-max) t) (replace-match repword t t)))

(defun current-line ()
  (beginning-of-line)
  (buffer-substring (point) (save-excursion (end-of-line) (point))))


(defun get-reflist ()
  (let ((refl nil))
    (while (search-forward "=" nil t)
      (setq refl
	    (cons
	     (list (buffer-substring (progn (beginning-of-line) (point))
				     (progn (search-forward "=" nil t)
					    (forward-char -2)
					    (point)))
		   (buffer-substring (progn (beginning-of-line)
					    (search-forward "=" nil t)
					    (forward-char 1)
					    (point))
				     (progn (end-of-line) (point))))
	     refl)))
    refl))


(defun get-shortcitereflist (sckeys)
  (setq case-fold-search nil)
  (let ((tmplist nil))
    (while sckeys
      (goto-char (point-min))
      (search-forward (car sckeys) nil t)
      (setq tmplist
	    (cons
	     (list
	      (car sckeys)
	      (buffer-substring
	       (progn
		 (search-forward "<HarDspace>" nil t)
		 (point))
	       (progn
		 (end-of-line)
		 (point))))
	     tmplist))
      (setq sckeys (cdr sckeys)))
    (setq case-fold-search t)
    tmplist))

(defun get-draftscreflist (sckeys)
  (let ((tmplist nil))
    (while sckeys
      (goto-char (point-min))
      (search-forward (car sckeys) nil t)
      (setq tmplist
	    (cons
	     (list
	      (car sckeys)
	      (buffer-substring
	       (progn
		 (forward-char 3)
		 (point))
	       (progn
		 (end-of-line)
		 (point))))
	     tmplist))
      (setq sckeys (cdr sckeys)))
    tmplist))


(defun fix-crossref-in-mml (style)
  (interactive)
  (goto-char (point-min))
  (while (search-forward "tpe-cite-" nil t)
    (backward-kill-word 2)
    (insert
     (concat (if (equal style "mmlmapalike")
		 "("
	       "[")
	     (car (cdr (assoc
			(save-excursion
			  (buffer-substring (point)
					    (progn (forward-word 1) (point))))
			bibframe-reflist)))
	     (if (equal style "mmlmapalike")
		 ")"
	       "]")))
    (kill-word 1)))

(defun fixfont ()
  "Fix the font in mif-file rep. of reference list"
  (interactive)
  (let (fsize ffamily)
    (find-file "/tmp/.bibframe.orig.mif")
    (goto-char (point-min))
    (re-search-forward "^<PgfCatalog" (point-max) t)
    (if (re-search-forward
	 "^ *<PgfTag `Body'>"
	 (save-excursion
	   (re-search-forward "^> # end of PgfCatalog" nil t)
	   (point))
	 t)
	(progn
	  (search-forward "FFamily" (point-max) t)
	  (setq ffamily (current-line))
	  (search-forward "FSize" (point-max) t)
	  (setq fsize (current-line)))
      (setq ffamily "   <FFamily `Times'>")
      (setq fsize "   <FSize  10.0 pt>"))
    (find-file "/tmp/.bibframe.mif")
    (reg-rep "^ *<FSize.*>" fsize)
    (reg-rep "^ *<FFamily.*>" ffamily)
    (basic-save-buffer)
    ))

(defun fix-char ()
  (interactive)
  (goto-char (point-min))
  (rep "{\\\"A}" "\\x80 ")
  (rep "\\\"{A}" "\\x80 ")
  (rep "{\\AA}"  "\\x81 ")
  (rep "{\c{C}}" "\\x82 ")
  (rep "\c{C}"   "\\x82 ")
  (rep "{\\'E}"  "\\x83 ")
  (rep "\\'{E}"  "\\x83 ")
  (rep "{\\~N}"  "\\x84 ")
  (rep "\\~{N}"  "\\x84 ")
  (rep "{\\\"O}" "\\x85 ")
  (rep "\\\"{O}" "\\x85 ")
  (rep "{\\\"U}" "\\x86 ")
  (rep "\\\"{U}" "\\x86 ")
  (rep "{\\'a}"  "\\x87 ")
  (rep "\\'{a}"  "\\x87 ")
  (rep "{\\`a}"  "\\x88 ")
  (rep "\\`{a}"  "\\x88 ")
  (rep "{\\^a}"  "\\x89 ")
  (rep "\\^{a}"  "\\x89 ")
  (rep "{\\\"a}" "\\x8a ")
  (rep "\\\"{a}" "\\x8a ")
  (rep "{\\~a}"  "\\x8b ")
  (rep "\\~{a}"  "\\x8b ")
  (rep "{\\aa}"  "\\x8c ")
  (rep "\\c{c}"  "\\x8d ")
  (rep "{\\'e}"  "\\x8e ")
  (rep "\\'{e}"  "\\x8e ")
  (rep "{\\`e}"  "\\x8f ")
  (rep "\\`{e}"  "\\x8f ")
  (rep "{\\^e}"  "\\x90 ")
  (rep "\\^{e}"  "\\x90 ")
  (rep "{\\\"e}" "\\x91 ")
  (rep "\\\"{e}" "\\x91 ")
  (rep "{\\'i}"  "\\x92 ")
  (rep "\\'{i}"  "\\x92 ")
  (rep "{\\`i}"  "\\x93 ")
  (rep "\\`{i}"  "\\x93 ")
  (rep "{\\^i}"  "\\x94 ")
  (rep "\\^{i}"  "\\x94 ")
  (rep "{\\\"i}" "\\x95 ")
  (rep "\\\"{i}" "\\x95 ")
  (rep "{\\~n}"  "\\x96 ")
  (rep "\\~{n}"  "\\x96 ")
  (rep "{\\'o}"  "\\x97 ")
  (rep "\\'{o}"  "\\x97 ")
  (rep "{\\`o}"  "\\x98 ")
  (rep "\\`{o}"  "\\x98 ")
  (rep "{\\^o}"  "\\x99 ")
  (rep "\\^{o}"  "\\x99 ")
  (rep "{\\\"o}" "\\x9a ")
  (rep "\\\"{o}" "\\x9a ")
  (rep "{\\~o}"  "\\x9b ")
  (rep "\\~{o}"  "\\x9b ")
  (rep "{\\'u}"  "\\x9c ")
  (rep "\\'{u}"  "\\x9c ")
  (rep "{\\`u}"  "\\x9d ")
  (rep "\\`{u}"  "\\x9d ")
  (rep "{\\^u}"  "\\x9e ")
  (rep "\\^{u}"  "\\x9e ")
  (rep "{\\\"u}" "\\x9f ")
  (rep "\\\"{u}" "\\x9f ")
  (rep "{\\pounds}" "\\xa3 ")
  (rep "{\\AE}"  "\\xae ")
  (rep "{\\O}"   "\\xaf ")
  (rep "{\\ae}"  "\\xbe ")
  (rep "{\\o}"   "\\xbf ")
  (rep "{\\`A}"  "\\xcb ")
  (rep "\\`{A}"  "\\xcb ")
  (rep "{\\~A}"  "\\xcc ")
  (rep "\\~{A}"  "\\xcc ")
  (rep "{\\~O}"  "\\xcd ")
  (rep "\\~{O}"  "\\xcd ")
  (rep "{\\OE}"  "\\xce ")
  (rep "{\\oe}"  "\\xcf ")
  (rep "{\\\"y}" "\\xd8 ")
  (rep "\\\"{y}" "\\xd8 ")
  (rep "{\\\"Y}" "\\xd9 ")
  (rep "\\\"{Y}" "\\xd9 ")
  (rep "{\\^A}"  "\\xe5 ")
  (rep "\\^{A}"  "\\xe5 ")
  (rep "{\\^E}"  "\\xe6 ")
  (rep "\\^{E}"  "\\xe6 ")
  (rep "{\\'A}"  "\\xe7 ")
  (rep "\\'{A}"  "\\xe7 ")
  (rep "{\\\"E}" "\\xe8 ")
  (rep "\\\"{E}" "\\xe8 ")
  (rep "{\\`E}"  "\\xe9 ")
  (rep "\\`{E}"  "\\xe9 ")
  (rep "{\\'I}"  "\\xea ")
  (rep "\\'{I}"  "\\xea ")
  (rep "{\\^I}"  "\\xeb ")
  (rep "\\^{I}"  "\\xeb ")
  (rep "{\\\"I}" "\\xec ")
  (rep "\\\"{I}" "\\xec ")
  (rep "{\\`I}"  "\\xed ")
  (rep "\\`{I}"  "\\xed ")
  (rep "{\\'O}"  "\\xee ")
  (rep "\\'{O}"  "\\xee ")
  (rep "{\\^O}"  "\\xef ")
  (rep "\\^{O}"  "\\xef ")
  (rep "{\\`O}"  "\\xf1 ")
  (rep "\\`{O}"  "\\xf1 ")
  (rep "{\\'U}"  "\\xf2 ")
  (rep "\\'{U}"  "\\xf2 ")
  (rep "{\\^U}"  "\\xf3 ")
  (rep "\\^{U}"  "\\xf3 ")
  (rep "{\\`U}"  "\\xf4 ")
  (rep "\\`{U}"  "\\xf4 ")
  (rep "---" "\\xd1 ")
  (rep "--" "\\xd0 ")
  (rep "``" "\\xd2 ")
  (rep "''" "\\xd3 ")
  (rep "~" "<HardSpace>")
  (rep "{\\'n}"  "n")
  (rep "{" "")
  (rep "}" "")
  )

(defun get-citations ()
  (interactive)
  (let ((cit ""))
    (while (re-search-forward "<VariableName `s?cite-" nil t)
      (setq cit
	    (concat
	     cit
	     "\\citation{"
	     (buffer-substring
	      (point)
	      (progn
		(search-forward "'>" nil t)
		(forward-char -2)
		(point)))
	     "}\n"
	     )))
    cit))

(defun get-reffiles ()
  (interactive)
  (search-forward "<VariableFormats" nil t)
  (if (search-forward "<VariableName `bf-reffiles" nil t)
      (progn
	(re-search-forward "<VariableDef `" nil t)
	(buffer-substring
	 (point)
	 (progn
	   (search-forward "'>" nil t)
	   (forward-char -2)
	   (point))))
    ""))
  
  
(defun miftoaux (style auxfile)
  (let (tmpstr reffiles bibframeref)
    (setq bibframeref (getenv "BIBFRAMEREF"))
    (goto-char (point-min))
    (setq reffiles (get-reffiles))
    (search-forward "# end of VariableFormats" nil t)
    (setq tmpstr (get-citations))
    (find-file auxfile)
    (insert tmpstr)
    (insert
     (concat "\\bibdata{"
	     (if bibframeref
		 (progn
		   (if (equal bibframeref "")
		       reffiles
		     (if (equal reffiles "")
			 bibframeref
		       (concat reffiles "," bibframeref))))
	       reffiles)
	     "}\n"
	     "\\bibstyle{" style "}"))
    (basic-save-buffer)))

;;(defun miftoaux (style auxfile)
;;  (let (tmpstr)
;;    (goto-char (point-min))
;;    (search-forward "# end of VariableFormats" nil t)
;;    (setq tmpstr (get-citations))
;;    (find-file auxfile)
;;    (insert tmpstr)
;;    (insert (concat "\\bibdata{" (getenv "BIBFRAMEREF") "}\n"
;;		    "\\bibstyle{" style "}"))
;;    (basic-save-buffer)))
;;

(defun get-shortcite ()
  (let ((tmplist nil))
    (goto-char (point-min))
    (search-forward "# end of VariableFormats" nil t)
    (while (search-forward "<VariableName `scite-" nil t)
      (setq tmplist (cons
		     (buffer-substring
		      (point)
		      (progn
			(search-forward "'>" nil t)
			(forward-char -2)
			(point)))
		     tmplist)))
    tmplist))

   
(defun create-var-redef (alist sclist style)
  (insert "<MIFFile 2.00> \n<VariableFormats \n")
  (while alist
    (insert (concat
	     " <VariableFormat\n  <VariableName `cite-"
	     (car (car alist))
	     "'>\n  <VariableDef "
	     (if (equal style "mmlmapalike")
		 "`("
	       "`[")
	     (car (cdr (car alist)))
	     (if (equal style "mmlmapalike")
		 ")'"
	       "]'")
	     ">\n >\n"))
    (setq alist (cdr alist)))
  (while sclist
    (insert (concat
	     " <VariableFormat\n  <VariableName `scite-"
	     (car (car sclist))
	     "'>\n  <VariableDef "
	     (cond ((equal style "mmlmapalike") "`(")
		   ((equal style "mmldraft") "`{")
		   (t "`["))
	     (car (cdr (car sclist)))
	     (cond ((equal style "mmlmapalike") ")'")
		   ((equal style "mmldraft") "}'")
		   (t "]'"))
	     ">\n >\n"))
    (setq sclist (cdr sclist)))
  (insert ">"))


(defun bibframe ()
  (interactive)
  (bibf "mmlplain"))

(defun draftbibframe ()
  (interactive)
  (bibf "mmldraft"))

(defun alphabibframe ()
  (interactive)
  (bibf "mmlalpha"))

(defun mapabibframe ()
  (interactive)
  (bibf "mmlmapalike"))


(defun bibf (style)
  (find-file "/tmp/.bibframe.orig.mif")
  (setq bibframe-shortcite (get-shortcite)) 
  (miftoaux style "/tmp/.bibframe.tmp.aux")
  (shell-command (concat bibframe-bibtex-bin "bibtex .bibframe.tmp"))
  (find-file "/tmp/.bibframe.tmp.bbl")
  (fix-char)
  (write-file "/tmp/.bibframe.tmp.mml")
  (find-file "/tmp/.bibframe.tmp.blg")
  (goto-char (point-min))
  (setq bibframe-reflist (get-reflist))
  (cond ((equal style "mmlmapalike")
      (setq bibframe-screflist (get-shortcitereflist bibframe-shortcite)))
	((equal style "mmldraft")
         (setq bibframe-screflist (get-draftscreflist bibframe-shortcite))))
  (find-file "/tmp/.bibframe.tmp.mml")
  (fix-crossref-in-mml style)
  (basic-save-buffer)
  (shell-command (concat
		  bibframe-frame-bin
		  "mmltomif /tmp/.bibframe.tmp.mml > /tmp/.bibframe.mif"))
  (fixfont)
  (find-file "/tmp/.bibframe.new.mif")
  (create-var-redef bibframe-reflist bibframe-screflist style)
  (rep "<Hardspace>" "\\x11 ")
  (rep "<HarDspace>" "\\x11 ")
  (rep "<superscript>" "<Superscript\\>") ;Added: [tompe:19911002.1243]
  (rep "<normal>" "<Default \\xa6  Font\\>") ;Added: [tompe:19911002.1244]
  (basic-save-buffer))
