///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	Bounce.h 
//	SUMMARY:	Interface for Bouncy annotations to eText documents
//	SUPERCLASS:	Object
//	INTERFACE:	None
//	PROTOCOLS:	<DocNotification, Annotation, Tool>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION
//		Glue for Ali Ozer's LinesView code. Demo of <Annotation>
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	02/04/94:	Created. Derived from NextDeveloper/Examples/Appkit/Lines.
///////////////////////////////////////////////////////////////////////////////

#import "LinesView.h"
#import "UserPath.h"
#import "eTextKernel.h"

@interface Bounce:Object <Annotation, Tool, Inspectable>
{
	id		controlPanel;
	id		controlView;
	id		linesView;
	id		heightField;
	id		widthField;
	id		cornerField;
	NXSize	sz;
	int		corners;
	NXImage *icon;
	id		etDoc;
}

-click:sender;
-doubleClick:sender;
@end