///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	HotLinks.h 
//	SUMMARY:	Interface for a link-caching Accessory
//	SUPERCLASS:	Object
//	INTERFACE:	HotLinks.nib
//	PROTOCOLS:	<Tool>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION: The HotLinks panel is an example of a loadable
// Accessory, an independent entity within the eText runtime
// environment. The HotLinks panel allows the user to keep a
// quick-reference list of links handy. The object archives itself
// entire in ~/Library/eText/HotLinks (creates the dir if
// nonexistent). We're being lazy, so we'll just write ourselves
// out everytime we're modified -- ideally there's an <appNotification>
// protocol similar to <docNotification>, and we should only save
// this data out on application-quit.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	11/13/94:	Modified to use a storage for sorted hotlink lists.
//	05/06/94:	Created. First actual implementation.
///////////////////////////////////////////////////////////////////////////////

#import "../eTextKernel.h"

@interface HotLinks:Object <Tool>
{
    id	browser;
    id	field;
    id	panel;
    id	well;
	Storage *anchors;
}

- accept:sender;
- rename:sender;
- select:sender;

@end
