///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTAudioUI.h 
//	SUMMARY:	User Interface for Audio annotations to eText documents
//	SUPERCLASS:	eTAudioUI:eTImageUI:Object
//	INTERFACE:	None
//	PROTOCOLS:	<Inspectable>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION
//		Previous versions of this inspector were not shared; _each_ audio 
//	had its _own_ ui and nibs, etc.
//		This had to do with numerous sound-kit level inconsistencies with
//	timed entires and the like.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	07/24/94:	Rearchitected for PR1/eTImage/<eTAudioNotification>
//	01/24/94:	Created. Derived largely from Version3's temporary Hypertext
//				'93 hack. Renamed as eTAudio and aTAudioUI.
///////////////////////////////////////////////////////////////////////////////

#import "eTAudio.h"

@interface eTAudioUI:eTImageUI
{
    id	audioPanel;
    id	audioView;

    id	etAudio;
    id	nameField;

    id	eraseButton;
    id	pauseButton;
    id	playButton;
    id	recordButton;
    id	stopButton;

    id	soundMeter;
    id	soundView;
}

+ new;
- setAnnotation:newAudio;
- soundView;
- soundMeter;

- editName:sender;
- erase:sender;
- pause:sender;
- play:sender;
- record:sender;
- stop:sender;

- click:sender;
- doubleClick:sender;
@end