///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTFileLink.h 
//	SUMMARY:	Interface for file components in eText documents
//	SUPERCLASS:	eTImage
//	INTERFACE:	None
//	PROTOCOLS:	<Annotation,HTMDSupport,ASCIISupport,LaTeXSupport,Tool,
//				InspectableTarget>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION
//		Does its job by an eTComponent and execString.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	10/30/94:	Modified to support <InspectableTarget>
//	08/06/94:	Added symbolic linking support.
//	07/21/94:	Created. First actual implementation.
///////////////////////////////////////////////////////////////////////////////

#import "../eTextKernel.h"
#import "../eTImage.subproj/eTImage.h"
#import "../eTImage.subproj/eTImageUI.h"
#import "eTFileLinkUI.h"
// we import eTRTFDFileLink.h at the end of this file

@interface eTFileLink:eTImage <Annotation, Tool, ASCIISupport, HTMDSupport, LaTeXSupport>
{	id		etFileComponent;
	char	*execString;
	BOOL	isExecEnabled;
	BOOL	useSymlink;
}

- setSymlink:(BOOL)newState;
- setExecEnabled:(BOOL)newState;
- (BOOL)isExecEnabled;
- (BOOL) useSymlink;
- (const char *)componentName;
- (const char *)execString;
- setExecString:(const char *) newString;
@end
#import "eTRTFDFileLink.h"