///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTImageUI.h
//	SUMMARY:	Inspector for an eTImage annotation (uses eTImageComponent)
//	SUPERCLASS:	Object
//	INTERFACE:	None
//	PROTOCOLS:	<Inspectable>
//	AUTHOR:		Rohit Khare and Tom Zavisca
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION
//		A subclass can cleverly reuse the inspection power of this object to
//	use it as one of the "panes" in its own popup menu.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	11/26/94:	Added pull-down menu, image-from-caption options.
//	07/19/94:	Rewritten from scratch (RK) from remains of ImageAnnotationUI.
///////////////////////////////////////////////////////////////////////////////

#import "eTImage.h"
#import "eTextKernel.h"

@interface eTImageUI:Object <Inspectable>
{
	id		etImage;
	id		controlPanel;
	id		controlView;
	id		componentNameField;
	id		descriptionField;		// this is actually a monofont Text object
	id		linkSwitch;
	id		heightField;
	id		widthField;
}

+ new;
- setAnnotation:neweTImage;

- chooseImage:sender;
- pasteImage:sender;
- captionImage:sender;
- editDescription:sender;
- editComponentName:sender;
- editSize:sender;

- textDidEnd:sender endChar:(unsigned short)whyEnd;
@end