///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTNoteUI.h 
//	SUMMARY:	Interface for inserting RTF Notes into a document
//	SUPERCLASS:	eTNoteUI:eTImageUI:Object
//	INTERFACE:	eTNoteUI.nib
//	PROTOCOLS:	<Inspectable>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//  DESCRIPTION
//		Just a scrollview for the text and fields for owner/date.
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	07/24/94:	Migrated to subclass of eTImageUI
//	05/22/94:	Created. First actual implementation.
///////////////////////////////////////////////////////////////////////////////

#import "eTNote.h"

@interface eTNoteUI:eTImageUI <Inspectable>
{
	id	notePanel;
	id	noteView;
	id	etNote;
	id	repText;
	id	ownerField;
	id	dateField;
	BOOL ownerDirty, textDirty;
}
+ new;
- setNote:newNote;
- load;
- sync;
- resetOwner:sender;
- resetText:sender;
@end
