///////////////////////////////////////////////////////////////////////////////
//	FILENAME:	eTURLink.h 
//	SUMMARY:	Interface for a URL Annotation
//	SUPERCLASS:	eTImage
//	INTERFACE:	None
//	PROTOCOLS:	<Annotation,HTMDSupport,ASCIISupport,LaTeXSupport,Tool,
//				InspectableTarget>
//	AUTHOR:		Rohit Khare
//	COPYRIGHT:	(c) 1994 California Institure of Technology, eText Project
///////////////////////////////////////////////////////////////////////////////
//	DESCRIPTION
//		Holds an URLrep and tries to NXPerformService("Open URL").
///////////////////////////////////////////////////////////////////////////////
//	HISTORY
//	10/30/94:	Modified to support <InspectableTarget>
//  07/20/94:	Minimal Creation
///////////////////////////////////////////////////////////////////////////////

#import "eTextKernel.h"
#import "../eTImage.subproj/eTImage.h"
#import "eTURLinkUI.h"

@interface eTURLink:eTImage <Annotation, Tool, ASCIISupport, HTMDSupport,LaTeXSupport>
{
	char *URLRep;
}

- setURL: (const char *) newURL;
- (char *) URL;
@end