/* mif.h
 * cm, 17 Dec 90
 * 
 * header file for frame bibliography filter.
 */

/*
 * Copyright (c) 1991 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */
#define MIF_BIBMARKERTYPE	 10
#define MIF_BIBXREF		"Bibliographic Reference"
#define MIF_FIRSTBIBXREF	"First Bibliographic Reference"
#define MIF_LASTBIBXREF 	"Last Bibliographic Reference"
#define MIF_NEXTBIBXREF 	"Next Bibliographic Reference"
#define FILEMARK		"INPUT-MIFFILE"
#define BIBMARKER		"BIB"
#define FIRST			"FIRST"
#define NEXT			"NEXT"
#define LAST			"LAST"

#define FMCONTRIBDIR		"/usr/misc/.frame/contrib/misc/fmbib"
#define FMBIBTEMPLATEFILE	"stdnumeric.tmpl"
#define FMBIBSTYLEFILE		"stdnumeric.style"
#define FMDEFAULTBIBLIOGRAPHY	"fmbib.doc"

#define MAX_BIBFILES	30

/* file-types sharing mifread routines. 
 */
#define F_MIF	0 	/* input frame (mif) doc. */
#define F_BIB	1	/* bib. database file */
#define F_REF	2	/* bib. style (reference) file */
#define F_TMP	3	/* input tmp file */

/* file-type sharing mifwrite routines. */
#define O_MIF	0	/* new (mif) doc w/ bib xrefs */
#define O_BIB	1	/* the generated (mif) bibliography */
#define O_TMP	2	/* the mif tmp file */

/* severity levels for error messages */
#define WARN 	0
#define FATAL	1

/* legal change-font commands */
#define F_REGULAR	1
#define F_ITALIC	2	
#define F_BOLD		3	
#define F_UNDERLINE	4	

/* indeces into BibVars[] for Variables
 * declared in mif file 
 */
#define BV_BIBFILES 0
#define BV_BIBFORMAT 1	

/* macros */
#define streq(a, b)	(strcmp((a),(b)) == 0)
#define strneq(a, b, n)	(strncmp((a),(b),(n)) == 0)
#define tokeq(str, c )	(((*str)==c) && (*(str+1)==0))

/* functions */
char *mif_getc();
char *mif_gets();
char *mif_gettok();
char *mif_fname();
char *getmem();
char *fontname();

/* globals */
#ifdef MAIN
#define VAR 
#else
#define VAR extern
#endif

VAR char 	*prog;
VAR unsigned short debug; 	
VAR unsigned short Debug; 	 /* verbose debugging */
VAR unsigned short verbose;	 /* user level verbose messages */
VAR unsigned short verify;	 /* verify integrity of database only */
VAR unsigned short query;	 /* query style info for fmbibverify */
VAR unsigned short contiguous_cites;	/* how to print contiguous citations */
VAR short	bib_markertype;	 /* Bibliograph Marker's MType value */
VAR short 	current_font;	 /* current output font */
VAR char	*fmbibdir;	 /* directory to find dependant data files. */
VAR char	*custom_sort;	/* comma-separated list of fields to sort on */

extern int errno;

