
/*****************************************************************************/
/**       Copyright 1989 by Evans & Sutherland Computer Division            **/
/**                           Mountain View, CA                             **/
/**                                                                         **/
/**                           All Rights Reserved                           **/
/**                                                                         **/
/**    Permission to use, copy, modify, and distribute this software and    **/
/**    its documentation  for  any  purpose  and  without  fee is hereby    **/
/**    granted, provided that the above copyright notice appear  in  all    **/
/**    copies and that both  that  copyright  notice  and  this  permis-    **/
/**    sion  notice appear in supporting  documentation,  and  that  the    **/
/**    name  of Evans & Sutherland  not be used in advertising or publi-    **/
/**    city pertaining to distribution  of the software without  specif-    **/
/**    ic, written prior permission.                                        **/
/**                                                                         **/
/**    EVANS  & SUTHERLAND  DISCLAIMS  ALL  WARRANTIES  WITH  REGARD  TO    **/
/**    THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILI-    **/
/**    TY AND FITNESS, IN NO EVENT SHALL EVANS &  SUTHERLAND  BE  LIABLE    **/
/**    FOR  ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY  DAM-    **/
/**    AGES  WHATSOEVER RESULTING FROM  LOSS OF USE,  DATA  OR  PROFITS,    **/
/**    WHETHER   IN  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS    **/
/**    ACTION, ARISING OUT OF OR IN  CONNECTION  WITH  THE  USE  OR PER-    **/
/**    FORMANCE OF THIS SOFTWARE.                                           **/
/*****************************************************************************/
/* Definitions for tables of text strings to be searched */

/* Data structure for tables of strings. */
/* A table for searching is an array of RECORD's ending */
/* in any entry with a null string and 0 value.		*/

typedef struct  {
        char* name;	/* string */
        int value;	/* corresponding integer value to return */
        } RECORD;


#define NONE -2
#define OTHER -1

/* Table of MIF function names */
/* This is not a complete list.  Only those functions of */
/* interest are in this table.  Others are ignored.      */

#define END 0
#define STRING 1
#define PARA 2
#define FBOLD 3
#define FITALIC 4
#define FPLAIN 5
#define CHAR 6
#define FONT 7
#define CATALOG 8
#define PGF 9
#define PGFTAG 10
#define TABSTOP 11
#define TSX 12
#define TSTYPE 13
#define PGFLINDENT 14
#define PGFFINDENT 15
#define PARALINE 16
#define TEXTLINE 17

RECORD token_table[] = {
        "String", STRING,
	"Para", PARA,
	"FBold", FBOLD,
	"FItalic", FITALIC,
	"FPlain", FPLAIN,
	"Char", CHAR,
	"Font", FONT,
	"Catalog", CATALOG,
	"Pgf", PGF,
	"PgfTag", PGFTAG,
	"TabStop", TABSTOP,
	"TSX", TSX,
	"TSType", TSTYPE,
	"PgfFIndent", PGFFINDENT,
	"PgfLIndent", PGFLINDENT,
	"ParaLine", PARALINE,
	"TextLine", TEXTLINE,
	"", 0
};

/* Table of special characters used in MIF file */
/* Only those of interest are included.         */

#define ENDASH 1
#define TAB 2
#define HARDSPACE 3
#define HARDRETURN 4
#define CHAR210 5
#define CHAR211 6
#define CHAR212 7
#define CHAR213 8

RECORD char_table[] = {
	"EnDash", ENDASH,
	"Tab", TAB,
	"HardSpace", HARDSPACE,
	"HardReturn", HARDRETURN,
	"210", CHAR210,
	"211", CHAR211,
	"212", CHAR212,
	"213", CHAR213,
	"", 0
};

/* Table of arguments for Yes/No functions */

#define YES 1
#define NO 0

RECORD yesno_args[] = {
	"Yes" , YES,
	"No", NO,
	"", 0
};

/* Table of special tags that must be recognized */

#define HEADING 1

RECORD special_tags[] = {
	"heading", HEADING,
	"", 0
};
